/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arith_rewrites_transcendentals(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x1433 = NodeManager::mkBoundVar("x1433", nm->realType());
Node x1434 = NodeManager::mkBoundVar("x1434", nm->realType());
Node x1435 = NodeManager::mkBoundVar("x1435", nm->realType());
Node x1436 = NodeManager::mkBoundVar("x1436", nm->realType());
Node x1437 = NodeManager::mkBoundVar("x1437", nm->realType());

  // Definitions
Node e1438 = nm->mkConst(true);
Node e1439 = nm->mkConstReal(internal::Rational("1/1"));
Node e1440 = nm->mkNullaryOperator(nm->realType(), Kind::PI);
Node e1441 = nm->mkNode(Kind::MULT, { nm->mkConstReal(internal::Rational("1/2")),nm->mkNullaryOperator(nm->realType(), Kind::PI) });
Node e1442 = nm->mkConstReal(internal::Rational("0/1"));

  // Rules

        {
            // from rewrites-arith-rewrites-transcendentals.cpp
            db.addRule(ProofRewriteRule::ARITH_SINE_ZERO, {  }, nm->mkNode(Kind::SINE, { e1442 }), e1442, e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_SINE_PI2, {  }, nm->mkNode(Kind::SINE, { e1441 }), e1439, e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_COSINE_ELIM, { x1433 }, nm->mkNode(Kind::COSINE, { x1433 }), nm->mkNode(Kind::SINE, { nm->mkNode(Kind::SUB, { e1441,x1433 }) }), e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_TANGENT_ELIM, { x1434 }, nm->mkNode(Kind::TANGENT, { x1434 }), nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::SINE, { x1434 }),nm->mkNode(Kind::COSINE, { x1434 }) }), e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_SECENT_ELIM, { x1435 }, nm->mkNode(Kind::SECANT, { x1435 }), nm->mkNode(Kind::DIVISION, { e1439,nm->mkNode(Kind::COSINE, { x1435 }) }), e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_COSECENT_ELIM, { x1436 }, nm->mkNode(Kind::COSECANT, { x1436 }), nm->mkNode(Kind::DIVISION, { e1439,nm->mkNode(Kind::SINE, { x1436 }) }), e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_COTANGENT_ELIM, { x1437 }, nm->mkNode(Kind::COTANGENT, { x1437 }), nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::COSINE, { x1437 }),nm->mkNode(Kind::SINE, { x1437 }) }), e1438, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::ARITH_PI_NOT_INT, {  }, nm->mkNode(Kind::IS_INTEGER, { e1440 }), nm->mkConst(false), e1438, Node::null(), Level::EXPERT);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
