/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arith_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node t1 = NodeManager::mkBoundVar("t1", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t2 = NodeManager::mkBoundVar("t2", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t3 = NodeManager::mkBoundVar("t3", nm->integerType());
Node s4 = NodeManager::mkBoundVar("s4", nm->integerType());
Node t5 = NodeManager::mkBoundVar("t5", nm->integerType());
Node t6 = NodeManager::mkBoundVar("t6", nm->integerType());
Node t7 = NodeManager::mkBoundVar("t7", nm->integerType());
Node s8 = NodeManager::mkBoundVar("s8", nm->integerType());
Node t9 = NodeManager::mkBoundVar("t9", nm->integerType());
Node s10 = NodeManager::mkBoundVar("s10", nm->integerType());
Node t11 = NodeManager::mkBoundVar("t11", nm->integerType());
Node t12 = NodeManager::mkBoundVar("t12", nm->integerType());
Node t13 = NodeManager::mkBoundVar("t13", nm->integerType());
Node s14 = NodeManager::mkBoundVar("s14", nm->integerType());
Node t15 = NodeManager::mkBoundVar("t15", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s16 = NodeManager::mkBoundVar("s16", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t17 = NodeManager::mkBoundVar("t17", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s18 = NodeManager::mkBoundVar("s18", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t19 = NodeManager::mkBoundVar("t19", nm->integerType());
Node s20 = NodeManager::mkBoundVar("s20", nm->integerType());
Node t21 = NodeManager::mkBoundVar("t21", nm->integerType());
Node s22 = NodeManager::mkBoundVar("s22", nm->integerType());
Node t23 = NodeManager::mkBoundVar("t23", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s24 = NodeManager::mkBoundVar("s24", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t25 = NodeManager::mkBoundVar("t25", nm->integerType());
Node s26 = NodeManager::mkBoundVar("s26", nm->integerType());
Node t27 = NodeManager::mkBoundVar("t27", nm->integerType());
Node s28 = NodeManager::mkBoundVar("s28", nm->integerType());
Node t29 = NodeManager::mkBoundVar("t29", nm->integerType());
Node s30 = NodeManager::mkBoundVar("s30", nm->integerType());
Node t31 = NodeManager::mkBoundVar("t31", nm->realType());
Node s32 = NodeManager::mkBoundVar("s32", nm->realType());
Node t33 = NodeManager::mkBoundVar("t33", nm->realType());
Node s34 = NodeManager::mkBoundVar("s34", nm->realType());
Node t35 = NodeManager::mkBoundVar("t35", nm->integerType());
Node s36 = NodeManager::mkBoundVar("s36", nm->integerType());
Node x37 = NodeManager::mkBoundVar("x37", nm->integerType());
Node x38 = NodeManager::mkBoundVar("x38", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x39 = NodeManager::mkBoundVar("x39", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y40 = NodeManager::mkBoundVar("y40", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x41 = NodeManager::mkBoundVar("x41", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y42 = NodeManager::mkBoundVar("y42", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c43 = NodeManager::mkBoundVar("c43", nm->integerType());
Node ts44 = NodeManager::mkBoundVar("ts44", nm->integerType());expr::markListVar(ts44);
Node r45 = NodeManager::mkBoundVar("r45", nm->integerType());
Node ss46 = NodeManager::mkBoundVar("ss46", nm->integerType());expr::markListVar(ss46);
Node t47 = NodeManager::mkBoundVar("t47", nm->integerType());
Node c48 = NodeManager::mkBoundVar("c48", nm->realType());
Node t49 = NodeManager::mkBoundVar("t49", nm->integerType());
Node c50 = NodeManager::mkBoundVar("c50", nm->realType());
Node cc51 = NodeManager::mkBoundVar("cc51", nm->integerType());
Node n52 = NodeManager::mkBoundVar("n52", nm->integerType());
Node t53 = NodeManager::mkBoundVar("t53", nm->integerType());
Node x54 = NodeManager::mkBoundVar("x54", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y55 = NodeManager::mkBoundVar("y55", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x56 = NodeManager::mkBoundVar("x56", nm->integerType());
Node y57 = NodeManager::mkBoundVar("y57", nm->integerType());
Node x58 = NodeManager::mkBoundVar("x58", nm->realType());
Node y59 = NodeManager::mkBoundVar("y59", nm->realType());
Node C60 = NodeManager::mkBoundVar("C60", nm->booleanType());
Node t61 = NodeManager::mkBoundVar("t61", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s62 = NodeManager::mkBoundVar("s62", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r63 = NodeManager::mkBoundVar("r63", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node C64 = NodeManager::mkBoundVar("C64", nm->booleanType());
Node t65 = NodeManager::mkBoundVar("t65", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s66 = NodeManager::mkBoundVar("s66", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r67 = NodeManager::mkBoundVar("r67", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t68 = NodeManager::mkBoundVar("t68", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s69 = NodeManager::mkBoundVar("s69", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t70 = NodeManager::mkBoundVar("t70", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s71 = NodeManager::mkBoundVar("s71", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t72 = NodeManager::mkBoundVar("t72", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s73 = NodeManager::mkBoundVar("s73", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t74 = NodeManager::mkBoundVar("t74", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s75 = NodeManager::mkBoundVar("s75", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e76 = nm->mkConst(true);
Node e77 = nm->mkNode(Kind::NEG, { x58 });
Node e78 = nm->mkNode(Kind::NEG, { y59 });
Node e79 = nm->mkNode(Kind::GEQ, { y59,nm->mkConstReal(internal::Rational("0/1")) });
Node e80 = nm->mkConstReal(internal::Rational("0/1"));
Node e81 = nm->mkNode(Kind::NEG, { x56 });
Node e82 = nm->mkNode(Kind::NEG, { y57 });
Node e83 = nm->mkNode(Kind::GEQ, { y57,nm->mkConstInt(Rational(0)) });
Node e84 = nm->mkConstInt(Rational(0));
Node e85 = nm->mkNode(Kind::TO_INTEGER, { c50 });
Node e86 = nm->mkConstInt(Rational(1));

  // Rules

        {
            // from rewrites-arith-rewrites.cpp
            db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_ZERO_REAL, { t1 }, nm->mkNode(Kind::DIVISION_TOTAL, { t1,e80 }), e80, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_DIV_TOTAL_ZERO_INT, { t2 }, nm->mkNode(Kind::DIVISION_TOTAL, { t2,e84 }), e80, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL, { t3, s4 }, nm->mkNode(Kind::INTS_DIVISION, { t3,s4 }), nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t3,s4 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s4,e84 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ONE, { t5 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t5,e86 }), t5, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_ZERO, { t6 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t6,e84 }), e84, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_DIV_TOTAL_NEG, { t7, s8 }, nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t7,s8 }), nm->mkNode(Kind::NEG, { nm->mkNode(Kind::INTS_DIVISION_TOTAL, { t7,nm->mkNode(Kind::NEG, { s8 }) }) }), nm->mkNode(Kind::LT, { s8,e84 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL, { t9, s10 }, nm->mkNode(Kind::INTS_MODULUS, { t9,s10 }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t9,s10 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s10,e84 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ONE, { t11 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t11,e86 }), e84, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_ZERO, { t12 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t12,e84 }), t12, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_MOD_TOTAL_NEG, { t13, s14 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t13,s14 }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t13,nm->mkNode(Kind::NEG, { s14 }) }), nm->mkNode(Kind::LT, { s14,e84 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ELIM_GT, { t15, s16 }, nm->mkNode(Kind::GT, { t15,s16 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { s16,t15 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ELIM_LT, { t17, s18 }, nm->mkNode(Kind::LT, { t17,s18 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t17,s18 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_GT, { t19, s20 }, nm->mkNode(Kind::GT, { t19,s20 }), nm->mkNode(Kind::GEQ, { t19,nm->mkNode(Kind::ADD, { s20,e86 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ELIM_INT_LT, { t21, s22 }, nm->mkNode(Kind::LT, { t21,s22 }), nm->mkNode(Kind::GEQ, { s22,nm->mkNode(Kind::ADD, { t21,e86 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ELIM_LEQ, { t23, s24 }, nm->mkNode(Kind::LEQ, { t23,s24 }), nm->mkNode(Kind::GEQ, { s24,t23 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_LEQ_NORM, { t25, s26 }, nm->mkNode(Kind::LEQ, { t25,s26 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t25,nm->mkNode(Kind::ADD, { s26,e86 }) }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_GEQ_TIGHTEN, { t27, s28 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::GEQ, { t27,s28 }) }), nm->mkNode(Kind::GEQ, { s28,nm->mkNode(Kind::ADD, { t27,e86 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM1_INT, { t29, s30 }, nm->mkNode(Kind::GEQ, { t29,s30 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { t29,s30 }),e84 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_GEQ_NORM1_REAL, { t31, s32 }, nm->mkNode(Kind::GEQ, { t31,s32 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { t31,s32 }),e80 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_EQ_ELIM_REAL, { t33, s34 }, nm->mkNode(Kind::EQUAL, { t33,s34 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t33,s34 }),nm->mkNode(Kind::LEQ, { t33,s34 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_EQ_ELIM_INT, { t35, s36 }, nm->mkNode(Kind::EQUAL, { t35,s36 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { t35,s36 }),nm->mkNode(Kind::LEQ, { t35,s36 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_TO_INT_ELIM, { x37 }, nm->mkNode(Kind::TO_INTEGER, { x37 }), x37, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_TO_INT_ELIM_TO_REAL, { x38 }, nm->mkNode(Kind::TO_INTEGER, { nm->mkNode(Kind::TO_REAL, { x38 }) }), nm->mkNode(Kind::TO_INTEGER, { x38 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL1, { x39, y40 }, nm->mkNode(Kind::DIVISION, { nm->mkNode(Kind::TO_REAL, { x39 }),y40 }), nm->mkNode(Kind::DIVISION, { x39,y40 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_DIV_ELIM_TO_REAL2, { x41, y42 }, nm->mkNode(Kind::DIVISION, { x41,nm->mkNode(Kind::TO_REAL, { y42 }) }), nm->mkNode(Kind::DIVISION, { x41,y42 }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_MOD_OVER_MOD, { c43, ts44, r45, ss46 }, nm->mkNode(Kind::INTS_MODULUS_TOTAL, { nm->mkNode(Kind::ADD, { ts44,nm->mkNode(Kind::INTS_MODULUS_TOTAL, { r45,c43 }),ss46 }),c43 }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { nm->mkNode(Kind::ADD, { ts44,r45,ss46 }),c43 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { c43,e84 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_EQ_CONFLICT, { t47, c48 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::TO_REAL, { t47 }),c48 }), nm->mkConst(false), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::TO_REAL, { nm->mkNode(Kind::TO_INTEGER, { c48 }) }),c48 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_INT_GEQ_TIGHTEN, { t49, c50, cc51 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::TO_REAL, { t49 }),c50 }), nm->mkNode(Kind::GEQ, { t49,cc51 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::TO_REAL, { e85 }),c50 }) }),nm->mkNode(Kind::EQUAL, { cc51,nm->mkNode(Kind::ADD, { e85,e86 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_DIVISIBLE_ELIM, { n52, t53 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::DIVISIBLE)),n52,t53 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t53,n52 }),e84 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { n52,e84 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ABS_EQ, { x54, y55 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ABS, { x54 }),nm->mkNode(Kind::ABS, { y55 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { x54,y55 }),nm->mkNode(Kind::EQUAL, { x54,nm->mkNode(Kind::NEG, { y55 }) }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ABS_INT_GT, { x56, y57 }, nm->mkNode(Kind::GT, { nm->mkNode(Kind::ABS, { x56 }),nm->mkNode(Kind::ABS, { y57 }) }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { x56,e84 }),nm->mkNode(Kind::ITE, { e83,nm->mkNode(Kind::GT, { x56,y57 }),nm->mkNode(Kind::GT, { x56,e82 }) }),nm->mkNode(Kind::ITE, { e83,nm->mkNode(Kind::GT, { e81,y57 }),nm->mkNode(Kind::GT, { e81,e82 }) }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_ABS_REAL_GT, { x58, y59 }, nm->mkNode(Kind::GT, { nm->mkNode(Kind::ABS, { x58 }),nm->mkNode(Kind::ABS, { y59 }) }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { x58,e80 }),nm->mkNode(Kind::ITE, { e79,nm->mkNode(Kind::GT, { x58,y59 }),nm->mkNode(Kind::GT, { x58,e78 }) }),nm->mkNode(Kind::ITE, { e79,nm->mkNode(Kind::GT, { e77,y59 }),nm->mkNode(Kind::GT, { e77,e78 }) }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_GEQ_ITE_LIFT, { C60, t61, s62, r63 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ITE, { C60,t61,s62 }),r63 }), nm->mkNode(Kind::ITE, { C60,nm->mkNode(Kind::GEQ, { t61,r63 }),nm->mkNode(Kind::GEQ, { s62,r63 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_LEQ_ITE_LIFT, { C64, t65, s66, r67 }, nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::ITE, { C64,t65,s66 }),r67 }), nm->mkNode(Kind::ITE, { C64,nm->mkNode(Kind::LEQ, { t65,r67 }),nm->mkNode(Kind::LEQ, { s66,r67 }) }), e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_MIN_LT1, { t68, s69 }, nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { t68,s69 }),t68,s69 }),t68 }), e76, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_MIN_LT2, { t70, s71 }, nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { t70,s71 }),t70,s71 }),s71 }), e76, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_MAX_GEQ1, { t72, s73 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { t72,s73 }),t72,s73 }),t72 }), e76, e76, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARITH_MAX_GEQ2, { t74, s75 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { t74,s75 }),t74,s75 }),s75 }), e76, e76, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
