/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arrays_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node t87 = NodeManager::mkBoundVar("t87", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i88 = NodeManager::mkBoundVar("i88", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e89 = NodeManager::mkBoundVar("e89", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t90 = NodeManager::mkBoundVar("t90", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i91 = NodeManager::mkBoundVar("i91", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j92 = NodeManager::mkBoundVar("j92", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e93 = NodeManager::mkBoundVar("e93", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t94 = NodeManager::mkBoundVar("t94", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i95 = NodeManager::mkBoundVar("i95", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e96 = NodeManager::mkBoundVar("e96", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node f97 = NodeManager::mkBoundVar("f97", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t98 = NodeManager::mkBoundVar("t98", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i99 = NodeManager::mkBoundVar("i99", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t100 = NodeManager::mkBoundVar("t100", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i101 = NodeManager::mkBoundVar("i101", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e102 = NodeManager::mkBoundVar("e102", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j103 = NodeManager::mkBoundVar("j103", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t109 = NodeManager::mkBoundVar("t109", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t104 = NodeManager::mkBoundVar("t104", nm->mkAbstractType(Kind::ARRAY_TYPE));
Node i105 = NodeManager::mkBoundVar("i105", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node j106 = NodeManager::mkBoundVar("j106", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node e107 = NodeManager::mkBoundVar("e107", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node f108 = NodeManager::mkBoundVar("f108", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e110 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-arrays-rewrites.cpp
            db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE, { t87, i88, e89 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t87,i88,e89 }),i88 }), e89, e110, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE2, { t90, i91, j92, e93 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t90,i91,e93 }),j92 }), nm->mkNode(Kind::SELECT, { t90,j92 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { i91,j92 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARRAY_STORE_OVERWRITE, { t94, i95, e96, f97 }, nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t94,i95,e96 }),i95,f97 }), nm->mkNode(Kind::STORE, { t94,i95,f97 }), e110, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARRAY_STORE_SELF, { t98, i99 }, nm->mkNode(Kind::STORE, { t98,i99,nm->mkNode(Kind::SELECT, { t98,i99 }) }), t98, e110, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ARRAY_READ_OVER_WRITE_SPLIT, { t100, i101, e102, j103 }, nm->mkNode(Kind::SELECT, { nm->mkNode(Kind::STORE, { t100,j103,e102 }),i101 }), nm->mkNode(Kind::SELECT, { t100,i101 }), e110, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t109 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { i101,j103 }),e102,t109 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::ARRAY_STORE_SWAP, { t104, i105, j106, e107, f108 }, nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t104,i105,e107 }),j106,f108 }), nm->mkNode(Kind::STORE, { nm->mkNode(Kind::STORE, { t104,j106,f108 }),i105,e107 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { i105,j106 }) }), Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
