/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_booleans_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node t111 = NodeManager::mkBoundVar("t111", nm->booleanType());
Node t112 = NodeManager::mkBoundVar("t112", nm->booleanType());
Node t113 = NodeManager::mkBoundVar("t113", nm->booleanType());
Node t114 = NodeManager::mkBoundVar("t114", nm->booleanType());
Node t115 = NodeManager::mkBoundVar("t115", nm->booleanType());
Node x116 = NodeManager::mkBoundVar("x116", nm->booleanType());
Node t117 = NodeManager::mkBoundVar("t117", nm->booleanType());
Node t118 = NodeManager::mkBoundVar("t118", nm->booleanType());
Node t119 = NodeManager::mkBoundVar("t119", nm->booleanType());
Node t120 = NodeManager::mkBoundVar("t120", nm->booleanType());
Node t121 = NodeManager::mkBoundVar("t121", nm->booleanType());
Node s122 = NodeManager::mkBoundVar("s122", nm->booleanType());
Node t123 = NodeManager::mkBoundVar("t123", nm->booleanType());
Node s124 = NodeManager::mkBoundVar("s124", nm->booleanType());
Node xs125 = NodeManager::mkBoundVar("xs125", nm->booleanType());expr::markListVar(xs125);
Node w126 = NodeManager::mkBoundVar("w126", nm->booleanType());
Node ys127 = NodeManager::mkBoundVar("ys127", nm->booleanType());expr::markListVar(ys127);
Node zs128 = NodeManager::mkBoundVar("zs128", nm->booleanType());expr::markListVar(zs128);
Node xs129 = NodeManager::mkBoundVar("xs129", nm->booleanType());expr::markListVar(xs129);
Node w130 = NodeManager::mkBoundVar("w130", nm->booleanType());
Node ys131 = NodeManager::mkBoundVar("ys131", nm->booleanType());expr::markListVar(ys131);
Node zs132 = NodeManager::mkBoundVar("zs132", nm->booleanType());expr::markListVar(zs132);
Node xs133 = NodeManager::mkBoundVar("xs133", nm->booleanType());expr::markListVar(xs133);
Node w134 = NodeManager::mkBoundVar("w134", nm->booleanType());
Node ys135 = NodeManager::mkBoundVar("ys135", nm->booleanType());expr::markListVar(ys135);
Node zs136 = NodeManager::mkBoundVar("zs136", nm->booleanType());expr::markListVar(zs136);
Node xs137 = NodeManager::mkBoundVar("xs137", nm->booleanType());expr::markListVar(xs137);
Node w138 = NodeManager::mkBoundVar("w138", nm->booleanType());
Node ys139 = NodeManager::mkBoundVar("ys139", nm->booleanType());expr::markListVar(ys139);
Node zs140 = NodeManager::mkBoundVar("zs140", nm->booleanType());expr::markListVar(zs140);
Node x141 = NodeManager::mkBoundVar("x141", nm->booleanType());
Node y142 = NodeManager::mkBoundVar("y142", nm->booleanType());
Node zs143 = NodeManager::mkBoundVar("zs143", nm->booleanType());expr::markListVar(zs143);
Node t197 = NodeManager::mkBoundVar("t197", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x144 = NodeManager::mkBoundVar("x144", nm->booleanType());
Node y145 = NodeManager::mkBoundVar("y145", nm->booleanType());
Node x146 = NodeManager::mkBoundVar("x146", nm->booleanType());
Node y147 = NodeManager::mkBoundVar("y147", nm->booleanType());
Node zs148 = NodeManager::mkBoundVar("zs148", nm->booleanType());expr::markListVar(zs148);
Node t198 = NodeManager::mkBoundVar("t198", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y1149 = NodeManager::mkBoundVar("y1149", nm->booleanType());
Node y2150 = NodeManager::mkBoundVar("y2150", nm->booleanType());
Node ys151 = NodeManager::mkBoundVar("ys151", nm->booleanType());expr::markListVar(ys151);
Node z1152 = NodeManager::mkBoundVar("z1152", nm->booleanType());
Node zs153 = NodeManager::mkBoundVar("zs153", nm->booleanType());expr::markListVar(zs153);
Node t199 = NodeManager::mkBoundVar("t199", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y1154 = NodeManager::mkBoundVar("y1154", nm->booleanType());
Node y2155 = NodeManager::mkBoundVar("y2155", nm->booleanType());
Node ys156 = NodeManager::mkBoundVar("ys156", nm->booleanType());expr::markListVar(ys156);
Node z157 = NodeManager::mkBoundVar("z157", nm->booleanType());
Node t200 = NodeManager::mkBoundVar("t200", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x158 = NodeManager::mkBoundVar("x158", nm->booleanType());
Node x159 = NodeManager::mkBoundVar("x159", nm->booleanType());
Node x160 = NodeManager::mkBoundVar("x160", nm->booleanType());
Node x161 = NodeManager::mkBoundVar("x161", nm->booleanType());
Node x162 = NodeManager::mkBoundVar("x162", nm->booleanType());
Node y163 = NodeManager::mkBoundVar("y163", nm->booleanType());
Node x164 = NodeManager::mkBoundVar("x164", nm->booleanType());
Node y165 = NodeManager::mkBoundVar("y165", nm->booleanType());
Node x166 = NodeManager::mkBoundVar("x166", nm->booleanType());
Node y167 = NodeManager::mkBoundVar("y167", nm->booleanType());
Node x168 = NodeManager::mkBoundVar("x168", nm->booleanType());
Node y169 = NodeManager::mkBoundVar("y169", nm->booleanType());
Node x170 = NodeManager::mkBoundVar("x170", nm->booleanType());
Node y171 = NodeManager::mkBoundVar("y171", nm->booleanType());
Node c172 = NodeManager::mkBoundVar("c172", nm->booleanType());
Node x173 = NodeManager::mkBoundVar("x173", nm->booleanType());
Node y174 = NodeManager::mkBoundVar("y174", nm->booleanType());
Node c175 = NodeManager::mkBoundVar("c175", nm->booleanType());
Node x176 = NodeManager::mkBoundVar("x176", nm->booleanType());
Node c177 = NodeManager::mkBoundVar("c177", nm->booleanType());
Node x178 = NodeManager::mkBoundVar("x178", nm->booleanType());
Node c179 = NodeManager::mkBoundVar("c179", nm->booleanType());
Node x180 = NodeManager::mkBoundVar("x180", nm->booleanType());
Node c181 = NodeManager::mkBoundVar("c181", nm->booleanType());
Node x182 = NodeManager::mkBoundVar("x182", nm->booleanType());
Node c183 = NodeManager::mkBoundVar("c183", nm->booleanType());
Node x184 = NodeManager::mkBoundVar("x184", nm->booleanType());
Node c185 = NodeManager::mkBoundVar("c185", nm->booleanType());
Node x186 = NodeManager::mkBoundVar("x186", nm->booleanType());
Node c187 = NodeManager::mkBoundVar("c187", nm->booleanType());
Node x188 = NodeManager::mkBoundVar("x188", nm->booleanType());
Node c189 = NodeManager::mkBoundVar("c189", nm->booleanType());
Node x190 = NodeManager::mkBoundVar("x190", nm->booleanType());
Node c191 = NodeManager::mkBoundVar("c191", nm->booleanType());
Node x192 = NodeManager::mkBoundVar("x192", nm->booleanType());
Node y193 = NodeManager::mkBoundVar("y193", nm->booleanType());
Node c194 = NodeManager::mkBoundVar("c194", nm->booleanType());
Node x195 = NodeManager::mkBoundVar("x195", nm->booleanType());
Node y196 = NodeManager::mkBoundVar("y196", nm->booleanType());

  // Definitions
Node e201 = nm->mkConst(true);
Node e202 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-booleans-rewrites.cpp
            db.addRule(ProofRewriteRule::BOOL_DOUBLE_NOT_ELIM, { t111 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::NOT, { t111 }) }), t111, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_TRUE, { t112 }, nm->mkNode(Kind::NOT, { t112 }), e201, nm->mkNode(Kind::EQUAL, { t112,e202 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_FALSE, { t113 }, nm->mkNode(Kind::NOT, { t113 }), e202, nm->mkNode(Kind::EQUAL, { t113,e201 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_EQ_TRUE, { t114 }, nm->mkNode(Kind::EQUAL, { t114,e201 }), t114, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_EQ_FALSE, { t115 }, nm->mkNode(Kind::EQUAL, { t115,e202 }), nm->mkNode(Kind::NOT, { t115 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_EQ_NREFL, { x116 }, nm->mkNode(Kind::EQUAL, { x116,nm->mkNode(Kind::NOT, { x116 }) }), e202, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE1, { t117 }, nm->mkNode(Kind::IMPLIES, { t117,e202 }), nm->mkNode(Kind::NOT, { t117 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPL_FALSE2, { t118 }, nm->mkNode(Kind::IMPLIES, { e202,t118 }), e201, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE1, { t119 }, nm->mkNode(Kind::IMPLIES, { t119,e201 }), e201, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPL_TRUE2, { t120 }, nm->mkNode(Kind::IMPLIES, { e201,t120 }), t120, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPL_ELIM, { t121, s122 }, nm->mkNode(Kind::IMPLIES, { t121,s122 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { t121 }),s122 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_DUAL_IMPL_EQ, { t123, s124 }, nm->mkNode(Kind::AND, { nm->mkNode(Kind::IMPLIES, { t123,s124 }),nm->mkNode(Kind::IMPLIES, { s124,t123 }) }), nm->mkNode(Kind::EQUAL, { t123,s124 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_AND_CONF, { xs125, w126, ys127, zs128 }, nm->mkNode(Kind::AND, { xs125,w126,ys127,nm->mkNode(Kind::NOT, { w126 }),zs128 }), e202, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_AND_CONF2, { xs129, w130, ys131, zs132 }, nm->mkNode(Kind::AND, { xs129,nm->mkNode(Kind::NOT, { w130 }),ys131,w130,zs132 }), e202, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_OR_TAUT, { xs133, w134, ys135, zs136 }, nm->mkNode(Kind::OR, { xs133,w134,ys135,nm->mkNode(Kind::NOT, { w134 }),zs136 }), e201, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_OR_TAUT2, { xs137, w138, ys139, zs140 }, nm->mkNode(Kind::OR, { xs137,nm->mkNode(Kind::NOT, { w138 }),ys139,w138,zs140 }), e201, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_OR_DE_MORGAN, { x141, y142, zs143 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { x141,y142,zs143 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::OR, { y142,zs143 }) }), e201, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t197 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { x141 }),t197 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPLIES_DE_MORGAN, { x144, y145 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::IMPLIES, { x144,y145 }) }), nm->mkNode(Kind::AND, { x144,nm->mkNode(Kind::NOT, { y145 }) }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_AND_DE_MORGAN, { x146, y147, zs148 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { x146,y147,zs148 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::AND, { y147,zs148 }) }), e201, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t198 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { x146 }),t198 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_OR_AND_DISTRIB, { y1149, y2150, ys151, z1152, zs153 }, nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { y1149,y2150,ys151 }),z1152,zs153 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { y2150,ys151 }),z1152,zs153 }), e201, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t199 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { y1149,z1152,zs153 }),t199 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_IMPLIES_OR_DISTRIB, { y1154, y2155, ys156, z157 }, nm->mkNode(Kind::IMPLIES, { nm->mkNode(Kind::OR, { y1154,y2155,ys156 }),z157 }), nm->mkNode(Kind::IMPLIES, { nm->mkNode(Kind::OR, { y2155,ys156 }),z157 }), e201, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t200 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::IMPLIES, { y1154,z157 }),t200 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_REFL, { x158 }, nm->mkNode(Kind::XOR, { x158,x158 }), e202, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_NREFL, { x159 }, nm->mkNode(Kind::XOR, { x159,nm->mkNode(Kind::NOT, { x159 }) }), e201, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_FALSE, { x160 }, nm->mkNode(Kind::XOR, { x160,e202 }), x160, e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_TRUE, { x161 }, nm->mkNode(Kind::XOR, { x161,e201 }), nm->mkNode(Kind::NOT, { x161 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_COMM, { x162, y163 }, nm->mkNode(Kind::XOR, { x162,y163 }), nm->mkNode(Kind::XOR, { y163,x162 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_XOR_ELIM, { x164, y165 }, nm->mkNode(Kind::XOR, { x164,y165 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x164 }),y165 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_XOR_ELIM, { x166, y167 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::XOR, { x166,y167 }) }), nm->mkNode(Kind::EQUAL, { x166,y167 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_EQ_ELIM1, { x168, y169 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x168,y169 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { x168 }),y169 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_EQ_ELIM2, { x170, y171 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x170,y171 }) }), nm->mkNode(Kind::EQUAL, { x170,nm->mkNode(Kind::NOT, { y171 }) }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_NEG_BRANCH, { c172, x173, y174 }, nm->mkNode(Kind::ITE, { c172,x173,y174 }), nm->mkNode(Kind::EQUAL, { c172,x173 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::NOT, { y174 }),x173 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_TRUE, { c175, x176 }, nm->mkNode(Kind::ITE, { c175,e201,x176 }), nm->mkNode(Kind::OR, { c175,x176 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_FALSE, { c177, x178 }, nm->mkNode(Kind::ITE, { c177,x178,e202 }), nm->mkNode(Kind::AND, { c177,x178 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_FALSE, { c179, x180 }, nm->mkNode(Kind::ITE, { c179,e202,x180 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { c179 }),x180 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_TRUE, { c181, x182 }, nm->mkNode(Kind::ITE, { c181,x182,e201 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { c181 }),x182 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD_SELF, { c183, x184 }, nm->mkNode(Kind::ITE, { c183,c183,x184 }), nm->mkNode(Kind::ITE, { c183,e201,x184 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD_SELF, { c185, x186 }, nm->mkNode(Kind::ITE, { c185,x186,c185 }), nm->mkNode(Kind::ITE, { c185,x186,e202 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD_NOT_SELF, { c187, x188 }, nm->mkNode(Kind::ITE, { c187,nm->mkNode(Kind::NOT, { c187 }),x188 }), nm->mkNode(Kind::ITE, { c187,e202,x188 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD_NOT_SELF, { c189, x190 }, nm->mkNode(Kind::ITE, { c189,x190,nm->mkNode(Kind::NOT, { c189 }) }), nm->mkNode(Kind::ITE, { c189,x190,e201 }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_EXPAND, { c191, x192, y193 }, nm->mkNode(Kind::ITE, { c191,x192,y193 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::NOT, { c191 }),x192 }),nm->mkNode(Kind::OR, { c191,y193 }) }), e201, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BOOL_NOT_ITE_ELIM, { c194, x195, y196 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::ITE, { c194,x195,y196 }) }), nm->mkNode(Kind::ITE, { c194,nm->mkNode(Kind::NOT, { x195 }),nm->mkNode(Kind::NOT, { y196 }) }), e201, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
