/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_builtin_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x203 = NodeManager::mkBoundVar("x203", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y204 = NodeManager::mkBoundVar("y204", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x205 = NodeManager::mkBoundVar("x205", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y206 = NodeManager::mkBoundVar("y206", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c207 = NodeManager::mkBoundVar("c207", nm->booleanType());
Node x208 = NodeManager::mkBoundVar("x208", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y209 = NodeManager::mkBoundVar("y209", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c210 = NodeManager::mkBoundVar("c210", nm->booleanType());
Node x211 = NodeManager::mkBoundVar("x211", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c212 = NodeManager::mkBoundVar("c212", nm->booleanType());
Node x213 = NodeManager::mkBoundVar("x213", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y214 = NodeManager::mkBoundVar("y214", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z215 = NodeManager::mkBoundVar("z215", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c216 = NodeManager::mkBoundVar("c216", nm->booleanType());
Node x217 = NodeManager::mkBoundVar("x217", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y218 = NodeManager::mkBoundVar("y218", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z219 = NodeManager::mkBoundVar("z219", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c220 = NodeManager::mkBoundVar("c220", nm->booleanType());
Node x221 = NodeManager::mkBoundVar("x221", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y222 = NodeManager::mkBoundVar("y222", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z223 = NodeManager::mkBoundVar("z223", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node c224 = NodeManager::mkBoundVar("c224", nm->booleanType());
Node x225 = NodeManager::mkBoundVar("x225", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y226 = NodeManager::mkBoundVar("y226", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node z227 = NodeManager::mkBoundVar("z227", nm->mkAbstractType(Kind::ABSTRACT_TYPE));

  // Definitions
Node e228 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-builtin-rewrites.cpp
            db.addRule(ProofRewriteRule::ITE_TRUE_COND, { x203, y204 }, nm->mkNode(Kind::ITE, { e228,x203,y204 }), x203, e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_FALSE_COND, { x205, y206 }, nm->mkNode(Kind::ITE, { nm->mkConst(false),x205,y206 }), y206, e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_NOT_COND, { c207, x208, y209 }, nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c207 }),x208,y209 }), nm->mkNode(Kind::ITE, { c207,y209,x208 }), e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_EQ_BRANCH, { c210, x211 }, nm->mkNode(Kind::ITE, { c210,x211,x211 }), x211, e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_LOOKAHEAD, { c212, x213, y214, z215 }, nm->mkNode(Kind::ITE, { c212,nm->mkNode(Kind::ITE, { c212,x213,y214 }),z215 }), nm->mkNode(Kind::ITE, { c212,x213,z215 }), e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_LOOKAHEAD, { c216, x217, y218, z219 }, nm->mkNode(Kind::ITE, { c216,x217,nm->mkNode(Kind::ITE, { c216,y218,z219 }) }), nm->mkNode(Kind::ITE, { c216,x217,z219 }), e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_THEN_NEG_LOOKAHEAD, { c220, x221, y222, z223 }, nm->mkNode(Kind::ITE, { c220,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c220 }),x221,y222 }),z223 }), nm->mkNode(Kind::ITE, { c220,y222,z223 }), e228, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::ITE_ELSE_NEG_LOOKAHEAD, { c224, x225, y226, z227 }, nm->mkNode(Kind::ITE, { c224,x225,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::NOT, { c224 }),y226,z227 }) }), nm->mkNode(Kind::ITE, { c224,x225,y226 }), e228, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
