/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_elimination(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x404 = NodeManager::mkBoundVar("x404", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y405 = NodeManager::mkBoundVar("y405", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x406 = NodeManager::mkBoundVar("x406", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y407 = NodeManager::mkBoundVar("y407", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x408 = NodeManager::mkBoundVar("x408", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y409 = NodeManager::mkBoundVar("y409", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x410 = NodeManager::mkBoundVar("x410", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y411 = NodeManager::mkBoundVar("y411", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x412 = NodeManager::mkBoundVar("x412", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y413 = NodeManager::mkBoundVar("y413", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x414 = NodeManager::mkBoundVar("x414", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w415 = NodeManager::mkBoundVar("w415", nm->integerType());
Node x416 = NodeManager::mkBoundVar("x416", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w417 = NodeManager::mkBoundVar("w417", nm->integerType());
Node x418 = NodeManager::mkBoundVar("x418", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y419 = NodeManager::mkBoundVar("y419", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x420 = NodeManager::mkBoundVar("x420", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y421 = NodeManager::mkBoundVar("y421", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x422 = NodeManager::mkBoundVar("x422", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount423 = NodeManager::mkBoundVar("amount423", nm->integerType());
Node u1424 = NodeManager::mkBoundVar("u1424", nm->integerType());
Node u2425 = NodeManager::mkBoundVar("u2425", nm->integerType());
Node l2426 = NodeManager::mkBoundVar("l2426", nm->integerType());
Node x427 = NodeManager::mkBoundVar("x427", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount428 = NodeManager::mkBoundVar("amount428", nm->integerType());
Node x429 = NodeManager::mkBoundVar("x429", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount430 = NodeManager::mkBoundVar("amount430", nm->integerType());
Node u1431 = NodeManager::mkBoundVar("u1431", nm->integerType());
Node u2432 = NodeManager::mkBoundVar("u2432", nm->integerType());
Node l2433 = NodeManager::mkBoundVar("l2433", nm->integerType());
Node x434 = NodeManager::mkBoundVar("x434", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount435 = NodeManager::mkBoundVar("amount435", nm->integerType());
Node x436 = NodeManager::mkBoundVar("x436", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y437 = NodeManager::mkBoundVar("y437", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x438 = NodeManager::mkBoundVar("x438", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y439 = NodeManager::mkBoundVar("y439", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x440 = NodeManager::mkBoundVar("x440", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y441 = NodeManager::mkBoundVar("y441", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x442 = NodeManager::mkBoundVar("x442", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y443 = NodeManager::mkBoundVar("y443", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1444 = NodeManager::mkBoundVar("nm1444", nm->integerType());
Node x445 = NodeManager::mkBoundVar("x445", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n446 = NodeManager::mkBoundVar("n446", nm->integerType());
Node x447 = NodeManager::mkBoundVar("x447", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y448 = NodeManager::mkBoundVar("y448", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w449 = NodeManager::mkBoundVar("w449", nm->integerType());
Node x450 = NodeManager::mkBoundVar("x450", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y451 = NodeManager::mkBoundVar("y451", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node wm1452 = NodeManager::mkBoundVar("wm1452", nm->integerType());
Node x453 = NodeManager::mkBoundVar("x453", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y454 = NodeManager::mkBoundVar("y454", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w455 = NodeManager::mkBoundVar("w455", nm->integerType());
Node wm1456 = NodeManager::mkBoundVar("wm1456", nm->integerType());
Node x457 = NodeManager::mkBoundVar("x457", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y458 = NodeManager::mkBoundVar("y458", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w459 = NodeManager::mkBoundVar("w459", nm->integerType());
Node wm1460 = NodeManager::mkBoundVar("wm1460", nm->integerType());
Node x461 = NodeManager::mkBoundVar("x461", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y462 = NodeManager::mkBoundVar("y462", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1463 = NodeManager::mkBoundVar("nm1463", nm->integerType());
Node x464 = NodeManager::mkBoundVar("x464", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y465 = NodeManager::mkBoundVar("y465", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n466 = NodeManager::mkBoundVar("n466", nm->integerType());
Node x467 = NodeManager::mkBoundVar("x467", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y468 = NodeManager::mkBoundVar("y468", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nm1469 = NodeManager::mkBoundVar("nm1469", nm->integerType());
Node x470 = NodeManager::mkBoundVar("x470", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n471 = NodeManager::mkBoundVar("n471", nm->integerType());

  // Definitions
Node e472 = nm->mkConstInt(Rational(1));
Node e473 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) });
Node e474 = nm->mkConstInt(Rational(0));
Node e475 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) });
Node e476 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1469,nm1469,nm->mkNode(Kind::BITVECTOR_SUB, { x467,y468 }) });
Node e477 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1469,nm1469,y468 });
Node e478 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1469,nm1469,x467 });
Node e479 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1463,nm1463,x461 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x461 }),x461 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1463,nm1463,y462 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y462 }),y462 }) });
Node e480 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1463,nm1463,x461 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e481 = nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,x457 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) }),x457,nm->mkNode(Kind::BITVECTOR_NEG, { x457 }) }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,y458 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) }),y458,nm->mkNode(Kind::BITVECTOR_NEG, { y458 }) }) });
Node e482 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,y458 });
Node e483 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,x457 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) });
Node e484 = nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_UREM, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,x457 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) }),x457,nm->mkNode(Kind::BITVECTOR_NEG, { x457 }) }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,y458 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) }),y458,nm->mkNode(Kind::BITVECTOR_NEG, { y458 }) }) }) });
Node e485 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,y458 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) }) });
Node e486 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1460,wm1460,x457 });
Node e487 = nm->mkNode(Kind::BITVECTOR_SIZE, { x457 });
Node e488 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1452,wm1452,nm->mkNode(Kind::BITVECTOR_ADD, { x450,y451 }) });
Node e489 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1452,wm1452,y451 });
Node e490 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1452,wm1452,x450 });
Node e491 = nm->mkNode(Kind::BITVECTOR_UDIV, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1444,nm1444,x442 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { x442 }),x442 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1444,nm1444,y443 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) }),nm->mkNode(Kind::BITVECTOR_NEG, { y443 }),y443 }) });
Node e492 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1444,nm1444,y443 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e493 = nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1444,nm1444,x442 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) }) });
Node e494 = nm->mkConst(true);
Node e495 = nm->mkNode(Kind::BITVECTOR_SIZE, { x429 });
Node e496 = nm->mkNode(Kind::INTS_MODULUS, { amount430,nm->mkNode(Kind::BITVECTOR_SIZE, { x429 }) });
Node e497 = nm->mkNode(Kind::BITVECTOR_SIZE, { x422 });
Node e498 = nm->mkNode(Kind::INTS_MODULUS, { amount423,nm->mkNode(Kind::BITVECTOR_SIZE, { x422 }) });

  // Rules

        {
            // from rewrites-bv-rewrites-elimination.cpp
            db.addRule(ProofRewriteRule::BV_UGT_ELIMINATE, { x404, y405 }, nm->mkNode(Kind::BITVECTOR_UGT, { x404,y405 }), nm->mkNode(Kind::BITVECTOR_ULT, { y405,x404 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UGE_ELIMINATE, { x406, y407 }, nm->mkNode(Kind::BITVECTOR_UGE, { x406,y407 }), nm->mkNode(Kind::BITVECTOR_ULE, { y407,x406 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SGT_ELIMINATE, { x408, y409 }, nm->mkNode(Kind::BITVECTOR_SGT, { x408,y409 }), nm->mkNode(Kind::BITVECTOR_SLT, { y409,x408 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SGE_ELIMINATE, { x410, y411 }, nm->mkNode(Kind::BITVECTOR_SGE, { x410,y411 }), nm->mkNode(Kind::BITVECTOR_SLE, { y411,x410 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SLE_ELIMINATE, { x412, y413 }, nm->mkNode(Kind::BITVECTOR_SLE, { x412,y413 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_SLT, { y413,x412 }) }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_REDOR_ELIMINATE, { x414, w415 }, nm->mkNode(Kind::BITVECTOR_REDOR, { x414 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_COMP, { x414,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,w415 }) }) }), nm->mkNode(Kind::EQUAL, { w415,nm->mkNode(Kind::BITVECTOR_SIZE, { x414 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_REDAND_ELIMINATE, { x416, w417 }, nm->mkNode(Kind::BITVECTOR_REDAND, { x416 }), nm->mkNode(Kind::BITVECTOR_COMP, { x416,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,w417 }) }) }), nm->mkNode(Kind::EQUAL, { w417,nm->mkNode(Kind::BITVECTOR_SIZE, { x416 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULE_ELIMINATE, { x418, y419 }, nm->mkNode(Kind::BITVECTOR_ULE, { x418,y419 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { y419,x418 }) }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_COMP_ELIMINATE, { x420, y421 }, nm->mkNode(Kind::BITVECTOR_COMP, { x420,y421 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x420,y421 }),e473,e475 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_1, { x422, amount423, u1424, u2425, l2426 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount423,x422 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1424,e474,x422 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2425,l2426,x422 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e498,e474 }) }),nm->mkNode(Kind::EQUAL, { u1424,nm->mkNode(Kind::SUB, { e497,nm->mkNode(Kind::ADD, { e472,e498 }) }) }),nm->mkNode(Kind::EQUAL, { u2425,nm->mkNode(Kind::SUB, { e497,e472 }) }),nm->mkNode(Kind::EQUAL, { l2426,nm->mkNode(Kind::SUB, { e497,e498 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ROTATE_LEFT_ELIMINATE_2, { x427, amount428 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_LEFT)),amount428,x427 }), x427, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount428,nm->mkNode(Kind::BITVECTOR_SIZE, { x427 }) }),e474 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_1, { x429, amount430, u1431, u2432, l2433 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount430,x429 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1431,e474,x429 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2432,l2433,x429 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e496,e474 }) }),nm->mkNode(Kind::EQUAL, { u1431,nm->mkNode(Kind::SUB, { e496,e472 }) }),nm->mkNode(Kind::EQUAL, { u2432,nm->mkNode(Kind::SUB, { e495,e472 }) }),nm->mkNode(Kind::EQUAL, { l2433,e496 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ROTATE_RIGHT_ELIMINATE_2, { x434, amount435 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ROTATE_RIGHT)),amount435,x434 }), x434, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::INTS_MODULUS, { amount435,nm->mkNode(Kind::BITVECTOR_SIZE, { x434 }) }),e474 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NAND_ELIMINATE, { x436, y437 }, nm->mkNode(Kind::BITVECTOR_NAND, { x436,y437 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_AND, { x436,y437 }) }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NOR_ELIMINATE, { x438, y439 }, nm->mkNode(Kind::BITVECTOR_NOR, { x438,y439 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_OR, { x438,y439 }) }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XNOR_ELIMINATE, { x440, y441 }, nm->mkNode(Kind::BITVECTOR_XNOR, { x440,y441 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x440,y441 }) }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SDIV_ELIMINATE, { x442, y443, nm1444 }, nm->mkNode(Kind::BITVECTOR_SDIV, { x442,y443 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::XOR, { e493,e492 }),nm->mkNode(Kind::BITVECTOR_NEG, { e491 }),e491 }), nm->mkNode(Kind::EQUAL, { nm1444,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x442 }),e472 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE, { x445, n446 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n446,x445 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,n446 }),x445 }), e494, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UADDO_ELIMINATE, { x447, y448, w449 }, nm->mkNode(Kind::BITVECTOR_UADDO, { x447,y448 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),w449,w449,nm->mkNode(Kind::BITVECTOR_ADD, { nm->mkNode(Kind::BITVECTOR_CONCAT, { e475,x447 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { e475,y448 }) }) }),e473 }), nm->mkNode(Kind::EQUAL, { w449,nm->mkNode(Kind::BITVECTOR_SIZE, { x447 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SADDO_ELIMINATE, { x450, y451, wm1452 }, nm->mkNode(Kind::BITVECTOR_SADDO, { x450,y451 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e490,e473 }),nm->mkNode(Kind::EQUAL, { e489,e473 }) }),nm->mkNode(Kind::EQUAL, { e488,e475 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e490,e475 }),nm->mkNode(Kind::EQUAL, { e489,e475 }) }),nm->mkNode(Kind::EQUAL, { e488,e473 }) }) }), nm->mkNode(Kind::EQUAL, { wm1452,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x450 }),e472 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SDIVO_ELIMINATE, { x453, y454, w455, wm1456 }, nm->mkNode(Kind::BITVECTOR_SDIVO, { x453,y454 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x453,nm->mkNode(Kind::BITVECTOR_CONCAT, { e473,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,wm1456 }) }) }),nm->mkNode(Kind::EQUAL, { y454,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,w455 }) }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1456,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x453 }),e472 }) }),nm->mkNode(Kind::EQUAL, { w455,nm->mkNode(Kind::BITVECTOR_SIZE, { y454 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SMOD_ELIMINATE, { x457, y458, w459, wm1460 }, nm->mkNode(Kind::BITVECTOR_SMOD, { x457,y458 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { e481,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,w459 }) }),e481,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e483,e485 }),e481,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e486,e473 }),e485 }),nm->mkNode(Kind::BITVECTOR_ADD, { e484,y458 }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::AND, { e483,nm->mkNode(Kind::EQUAL, { e482,e473 }) }),nm->mkNode(Kind::BITVECTOR_ADD, { e481,y458 }),e484 }) }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w459,e487 }),nm->mkNode(Kind::EQUAL, { wm1460,nm->mkNode(Kind::SUB, { e487,e472 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SREM_ELIMINATE, { x461, y462, nm1463 }, nm->mkNode(Kind::BITVECTOR_SREM, { x461,y462 }), nm->mkNode(Kind::ITE, { e480,nm->mkNode(Kind::BITVECTOR_NEG, { e479 }),e479 }), nm->mkNode(Kind::EQUAL, { nm1463,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x461 }),e472 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_USUBO_ELIMINATE, { x464, y465, n466 }, nm->mkNode(Kind::BITVECTOR_USUBO, { x464,y465 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),n466,n466,nm->mkNode(Kind::BITVECTOR_SUB, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e472,x464 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e472,y465 }) }) }),e473 }), nm->mkNode(Kind::EQUAL, { n466,nm->mkNode(Kind::BITVECTOR_SIZE, { x464 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SSUBO_ELIMINATE, { x467, y468, nm1469 }, nm->mkNode(Kind::BITVECTOR_SSUBO, { x467,y468 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e478,e473 }),nm->mkNode(Kind::EQUAL, { e477,e475 }) }),nm->mkNode(Kind::EQUAL, { e476,e475 }) }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e478,e475 }),nm->mkNode(Kind::EQUAL, { e477,e473 }) }),nm->mkNode(Kind::EQUAL, { e476,e473 }) }) }), nm->mkNode(Kind::EQUAL, { nm1469,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x467 }),e472 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NEGO_ELIMINATE, { x470, n471 }, nm->mkNode(Kind::BITVECTOR_NEGO, { x470 }), nm->mkNode(Kind::EQUAL, { x470,nm->mkNode(Kind::BITVECTOR_CONCAT, { e473,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e474,n471 }) }) }), nm->mkNode(Kind::EQUAL, { n471,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x470 }),e472 }) }), Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
