/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites_simplification(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node c499 = NodeManager::mkBoundVar("c499", nm->mkBitVectorType(1));
Node x500 = NodeManager::mkBoundVar("x500", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c501 = NodeManager::mkBoundVar("c501", nm->mkBitVectorType(1));
Node c502 = NodeManager::mkBoundVar("c502", nm->mkBitVectorType(1));
Node c0503 = NodeManager::mkBoundVar("c0503", nm->mkBitVectorType(1));
Node t0504 = NodeManager::mkBoundVar("t0504", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0505 = NodeManager::mkBoundVar("e0505", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1506 = NodeManager::mkBoundVar("e1506", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0507 = NodeManager::mkBoundVar("c0507", nm->mkBitVectorType(1));
Node t0508 = NodeManager::mkBoundVar("t0508", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1509 = NodeManager::mkBoundVar("t1509", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1510 = NodeManager::mkBoundVar("e1510", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0511 = NodeManager::mkBoundVar("c0511", nm->mkBitVectorType(1));
Node t0512 = NodeManager::mkBoundVar("t0512", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e0513 = NodeManager::mkBoundVar("e0513", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1514 = NodeManager::mkBoundVar("t1514", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1515 = NodeManager::mkBoundVar("e1515", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0516 = NodeManager::mkBoundVar("c0516", nm->mkBitVectorType(1));
Node c1517 = NodeManager::mkBoundVar("c1517", nm->mkBitVectorType(1));
Node t1518 = NodeManager::mkBoundVar("t1518", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1519 = NodeManager::mkBoundVar("e1519", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0520 = NodeManager::mkBoundVar("c0520", nm->mkBitVectorType(1));
Node c1521 = NodeManager::mkBoundVar("c1521", nm->mkBitVectorType(1));
Node t1522 = NodeManager::mkBoundVar("t1522", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1523 = NodeManager::mkBoundVar("e1523", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0524 = NodeManager::mkBoundVar("c0524", nm->mkBitVectorType(1));
Node c1525 = NodeManager::mkBoundVar("c1525", nm->mkBitVectorType(1));
Node t0526 = NodeManager::mkBoundVar("t0526", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node e1527 = NodeManager::mkBoundVar("e1527", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node c0528 = NodeManager::mkBoundVar("c0528", nm->mkBitVectorType(1));
Node c1529 = NodeManager::mkBoundVar("c1529", nm->mkBitVectorType(1));
Node t1530 = NodeManager::mkBoundVar("t1530", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t0531 = NodeManager::mkBoundVar("t0531", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x532 = NodeManager::mkBoundVar("x532", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz533 = NodeManager::mkBoundVar("sz533", nm->integerType());
Node x534 = NodeManager::mkBoundVar("x534", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount535 = NodeManager::mkBoundVar("amount535", nm->integerType());
Node sz536 = NodeManager::mkBoundVar("sz536", nm->integerType());
Node en537 = NodeManager::mkBoundVar("en537", nm->integerType());
Node x538 = NodeManager::mkBoundVar("x538", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount539 = NodeManager::mkBoundVar("amount539", nm->integerType());
Node sz540 = NodeManager::mkBoundVar("sz540", nm->integerType());
Node w541 = NodeManager::mkBoundVar("w541", nm->integerType());
Node x542 = NodeManager::mkBoundVar("x542", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz543 = NodeManager::mkBoundVar("sz543", nm->integerType());
Node x544 = NodeManager::mkBoundVar("x544", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount545 = NodeManager::mkBoundVar("amount545", nm->integerType());
Node sz546 = NodeManager::mkBoundVar("sz546", nm->integerType());
Node nm1547 = NodeManager::mkBoundVar("nm1547", nm->integerType());
Node x548 = NodeManager::mkBoundVar("x548", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount549 = NodeManager::mkBoundVar("amount549", nm->integerType());
Node sz550 = NodeManager::mkBoundVar("sz550", nm->integerType());
Node x551 = NodeManager::mkBoundVar("x551", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node sz552 = NodeManager::mkBoundVar("sz552", nm->integerType());
Node x553 = NodeManager::mkBoundVar("x553", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount554 = NodeManager::mkBoundVar("amount554", nm->integerType());
Node sz555 = NodeManager::mkBoundVar("sz555", nm->integerType());
Node nm1556 = NodeManager::mkBoundVar("nm1556", nm->integerType());
Node x557 = NodeManager::mkBoundVar("x557", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node amount558 = NodeManager::mkBoundVar("amount558", nm->integerType());
Node sz559 = NodeManager::mkBoundVar("sz559", nm->integerType());
Node nm1560 = NodeManager::mkBoundVar("nm1560", nm->integerType());
Node rn561 = NodeManager::mkBoundVar("rn561", nm->integerType());
Node xs562 = NodeManager::mkBoundVar("xs562", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs562);
Node ws563 = NodeManager::mkBoundVar("ws563", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws563);
Node y564 = NodeManager::mkBoundVar("y564", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z565 = NodeManager::mkBoundVar("z565", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys566 = NodeManager::mkBoundVar("ys566", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys566);
Node nxm1567 = NodeManager::mkBoundVar("nxm1567", nm->integerType());
Node ny568 = NodeManager::mkBoundVar("ny568", nm->integerType());
Node nym1569 = NodeManager::mkBoundVar("nym1569", nm->integerType());
Node xs570 = NodeManager::mkBoundVar("xs570", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs570);
Node ws571 = NodeManager::mkBoundVar("ws571", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws571);
Node y572 = NodeManager::mkBoundVar("y572", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z573 = NodeManager::mkBoundVar("z573", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys574 = NodeManager::mkBoundVar("ys574", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys574);
Node nxm1575 = NodeManager::mkBoundVar("nxm1575", nm->integerType());
Node ny576 = NodeManager::mkBoundVar("ny576", nm->integerType());
Node nym1577 = NodeManager::mkBoundVar("nym1577", nm->integerType());
Node xs578 = NodeManager::mkBoundVar("xs578", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs578);
Node ws579 = NodeManager::mkBoundVar("ws579", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws579);
Node y580 = NodeManager::mkBoundVar("y580", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z581 = NodeManager::mkBoundVar("z581", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys582 = NodeManager::mkBoundVar("ys582", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys582);
Node nxm1583 = NodeManager::mkBoundVar("nxm1583", nm->integerType());
Node ny584 = NodeManager::mkBoundVar("ny584", nm->integerType());
Node nym1585 = NodeManager::mkBoundVar("nym1585", nm->integerType());
Node xs586 = NodeManager::mkBoundVar("xs586", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs586);
Node ws587 = NodeManager::mkBoundVar("ws587", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws587);
Node y588 = NodeManager::mkBoundVar("y588", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z589 = NodeManager::mkBoundVar("z589", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys590 = NodeManager::mkBoundVar("ys590", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys590);
Node nxm1591 = NodeManager::mkBoundVar("nxm1591", nm->integerType());
Node ny592 = NodeManager::mkBoundVar("ny592", nm->integerType());
Node nym1593 = NodeManager::mkBoundVar("nym1593", nm->integerType());
Node xs594 = NodeManager::mkBoundVar("xs594", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs594);
Node ws595 = NodeManager::mkBoundVar("ws595", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws595);
Node y596 = NodeManager::mkBoundVar("y596", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z597 = NodeManager::mkBoundVar("z597", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys598 = NodeManager::mkBoundVar("ys598", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys598);
Node nxm1599 = NodeManager::mkBoundVar("nxm1599", nm->integerType());
Node ny600 = NodeManager::mkBoundVar("ny600", nm->integerType());
Node nym1601 = NodeManager::mkBoundVar("nym1601", nm->integerType());
Node xs602 = NodeManager::mkBoundVar("xs602", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs602);
Node ws603 = NodeManager::mkBoundVar("ws603", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws603);
Node y604 = NodeManager::mkBoundVar("y604", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z605 = NodeManager::mkBoundVar("z605", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys606 = NodeManager::mkBoundVar("ys606", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys606);
Node nxm1607 = NodeManager::mkBoundVar("nxm1607", nm->integerType());
Node ny608 = NodeManager::mkBoundVar("ny608", nm->integerType());
Node nym1609 = NodeManager::mkBoundVar("nym1609", nm->integerType());
Node xs610 = NodeManager::mkBoundVar("xs610", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs610);
Node ws611 = NodeManager::mkBoundVar("ws611", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws611);
Node y612 = NodeManager::mkBoundVar("y612", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z613 = NodeManager::mkBoundVar("z613", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node u614 = NodeManager::mkBoundVar("u614", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nxm1615 = NodeManager::mkBoundVar("nxm1615", nm->integerType());
Node nyu616 = NodeManager::mkBoundVar("nyu616", nm->integerType());
Node nyum1617 = NodeManager::mkBoundVar("nyum1617", nm->integerType());
Node nu618 = NodeManager::mkBoundVar("nu618", nm->integerType());
Node num1619 = NodeManager::mkBoundVar("num1619", nm->integerType());
Node xs620 = NodeManager::mkBoundVar("xs620", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs620);
Node ws621 = NodeManager::mkBoundVar("ws621", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws621);
Node y622 = NodeManager::mkBoundVar("y622", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z623 = NodeManager::mkBoundVar("z623", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node u624 = NodeManager::mkBoundVar("u624", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nxm1625 = NodeManager::mkBoundVar("nxm1625", nm->integerType());
Node nyu626 = NodeManager::mkBoundVar("nyu626", nm->integerType());
Node nyum1627 = NodeManager::mkBoundVar("nyum1627", nm->integerType());
Node nu628 = NodeManager::mkBoundVar("nu628", nm->integerType());
Node num1629 = NodeManager::mkBoundVar("num1629", nm->integerType());
Node xs630 = NodeManager::mkBoundVar("xs630", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs630);
Node ws631 = NodeManager::mkBoundVar("ws631", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ws631);
Node y632 = NodeManager::mkBoundVar("y632", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z633 = NodeManager::mkBoundVar("z633", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node u634 = NodeManager::mkBoundVar("u634", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node nxm1635 = NodeManager::mkBoundVar("nxm1635", nm->integerType());
Node nyu636 = NodeManager::mkBoundVar("nyu636", nm->integerType());
Node nyum1637 = NodeManager::mkBoundVar("nyum1637", nm->integerType());
Node nu638 = NodeManager::mkBoundVar("nu638", nm->integerType());
Node num1639 = NodeManager::mkBoundVar("num1639", nm->integerType());
Node x640 = NodeManager::mkBoundVar("x640", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w641 = NodeManager::mkBoundVar("w641", nm->integerType());
Node xs642 = NodeManager::mkBoundVar("xs642", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs642);
Node zs643 = NodeManager::mkBoundVar("zs643", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs643);
Node n644 = NodeManager::mkBoundVar("n644", nm->integerType());
Node w645 = NodeManager::mkBoundVar("w645", nm->integerType());
Node x646 = NodeManager::mkBoundVar("x646", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y647 = NodeManager::mkBoundVar("y647", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x648 = NodeManager::mkBoundVar("x648", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x649 = NodeManager::mkBoundVar("x649", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n650 = NodeManager::mkBoundVar("n650", nm->integerType());
Node x651 = NodeManager::mkBoundVar("x651", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n652 = NodeManager::mkBoundVar("n652", nm->integerType());
Node x653 = NodeManager::mkBoundVar("x653", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x654 = NodeManager::mkBoundVar("x654", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x655 = NodeManager::mkBoundVar("x655", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x656 = NodeManager::mkBoundVar("x656", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n657 = NodeManager::mkBoundVar("n657", nm->integerType());
Node x658 = NodeManager::mkBoundVar("x658", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n659 = NodeManager::mkBoundVar("n659", nm->integerType());
Node x660 = NodeManager::mkBoundVar("x660", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x661 = NodeManager::mkBoundVar("x661", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n662 = NodeManager::mkBoundVar("n662", nm->integerType());
Node w663 = NodeManager::mkBoundVar("w663", nm->integerType());
Node x664 = NodeManager::mkBoundVar("x664", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y665 = NodeManager::mkBoundVar("y665", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs666 = NodeManager::mkBoundVar("xs666", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs666);
Node ys667 = NodeManager::mkBoundVar("ys667", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys667);
Node z668 = NodeManager::mkBoundVar("z668", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size669 = NodeManager::mkBoundVar("size669", nm->integerType());
Node n670 = NodeManager::mkBoundVar("n670", nm->integerType());
Node exponent671 = NodeManager::mkBoundVar("exponent671", nm->integerType());
Node u672 = NodeManager::mkBoundVar("u672", nm->integerType());
Node xs673 = NodeManager::mkBoundVar("xs673", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs673);
Node ys674 = NodeManager::mkBoundVar("ys674", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys674);
Node z675 = NodeManager::mkBoundVar("z675", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size676 = NodeManager::mkBoundVar("size676", nm->integerType());
Node n677 = NodeManager::mkBoundVar("n677", nm->integerType());
Node exponent678 = NodeManager::mkBoundVar("exponent678", nm->integerType());
Node u679 = NodeManager::mkBoundVar("u679", nm->integerType());
Node z680 = NodeManager::mkBoundVar("z680", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node size681 = NodeManager::mkBoundVar("size681", nm->integerType());
Node n682 = NodeManager::mkBoundVar("n682", nm->integerType());
Node exponent683 = NodeManager::mkBoundVar("exponent683", nm->integerType());
Node u684 = NodeManager::mkBoundVar("u684", nm->integerType());
Node high685 = NodeManager::mkBoundVar("high685", nm->integerType());
Node low686 = NodeManager::mkBoundVar("low686", nm->integerType());
Node x1i687 = NodeManager::mkBoundVar("x1i687", nm->integerType());
Node x1in688 = NodeManager::mkBoundVar("x1in688", nm->integerType());
Node x2689 = NodeManager::mkBoundVar("x2689", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y1i690 = NodeManager::mkBoundVar("y1i690", nm->integerType());
Node y1in691 = NodeManager::mkBoundVar("y1in691", nm->integerType());
Node y2692 = NodeManager::mkBoundVar("y2692", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w693 = NodeManager::mkBoundVar("w693", nm->integerType());
Node x694 = NodeManager::mkBoundVar("x694", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v695 = NodeManager::mkBoundVar("v695", nm->integerType());
Node n696 = NodeManager::mkBoundVar("n696", nm->integerType());
Node power697 = NodeManager::mkBoundVar("power697", nm->integerType());
Node nm1698 = NodeManager::mkBoundVar("nm1698", nm->integerType());
Node x699 = NodeManager::mkBoundVar("x699", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n700 = NodeManager::mkBoundVar("n700", nm->integerType());
Node x701 = NodeManager::mkBoundVar("x701", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n702 = NodeManager::mkBoundVar("n702", nm->integerType());
Node x703 = NodeManager::mkBoundVar("x703", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node v704 = NodeManager::mkBoundVar("v704", nm->integerType());
Node n705 = NodeManager::mkBoundVar("n705", nm->integerType());
Node nmp706 = NodeManager::mkBoundVar("nmp706", nm->integerType());
Node pm1707 = NodeManager::mkBoundVar("pm1707", nm->integerType());
Node x708 = NodeManager::mkBoundVar("x708", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n709 = NodeManager::mkBoundVar("n709", nm->integerType());
Node x710 = NodeManager::mkBoundVar("x710", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w711 = NodeManager::mkBoundVar("w711", nm->integerType());
Node a712 = NodeManager::mkBoundVar("a712", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n713 = NodeManager::mkBoundVar("n713", nm->integerType());
Node a714 = NodeManager::mkBoundVar("a714", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n715 = NodeManager::mkBoundVar("n715", nm->integerType());
Node a716 = NodeManager::mkBoundVar("a716", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n717 = NodeManager::mkBoundVar("n717", nm->integerType());
Node y718 = NodeManager::mkBoundVar("y718", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x719 = NodeManager::mkBoundVar("x719", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w720 = NodeManager::mkBoundVar("w720", nm->integerType());
Node x721 = NodeManager::mkBoundVar("x721", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n722 = NodeManager::mkBoundVar("n722", nm->integerType());
Node x723 = NodeManager::mkBoundVar("x723", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i724 = NodeManager::mkBoundVar("i724", nm->integerType());
Node j725 = NodeManager::mkBoundVar("j725", nm->integerType());
Node k726 = NodeManager::mkBoundVar("k726", nm->integerType());
Node x727 = NodeManager::mkBoundVar("x727", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i728 = NodeManager::mkBoundVar("i728", nm->integerType());
Node j729 = NodeManager::mkBoundVar("j729", nm->integerType());
Node k730 = NodeManager::mkBoundVar("k730", nm->integerType());
Node x731 = NodeManager::mkBoundVar("x731", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m732 = NodeManager::mkBoundVar("m732", nm->integerType());
Node c733 = NodeManager::mkBoundVar("c733", nm->integerType());
Node nm734 = NodeManager::mkBoundVar("nm734", nm->integerType());
Node mp1735 = NodeManager::mkBoundVar("mp1735", nm->integerType());
Node nm1736 = NodeManager::mkBoundVar("nm1736", nm->integerType());
Node nmm1737 = NodeManager::mkBoundVar("nmm1737", nm->integerType());
Node x738 = NodeManager::mkBoundVar("x738", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m739 = NodeManager::mkBoundVar("m739", nm->integerType());
Node c740 = NodeManager::mkBoundVar("c740", nm->integerType());
Node nm741 = NodeManager::mkBoundVar("nm741", nm->integerType());
Node mp1742 = NodeManager::mkBoundVar("mp1742", nm->integerType());
Node nm1743 = NodeManager::mkBoundVar("nm1743", nm->integerType());
Node nmm1744 = NodeManager::mkBoundVar("nmm1744", nm->integerType());
Node x745 = NodeManager::mkBoundVar("x745", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m746 = NodeManager::mkBoundVar("m746", nm->integerType());
Node c747 = NodeManager::mkBoundVar("c747", nm->integerType());
Node nm748 = NodeManager::mkBoundVar("nm748", nm->integerType());
Node nm1749 = NodeManager::mkBoundVar("nm1749", nm->integerType());
Node nmm1750 = NodeManager::mkBoundVar("nmm1750", nm->integerType());
Node x751 = NodeManager::mkBoundVar("x751", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m752 = NodeManager::mkBoundVar("m752", nm->integerType());
Node c753 = NodeManager::mkBoundVar("c753", nm->integerType());
Node nm754 = NodeManager::mkBoundVar("nm754", nm->integerType());
Node nm1755 = NodeManager::mkBoundVar("nm1755", nm->integerType());
Node nmm1756 = NodeManager::mkBoundVar("nmm1756", nm->integerType());
Node x757 = NodeManager::mkBoundVar("x757", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m758 = NodeManager::mkBoundVar("m758", nm->integerType());
Node c759 = NodeManager::mkBoundVar("c759", nm->integerType());
Node nm760 = NodeManager::mkBoundVar("nm760", nm->integerType());
Node nm1761 = NodeManager::mkBoundVar("nm1761", nm->integerType());
Node x762 = NodeManager::mkBoundVar("x762", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m763 = NodeManager::mkBoundVar("m763", nm->integerType());
Node c764 = NodeManager::mkBoundVar("c764", nm->integerType());
Node nm765 = NodeManager::mkBoundVar("nm765", nm->integerType());
Node nm1766 = NodeManager::mkBoundVar("nm1766", nm->integerType());
Node x767 = NodeManager::mkBoundVar("x767", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m768 = NodeManager::mkBoundVar("m768", nm->integerType());
Node c769 = NodeManager::mkBoundVar("c769", nm->integerType());
Node nm770 = NodeManager::mkBoundVar("nm770", nm->integerType());
Node nm1771 = NodeManager::mkBoundVar("nm1771", nm->integerType());
Node x772 = NodeManager::mkBoundVar("x772", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m773 = NodeManager::mkBoundVar("m773", nm->integerType());
Node c774 = NodeManager::mkBoundVar("c774", nm->integerType());
Node nm775 = NodeManager::mkBoundVar("nm775", nm->integerType());
Node nm1776 = NodeManager::mkBoundVar("nm1776", nm->integerType());
Node x777 = NodeManager::mkBoundVar("x777", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m778 = NodeManager::mkBoundVar("m778", nm->integerType());
Node c779 = NodeManager::mkBoundVar("c779", nm->integerType());
Node nm780 = NodeManager::mkBoundVar("nm780", nm->integerType());
Node nm1781 = NodeManager::mkBoundVar("nm1781", nm->integerType());
Node x782 = NodeManager::mkBoundVar("x782", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node m783 = NodeManager::mkBoundVar("m783", nm->integerType());
Node c784 = NodeManager::mkBoundVar("c784", nm->integerType());
Node nm785 = NodeManager::mkBoundVar("nm785", nm->integerType());
Node nm1786 = NodeManager::mkBoundVar("nm1786", nm->integerType());

  // Definitions
Node e787 = nm->mkConstInt(Rational(1));
Node e788 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x782 }),nm->mkConstInt(Rational(1)) });
Node e789 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c784,nm785 });
Node e790 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x782 }),nm->mkConstInt(Rational(1)) }),nm785 });
Node e791 = nm->mkConstInt(Rational(0));
Node e792 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c779,nm780 });
Node e793 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x777 }),nm->mkConstInt(Rational(1)) });
Node e794 = nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm780 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x777 }),nm->mkConstInt(Rational(1)) }),nm780 }) });
Node e795 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x772 }),nm->mkConstInt(Rational(1)) });
Node e796 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c774,nm775 });
Node e797 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x772 }),nm->mkConstInt(Rational(1)) }),nm775 });
Node e798 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c769,nm770 });
Node e799 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x767 }),nm->mkConstInt(Rational(1)) });
Node e800 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x767 }),nm->mkConstInt(Rational(1)) }),nm770 });
Node e801 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c764,nm765 });
Node e802 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1766,nm->mkConstInt(Rational(0)),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c764,nm765 }) });
Node e803 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c759,nm760 });
Node e804 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1761,nm->mkConstInt(Rational(0)),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c759,nm760 }) });
Node e805 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c753,nm754 });
Node e806 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c747,nm748 });
Node e807 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c740,nm741 });
Node e808 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),mp1742 });
Node e809 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1744,nm1743,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c740,nm741 }) });
Node e810 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c733,nm734 });
Node e811 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),mp1735 });
Node e812 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1737,nm1736,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { c733,nm734 }) });
Node e813 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),w720 });
Node e814 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n717 });
Node e815 = nm->mkConst(true);
Node e816 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n715 });
Node e817 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n713 });
Node e818 = nm->mkNode(Kind::INTS_LOG2, { v704 });
Node e819 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n700 });
Node e820 = nm->mkNode(Kind::ADD, { x1in688,nm->mkNode(Kind::BITVECTOR_SIZE, { x2689 }) });
Node e821 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size681 }),n682 }) });
Node e822 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size681 }),n682 });
Node e823 = nm->mkNode(Kind::INTS_LOG2, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size676 }),n677 }) });
Node e824 = nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { size676 }),n677 });
Node e825 = nm->mkNode(Kind::INTS_LOG2, { n670 });
Node e826 = nm->mkNode(Kind::BITVECTOR_SIZE, { x661 });
Node e827 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n657 });
Node e828 = nm->mkConst(false);
Node e829 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),n650 });
Node e830 = nm->mkNode(Kind::BITVECTOR_XOR, { xs630,ws631 });
Node e831 = nm->mkNode(Kind::BITVECTOR_SIZE, { u634 });
Node e832 = nm->mkNode(Kind::ADD, { nm->mkNode(Kind::BITVECTOR_SIZE, { y632 }),nm->mkNode(Kind::BITVECTOR_SIZE, { u634 }) });
Node e833 = nm->mkNode(Kind::BITVECTOR_OR, { xs620,ws621 });
Node e834 = nm->mkNode(Kind::BITVECTOR_SIZE, { u624 });
Node e835 = nm->mkNode(Kind::ADD, { nm->mkNode(Kind::BITVECTOR_SIZE, { y622 }),nm->mkNode(Kind::BITVECTOR_SIZE, { u624 }) });
Node e836 = nm->mkNode(Kind::BITVECTOR_AND, { xs610,ws611 });
Node e837 = nm->mkNode(Kind::BITVECTOR_SIZE, { u614 });
Node e838 = nm->mkNode(Kind::ADD, { nm->mkNode(Kind::BITVECTOR_SIZE, { y612 }),nm->mkNode(Kind::BITVECTOR_SIZE, { u614 }) });
Node e839 = nm->mkNode(Kind::BITVECTOR_XOR, { xs602,ws603 });
Node e840 = nm->mkNode(Kind::BITVECTOR_CONCAT, { y604,ys606 });
Node e841 = nm->mkNode(Kind::BITVECTOR_SIZE, { nm->mkNode(Kind::BITVECTOR_CONCAT, { y604,ys606 }) });
Node e842 = nm->mkNode(Kind::BITVECTOR_OR, { xs594,ws595 });
Node e843 = nm->mkNode(Kind::BITVECTOR_CONCAT, { y596,ys598 });
Node e844 = nm->mkNode(Kind::BITVECTOR_SIZE, { nm->mkNode(Kind::BITVECTOR_CONCAT, { y596,ys598 }) });
Node e845 = nm->mkNode(Kind::BITVECTOR_AND, { xs586,ws587 });
Node e846 = nm->mkNode(Kind::BITVECTOR_CONCAT, { y588,ys590 });
Node e847 = nm->mkNode(Kind::BITVECTOR_SIZE, { nm->mkNode(Kind::BITVECTOR_CONCAT, { y588,ys590 }) });
Node e848 = nm->mkNode(Kind::BITVECTOR_XOR, { xs578,ws579 });
Node e849 = nm->mkNode(Kind::BITVECTOR_SIZE, { y580 });
Node e850 = nm->mkNode(Kind::BITVECTOR_OR, { xs570,ws571 });
Node e851 = nm->mkNode(Kind::BITVECTOR_SIZE, { y572 });
Node e852 = nm->mkNode(Kind::BITVECTOR_AND, { xs562,ws563 });
Node e853 = nm->mkNode(Kind::BITVECTOR_SIZE, { y564 });
Node e854 = nm->mkNode(Kind::BITVECTOR_SIZE, { x557 });
Node e855 = nm->mkNode(Kind::BITVECTOR_SIZE, { x553 });
Node e856 = nm->mkNode(Kind::BITVECTOR_SIZE, { x544 });
Node e857 = nm->mkNode(Kind::BITVECTOR_SIZE, { x538 });
Node e858 = nm->mkNode(Kind::BITVECTOR_SIZE, { x534 });
Node e859 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) });
Node e860 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) });

  // Rules

        {
            // from rewrites-bv-rewrites-simplification.cpp
            db.addRule(ProofRewriteRule::BV_ITE_EQUAL_CHILDREN, { c499, x500 }, nm->mkNode(Kind::BITVECTOR_ITE, { c499,x500,x500 }), x500, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_1, { c501 }, nm->mkNode(Kind::BITVECTOR_ITE, { c501,e859,e860 }), nm->mkNode(Kind::BITVECTOR_NOT, { c501 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_CONST_CHILDREN_2, { c502 }, nm->mkNode(Kind::BITVECTOR_ITE, { c502,e860,e859 }), c502, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_1, { c0503, t0504, e0505, e1506 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0503,nm->mkNode(Kind::BITVECTOR_ITE, { c0503,t0504,e0505 }),e1506 }), nm->mkNode(Kind::BITVECTOR_ITE, { c0503,t0504,e1506 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_2, { c0507, t0508, t1509, e1510 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0507,t0508,nm->mkNode(Kind::BITVECTOR_ITE, { c0507,t1509,e1510 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0507,t0508,e1510 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_EQUAL_COND_3, { c0511, t0512, e0513, t1514, e1515 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0511,nm->mkNode(Kind::BITVECTOR_ITE, { c0511,t0512,e0513 }),nm->mkNode(Kind::BITVECTOR_ITE, { c0511,t1514,e1515 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { c0511,t0512,e1515 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_IF, { c0516, c1517, t1518, e1519 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0516,nm->mkNode(Kind::BITVECTOR_ITE, { c1517,t1518,e1519 }),t1518 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0516,nm->mkNode(Kind::BITVECTOR_NOT, { c1517 }) }),e1519,t1518 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_IF, { c0520, c1521, t1522, e1523 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0520,nm->mkNode(Kind::BITVECTOR_ITE, { c1521,t1522,e1523 }),e1523 }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { c0520,c1521 }),t1522,e1523 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_MERGE_THEN_ELSE, { c0524, c1525, t0526, e1527 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0524,t0526,nm->mkNode(Kind::BITVECTOR_ITE, { c1525,t0526,e1527 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::BITVECTOR_NOT, { c0524 }),nm->mkNode(Kind::BITVECTOR_NOT, { c1525 }) }),e1527,t0526 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_MERGE_ELSE_ELSE, { c0528, c1529, t1530, t0531 }, nm->mkNode(Kind::BITVECTOR_ITE, { c0528,t0531,nm->mkNode(Kind::BITVECTOR_ITE, { c1529,t1530,t0531 }) }), nm->mkNode(Kind::BITVECTOR_ITE, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::BITVECTOR_NOT, { c0528 }),c1529 }),t1530,t0531 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_0, { x532, sz533 }, nm->mkNode(Kind::BITVECTOR_SHL, { x532,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,sz533 }) }), x532, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_1, { x534, amount535, sz536, en537 }, nm->mkNode(Kind::BITVECTOR_SHL, { x534,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount535,sz536 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),en537,e791,x534 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,amount535 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount535,e858 }),nm->mkNode(Kind::EQUAL, { en537,nm->mkNode(Kind::SUB, { e858,nm->mkNode(Kind::ADD, { e787,amount535 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SHL_BY_CONST_2, { x538, amount539, sz540, w541 }, nm->mkNode(Kind::BITVECTOR_SHL, { x538,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount539,sz540 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,w541 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { amount539,e857 }),nm->mkNode(Kind::EQUAL, { w541,e857 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_0, { x542, sz543 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x542,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,sz543 }) }), x542, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_1, { x544, amount545, sz546, nm1547 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x544,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount545,sz546 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,amount545 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1547,amount545,x544 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount545,e856 }),nm->mkNode(Kind::EQUAL, { nm1547,nm->mkNode(Kind::SUB, { e856,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_LSHR_BY_CONST_2, { x548, amount549, sz550 }, nm->mkNode(Kind::BITVECTOR_LSHR, { x548,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount549,sz550 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,sz550 }), nm->mkNode(Kind::GEQ, { amount549,nm->mkNode(Kind::BITVECTOR_SIZE, { x548 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_0, { x551, sz552 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x551,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,sz552 }) }), x551, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_1, { x553, amount554, sz555, nm1556 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x553,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount554,sz555 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),amount554,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1556,nm1556,x553 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1556,amount554,x553 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { amount554,e855 }),nm->mkNode(Kind::EQUAL, { nm1556,nm->mkNode(Kind::SUB, { e855,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ASHR_BY_CONST_2, { x557, amount558, sz559, nm1560, rn561 }, nm->mkNode(Kind::BITVECTOR_ASHR, { x557,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { amount558,sz559 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),rn561,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1560,nm1560,x557 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { amount558,e854 }),nm->mkNode(Kind::EQUAL, { nm1560,nm->mkNode(Kind::SUB, { e854,e787 }) }),nm->mkNode(Kind::EQUAL, { rn561,e854 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_AND_CONCAT_PULLUP, { xs562, ws563, y564, z565, ys566, nxm1567, ny568, nym1569 }, nm->mkNode(Kind::BITVECTOR_AND, { xs562,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys566,z565,y564 }),ws563 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1567,ny568,e852 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys566,z565 }) }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1569,e791,e852 }),y564 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny568,e853 }),nm->mkNode(Kind::EQUAL, { nxm1567,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e852 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1569,nm->mkNode(Kind::SUB, { e853,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_OR_CONCAT_PULLUP, { xs570, ws571, y572, z573, ys574, nxm1575, ny576, nym1577 }, nm->mkNode(Kind::BITVECTOR_OR, { xs570,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys574,z573,y572 }),ws571 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1575,ny576,e850 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys574,z573 }) }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1577,e791,e850 }),y572 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny576,e851 }),nm->mkNode(Kind::EQUAL, { nxm1575,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e850 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1577,nm->mkNode(Kind::SUB, { e851,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_CONCAT_PULLUP, { xs578, ws579, y580, z581, ys582, nxm1583, ny584, nym1585 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs578,nm->mkNode(Kind::BITVECTOR_CONCAT, { ys582,z581,y580 }),ws579 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1583,ny584,e848 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { ys582,z581 }) }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1585,e791,e848 }),y580 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny584,e849 }),nm->mkNode(Kind::EQUAL, { nxm1583,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e848 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1585,nm->mkNode(Kind::SUB, { e849,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_AND_CONCAT_PULLUP2, { xs586, ws587, y588, z589, ys590, nxm1591, ny592, nym1593 }, nm->mkNode(Kind::BITVECTOR_AND, { xs586,nm->mkNode(Kind::BITVECTOR_CONCAT, { z589,y588,ys590 }),ws587 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1591,ny592,e845 }),z589 }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1593,e791,e845 }),e846 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny592,e847 }),nm->mkNode(Kind::EQUAL, { nxm1591,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e845 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1593,nm->mkNode(Kind::SUB, { e847,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_OR_CONCAT_PULLUP2, { xs594, ws595, y596, z597, ys598, nxm1599, ny600, nym1601 }, nm->mkNode(Kind::BITVECTOR_OR, { xs594,nm->mkNode(Kind::BITVECTOR_CONCAT, { z597,y596,ys598 }),ws595 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1599,ny600,e842 }),z597 }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1601,e791,e842 }),e843 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny600,e844 }),nm->mkNode(Kind::EQUAL, { nxm1599,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e842 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1601,nm->mkNode(Kind::SUB, { e844,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_CONCAT_PULLUP2, { xs602, ws603, y604, z605, ys606, nxm1607, ny608, nym1609 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs602,nm->mkNode(Kind::BITVECTOR_CONCAT, { z605,y604,ys606 }),ws603 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1607,ny608,e839 }),z605 }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nym1609,e791,e839 }),e840 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ny608,e841 }),nm->mkNode(Kind::EQUAL, { nxm1607,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e839 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nym1609,nm->mkNode(Kind::SUB, { e841,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_AND_CONCAT_PULLUP3, { xs610, ws611, y612, z613, u614, nxm1615, nyu616, nyum1617, nu618, num1619 }, nm->mkNode(Kind::BITVECTOR_AND, { xs610,nm->mkNode(Kind::BITVECTOR_CONCAT, { z613,y612,u614 }),ws611 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1615,nyu616,e836 }),z613 }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nyum1617,nu618,e836 }),y612 }),nm->mkNode(Kind::BITVECTOR_AND, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),num1619,e791,e836 }),u614 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nxm1615,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e836 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nyu616,e838 }),nm->mkNode(Kind::EQUAL, { nyum1617,nm->mkNode(Kind::SUB, { e838,e787 }) }),nm->mkNode(Kind::EQUAL, { nu618,e837 }),nm->mkNode(Kind::EQUAL, { num1619,nm->mkNode(Kind::SUB, { e837,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_OR_CONCAT_PULLUP3, { xs620, ws621, y622, z623, u624, nxm1625, nyu626, nyum1627, nu628, num1629 }, nm->mkNode(Kind::BITVECTOR_OR, { xs620,nm->mkNode(Kind::BITVECTOR_CONCAT, { z623,y622,u624 }),ws621 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1625,nyu626,e833 }),z623 }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nyum1627,nu628,e833 }),y622 }),nm->mkNode(Kind::BITVECTOR_OR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),num1629,e791,e833 }),u624 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nxm1625,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e833 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nyu626,e835 }),nm->mkNode(Kind::EQUAL, { nyum1627,nm->mkNode(Kind::SUB, { e835,e787 }) }),nm->mkNode(Kind::EQUAL, { nu628,e834 }),nm->mkNode(Kind::EQUAL, { num1629,nm->mkNode(Kind::SUB, { e834,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_CONCAT_PULLUP3, { xs630, ws631, y632, z633, u634, nxm1635, nyu636, nyum1637, nu638, num1639 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs630,nm->mkNode(Kind::BITVECTOR_CONCAT, { z633,y632,u634 }),ws631 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nxm1635,nyu636,e830 }),z633 }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nyum1637,nu638,e830 }),y632 }),nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),num1639,e791,e830 }),u634 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nxm1635,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e830 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nyu636,e832 }),nm->mkNode(Kind::EQUAL, { nyum1637,nm->mkNode(Kind::SUB, { e832,e787 }) }),nm->mkNode(Kind::EQUAL, { nu638,e831 }),nm->mkNode(Kind::EQUAL, { num1639,nm->mkNode(Kind::SUB, { e831,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_DUPLICATE, { x640, w641 }, nm->mkNode(Kind::BITVECTOR_XOR, { x640,x640 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,w641 }), nm->mkNode(Kind::EQUAL, { w641,nm->mkNode(Kind::BITVECTOR_SIZE, { x640 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_ONES, { xs642, zs643, n644, w645 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs642,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n644,w645 }),zs643 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs642,zs643 }) }), nm->mkNode(Kind::EQUAL, { n644,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { w645 }),e787 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_NOT, { x646, y647 }, nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x646 }),nm->mkNode(Kind::BITVECTOR_NOT, { y647 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { x646,y647 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NOT_IDEMP, { x648 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_NOT, { x648 }) }), x648, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_ZERO_1, { x649, n650 }, nm->mkNode(Kind::BITVECTOR_ULT, { e829,x649 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { x649,e829 }) }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_ZERO_2, { x651, n652 }, nm->mkNode(Kind::BITVECTOR_ULT, { x651,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,n652 }) }), e828, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_SELF, { x653 }, nm->mkNode(Kind::BITVECTOR_ULT, { x653,x653 }), e828, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_LT_SELF, { x654 }, nm->mkNode(Kind::BITVECTOR_SLT, { x654,x654 }), e828, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULE_SELF, { x655 }, nm->mkNode(Kind::BITVECTOR_ULE, { x655,x655 }), e815, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULE_ZERO, { x656, n657 }, nm->mkNode(Kind::BITVECTOR_ULE, { x656,e827 }), nm->mkNode(Kind::EQUAL, { x656,e827 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_ULE, { x658, n659 }, nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,n659 }),x658 }), e815, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SLE_SELF, { x660 }, nm->mkNode(Kind::BITVECTOR_SLE, { x660,x660 }), e815, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULE_MAX, { x661, n662, w663 }, nm->mkNode(Kind::BITVECTOR_ULE, { x661,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n662,w663 }) }), e815, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { w663,e826 }),nm->mkNode(Kind::EQUAL, { n662,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { e826 }),e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NOT_ULT, { x664, y665 }, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { x664,y665 }) }), nm->mkNode(Kind::BITVECTOR_ULE, { y665,x664 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MULT_POW2_1, { xs666, ys667, z668, size669, n670, exponent671, u672 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs666,z668,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n670,size669 }),ys667 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u672,e791,nm->mkNode(Kind::BITVECTOR_MULT, { xs666,z668,ys667 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,exponent671 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { n670 }),nm->mkNode(Kind::EQUAL, { exponent671,e825 }),nm->mkNode(Kind::EQUAL, { u672,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size669,e825 }),e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MULT_POW2_2, { xs673, ys674, z675, size676, n677, exponent678, u679 }, nm->mkNode(Kind::BITVECTOR_MULT, { xs673,z675,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n677,size676 }),ys674 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u679,e791,nm->mkNode(Kind::BITVECTOR_NEG, { nm->mkNode(Kind::BITVECTOR_MULT, { xs673,z675,ys674 }) }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,exponent678 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { e824 }),nm->mkNode(Kind::EQUAL, { exponent678,e823 }),nm->mkNode(Kind::EQUAL, { u679,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size676,e823 }),e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MULT_POW2_2B, { z680, size681, n682, exponent683, u684 }, nm->mkNode(Kind::BITVECTOR_MULT, { z680,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n682,size681 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u684,e791,nm->mkNode(Kind::BITVECTOR_NEG, { z680 }) }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,exponent683 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { e822 }),nm->mkNode(Kind::EQUAL, { exponent683,e821 }),nm->mkNode(Kind::EQUAL, { u684,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { size681,e821 }),e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_MULT_LEADING_BIT, { high685, low686, x1i687, x1in688, x2689, y1i690, y1in691, y2692, w693 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high685,low686,nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { x1i687,x1in688 }),x2689 }),nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { y1i690,y1in691 }),y2692 }) }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,w693 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { e820,nm->mkConstInt(Rational(64)) }),nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::MULT, { nm->mkConstInt(Rational(2)),e820 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x1i687,e791 }),x1in688,nm->mkNode(Kind::SUB, { x1in688,nm->mkNode(Kind::ADD, { e787,nm->mkNode(Kind::INTS_LOG2, { x1i687 }) }) }) }),nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { y1i690,e791 }),y1in691,nm->mkNode(Kind::SUB, { y1in691,nm->mkNode(Kind::ADD, { e787,nm->mkNode(Kind::INTS_LOG2, { y1i690 }) }) }) }) }) }),low686 }),nm->mkNode(Kind::EQUAL, { w693,nm->mkNode(Kind::ADD, { e787,nm->mkNode(Kind::SUB, { high685,low686 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UDIV_POW2_NOT_ONE, { x694, v695, n696, power697, nm1698 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x694,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v695,n696 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,power697 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1698,power697,x694 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v695 }),nm->mkNode(Kind::GT, { v695,e787 }),nm->mkNode(Kind::EQUAL, { power697,nm->mkNode(Kind::INTS_LOG2, { v695 }) }),nm->mkNode(Kind::EQUAL, { nm1698,nm->mkNode(Kind::SUB, { n696,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UDIV_ZERO, { x699, n700 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x699,e819 }), nm->mkNode(Kind::BITVECTOR_NOT, { e819 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UDIV_ONE, { x701, n702 }, nm->mkNode(Kind::BITVECTOR_UDIV, { x701,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,n702 }) }), x701, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UREM_POW2_NOT_ONE, { x703, v704, n705, nmp706, pm1707 }, nm->mkNode(Kind::BITVECTOR_UREM, { x703,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { v704,n705 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,nmp706 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),pm1707,e791,x703 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::INTS_ISPOW2, { v704 }),nm->mkNode(Kind::GT, { v704,e787 }),nm->mkNode(Kind::EQUAL, { nmp706,nm->mkNode(Kind::SUB, { n705,e818 }) }),nm->mkNode(Kind::EQUAL, { pm1707,nm->mkNode(Kind::SUB, { e818,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UREM_ONE, { x708, n709 }, nm->mkNode(Kind::BITVECTOR_UREM, { x708,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,n709 }) }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,n709 }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UREM_SELF, { x710, w711 }, nm->mkNode(Kind::BITVECTOR_UREM, { x710,x710 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,w711 }), nm->mkNode(Kind::EQUAL, { w711,nm->mkNode(Kind::BITVECTOR_SIZE, { x710 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SHL_ZERO, { a712, n713 }, nm->mkNode(Kind::BITVECTOR_SHL, { e817,a712 }), e817, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_LSHR_ZERO, { a714, n715 }, nm->mkNode(Kind::BITVECTOR_LSHR, { e816,a714 }), e816, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ASHR_ZERO, { a716, n717 }, nm->mkNode(Kind::BITVECTOR_ASHR, { e814,a716 }), e814, e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_UGT_UREM, { y718, x719, w720 }, nm->mkNode(Kind::BITVECTOR_UGT, { nm->mkNode(Kind::BITVECTOR_UREM, { y718,x719 }),x719 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x719,e813 }),nm->mkNode(Kind::BITVECTOR_UGT, { y718,e813 }) }), nm->mkNode(Kind::EQUAL, { w720,nm->mkNode(Kind::BITVECTOR_SIZE, { y718 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_ONE, { x721, n722 }, nm->mkNode(Kind::BITVECTOR_ULT, { x721,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,n722 }) }), nm->mkNode(Kind::EQUAL, { x721,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,n722 }) }), e815, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_1, { x723, i724, j725, k726 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i724,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),j725,x723 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k726,x723 }), nm->mkNode(Kind::EQUAL, { k726,nm->mkNode(Kind::ADD, { i724,j725 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MERGE_SIGN_EXTEND_2, { x727, i728, j729, k730 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),i728,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),j729,x727 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),k730,x727 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { j729,e791 }),nm->mkNode(Kind::EQUAL, { k730,nm->mkNode(Kind::ADD, { i728,j729 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_1, { x731, m732, c733, nm734, mp1735, nm1736, nmm1737 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m732,x731 }),e810 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e812,e811 }),nm->mkNode(Kind::EQUAL, { e812,nm->mkNode(Kind::BITVECTOR_NOT, { e811 }) }) }),nm->mkNode(Kind::EQUAL, { x731,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1736,e791,e810 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { mp1735,nm->mkNode(Kind::ADD, { m732,e787 }) }),nm->mkNode(Kind::EQUAL, { nm1736,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x731 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nmm1737,nm->mkNode(Kind::SUB, { nm734,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_EQ_CONST_2, { x738, m739, c740, nm741, mp1742, nm1743, nmm1744 }, nm->mkNode(Kind::EQUAL, { e807,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m739,x738 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { e809,e808 }),nm->mkNode(Kind::EQUAL, { e809,nm->mkNode(Kind::BITVECTOR_NOT, { e808 }) }) }),nm->mkNode(Kind::EQUAL, { x738,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1743,e791,e807 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { mp1742,nm->mkNode(Kind::ADD, { m739,e787 }) }),nm->mkNode(Kind::EQUAL, { nm1743,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x738 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nmm1744,nm->mkNode(Kind::SUB, { nm741,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_1, { x745, m746, c747, nm748, nm1749, nmm1750 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m746,x745 }),e806 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1750,nm1749,e806 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,m746 }) }),nm->mkNode(Kind::EQUAL, { x745,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1749,e791,e806 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1749,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x745 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nmm1750,nm->mkNode(Kind::SUB, { nm748,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_EQ_CONST_2, { x751, m752, c753, nm754, nm1755, nmm1756 }, nm->mkNode(Kind::EQUAL, { e805,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m752,x751 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nmm1756,nm1755,e805 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,m752 }) }),nm->mkNode(Kind::EQUAL, { x751,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1755,e791,e805 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1755,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x751 }),e787 }) }),nm->mkNode(Kind::EQUAL, { nmm1756,nm->mkNode(Kind::SUB, { nm754,e787 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ULT_CONST_1, { x757, m758, c759, nm760, nm1761 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m758,x757 }),e803 }), nm->mkNode(Kind::BITVECTOR_ULT, { x757,e804 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1761,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x757 }),e787 }) }),nm->mkNode(Kind::EQUAL, { e803,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m758,e804 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ULT_CONST_2, { x762, m763, c764, nm765, nm1766 }, nm->mkNode(Kind::BITVECTOR_ULT, { e801,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m763,x762 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { e802,x762 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm1766,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x762 }),e787 }) }),nm->mkNode(Kind::EQUAL, { e801,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),m763,e802 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_1, { x767, m768, c769, nm770, nm1771 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m768,x767 }),e798 }), nm->mkNode(Kind::BITVECTOR_ULT, { x767,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1771,e791,e798 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULE, { e798,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,nm770 }),e800 }) }),nm->mkNode(Kind::BITVECTOR_UGE, { e798,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,nm770 }) }),e800 }) }) }),nm->mkNode(Kind::EQUAL, { nm1771,e799 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_2, { x772, m773, c774, nm775, nm1776 }, nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m773,x772 }),e796 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1776,nm1776,x772 }),e859 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,nm775 }),e797 }),e796 }),nm->mkNode(Kind::BITVECTOR_ULE, { e796,nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,nm775 }) }),e797 }) }),nm->mkNode(Kind::EQUAL, { nm1776,e795 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_3, { x777, m778, c779, nm780, nm1781 }, nm->mkNode(Kind::BITVECTOR_ULT, { e792,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m778,x777 }) }), nm->mkNode(Kind::BITVECTOR_ULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1781,e791,e792 }),x777 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::OR, { nm->mkNode(Kind::BITVECTOR_ULT, { e792,e794 }),nm->mkNode(Kind::BITVECTOR_UGE, { e792,nm->mkNode(Kind::BITVECTOR_NOT, { e794 }) }) }),nm->mkNode(Kind::EQUAL, { nm1781,e793 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ULT_CONST_4, { x782, m783, c784, nm785, nm1786 }, nm->mkNode(Kind::BITVECTOR_ULT, { e789,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m783,x782 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1786,nm1786,x782 }),e860 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::BITVECTOR_ULE, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e791,nm785 }) }),e790 }) }),e789 }),nm->mkNode(Kind::BITVECTOR_ULE, { e789,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_SHL, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e787,nm785 }),e790 }) }) }),nm->mkNode(Kind::EQUAL, { nm1786,e788 }) }), Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
