/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_bv_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node xs229 = NodeManager::mkBoundVar("xs229", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs229);
Node s230 = NodeManager::mkBoundVar("s230", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys231 = NodeManager::mkBoundVar("ys231", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys231);
Node i232 = NodeManager::mkBoundVar("i232", nm->integerType());
Node j233 = NodeManager::mkBoundVar("j233", nm->integerType());
Node j1234 = NodeManager::mkBoundVar("j1234", nm->integerType());
Node k235 = NodeManager::mkBoundVar("k235", nm->integerType());
Node x236 = NodeManager::mkBoundVar("x236", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i237 = NodeManager::mkBoundVar("i237", nm->integerType());
Node j238 = NodeManager::mkBoundVar("j238", nm->integerType());
Node k239 = NodeManager::mkBoundVar("k239", nm->integerType());
Node l240 = NodeManager::mkBoundVar("l240", nm->integerType());
Node ll241 = NodeManager::mkBoundVar("ll241", nm->integerType());
Node kk242 = NodeManager::mkBoundVar("kk242", nm->integerType());
Node x243 = NodeManager::mkBoundVar("x243", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n244 = NodeManager::mkBoundVar("n244", nm->integerType());
Node x245 = NodeManager::mkBoundVar("x245", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs246 = NodeManager::mkBoundVar("xs246", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs246);
Node y247 = NodeManager::mkBoundVar("y247", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i248 = NodeManager::mkBoundVar("i248", nm->integerType());
Node j249 = NodeManager::mkBoundVar("j249", nm->integerType());
Node x250 = NodeManager::mkBoundVar("x250", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs251 = NodeManager::mkBoundVar("xs251", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs251);
Node y252 = NodeManager::mkBoundVar("y252", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i253 = NodeManager::mkBoundVar("i253", nm->integerType());
Node j254 = NodeManager::mkBoundVar("j254", nm->integerType());
Node u1255 = NodeManager::mkBoundVar("u1255", nm->integerType());
Node u2256 = NodeManager::mkBoundVar("u2256", nm->integerType());
Node x257 = NodeManager::mkBoundVar("x257", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y258 = NodeManager::mkBoundVar("y258", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs259 = NodeManager::mkBoundVar("xs259", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs259);
Node i260 = NodeManager::mkBoundVar("i260", nm->integerType());
Node j261 = NodeManager::mkBoundVar("j261", nm->integerType());
Node u2262 = NodeManager::mkBoundVar("u2262", nm->integerType());
Node l2263 = NodeManager::mkBoundVar("l2263", nm->integerType());
Node x264 = NodeManager::mkBoundVar("x264", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y265 = NodeManager::mkBoundVar("y265", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs266 = NodeManager::mkBoundVar("xs266", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs266);
Node i267 = NodeManager::mkBoundVar("i267", nm->integerType());
Node j268 = NodeManager::mkBoundVar("j268", nm->integerType());
Node x269 = NodeManager::mkBoundVar("x269", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y270 = NodeManager::mkBoundVar("y270", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i271 = NodeManager::mkBoundVar("i271", nm->integerType());
Node j272 = NodeManager::mkBoundVar("j272", nm->integerType());
Node wm1273 = NodeManager::mkBoundVar("wm1273", nm->integerType());
Node jp1274 = NodeManager::mkBoundVar("jp1274", nm->integerType());
Node im1275 = NodeManager::mkBoundVar("im1275", nm->integerType());
Node x276 = NodeManager::mkBoundVar("x276", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y277 = NodeManager::mkBoundVar("y277", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node j278 = NodeManager::mkBoundVar("j278", nm->integerType());
Node wm1279 = NodeManager::mkBoundVar("wm1279", nm->integerType());
Node jp1280 = NodeManager::mkBoundVar("jp1280", nm->integerType());
Node x281 = NodeManager::mkBoundVar("x281", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y282 = NodeManager::mkBoundVar("y282", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i283 = NodeManager::mkBoundVar("i283", nm->integerType());
Node j284 = NodeManager::mkBoundVar("j284", nm->integerType());
Node im1285 = NodeManager::mkBoundVar("im1285", nm->integerType());
Node x286 = NodeManager::mkBoundVar("x286", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node i287 = NodeManager::mkBoundVar("i287", nm->integerType());
Node j288 = NodeManager::mkBoundVar("j288", nm->integerType());
Node x289 = NodeManager::mkBoundVar("x289", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low290 = NodeManager::mkBoundVar("low290", nm->integerType());
Node high291 = NodeManager::mkBoundVar("high291", nm->integerType());
Node k292 = NodeManager::mkBoundVar("k292", nm->integerType());
Node x293 = NodeManager::mkBoundVar("x293", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low294 = NodeManager::mkBoundVar("low294", nm->integerType());
Node high295 = NodeManager::mkBoundVar("high295", nm->integerType());
Node k296 = NodeManager::mkBoundVar("k296", nm->integerType());
Node nm1297 = NodeManager::mkBoundVar("nm1297", nm->integerType());
Node sn298 = NodeManager::mkBoundVar("sn298", nm->integerType());
Node x299 = NodeManager::mkBoundVar("x299", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node low300 = NodeManager::mkBoundVar("low300", nm->integerType());
Node high301 = NodeManager::mkBoundVar("high301", nm->integerType());
Node k302 = NodeManager::mkBoundVar("k302", nm->integerType());
Node rn303 = NodeManager::mkBoundVar("rn303", nm->integerType());
Node nm1304 = NodeManager::mkBoundVar("nm1304", nm->integerType());
Node x1305 = NodeManager::mkBoundVar("x1305", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x2306 = NodeManager::mkBoundVar("x2306", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs307 = NodeManager::mkBoundVar("xs307", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs307);
Node xs308 = NodeManager::mkBoundVar("xs308", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs308);
Node ys309 = NodeManager::mkBoundVar("ys309", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys309);
Node zs310 = NodeManager::mkBoundVar("zs310", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs310);
Node x311 = NodeManager::mkBoundVar("x311", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w312 = NodeManager::mkBoundVar("w312", nm->integerType());
Node xs313 = NodeManager::mkBoundVar("xs313", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs313);
Node ys314 = NodeManager::mkBoundVar("ys314", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys314);
Node zs315 = NodeManager::mkBoundVar("zs315", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs315);
Node x316 = NodeManager::mkBoundVar("x316", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w317 = NodeManager::mkBoundVar("w317", nm->integerType());
Node xs318 = NodeManager::mkBoundVar("xs318", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs318);
Node ys319 = NodeManager::mkBoundVar("ys319", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys319);
Node zs320 = NodeManager::mkBoundVar("zs320", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs320);
Node x321 = NodeManager::mkBoundVar("x321", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w322 = NodeManager::mkBoundVar("w322", nm->integerType());
Node xs323 = NodeManager::mkBoundVar("xs323", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs323);
Node ys324 = NodeManager::mkBoundVar("ys324", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys324);
Node zs325 = NodeManager::mkBoundVar("zs325", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs325);
Node x326 = NodeManager::mkBoundVar("x326", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w327 = NodeManager::mkBoundVar("w327", nm->integerType());
Node xs328 = NodeManager::mkBoundVar("xs328", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs328);
Node ys329 = NodeManager::mkBoundVar("ys329", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys329);
Node zs330 = NodeManager::mkBoundVar("zs330", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs330);
Node x331 = NodeManager::mkBoundVar("x331", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t387 = NodeManager::mkBoundVar("t387", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs332 = NodeManager::mkBoundVar("xs332", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs332);
Node ys333 = NodeManager::mkBoundVar("ys333", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys333);
Node zs334 = NodeManager::mkBoundVar("zs334", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs334);
Node x335 = NodeManager::mkBoundVar("x335", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node xs336 = NodeManager::mkBoundVar("xs336", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs336);
Node ys337 = NodeManager::mkBoundVar("ys337", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys337);
Node zs338 = NodeManager::mkBoundVar("zs338", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs338);
Node x339 = NodeManager::mkBoundVar("x339", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x340 = NodeManager::mkBoundVar("x340", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node ys341 = NodeManager::mkBoundVar("ys341", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(ys341);
Node zs342 = NodeManager::mkBoundVar("zs342", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs342);
Node c1343 = NodeManager::mkBoundVar("c1343", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w344 = NodeManager::mkBoundVar("w344", nm->integerType());
Node x345 = NodeManager::mkBoundVar("x345", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y346 = NodeManager::mkBoundVar("y346", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a347 = NodeManager::mkBoundVar("a347", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n348 = NodeManager::mkBoundVar("n348", nm->integerType());
Node m349 = NodeManager::mkBoundVar("m349", nm->integerType());
Node tn350 = NodeManager::mkBoundVar("tn350", nm->integerType());
Node an351 = NodeManager::mkBoundVar("an351", nm->integerType());
Node x352 = NodeManager::mkBoundVar("x352", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y353 = NodeManager::mkBoundVar("y353", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node a354 = NodeManager::mkBoundVar("a354", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n355 = NodeManager::mkBoundVar("n355", nm->integerType());
Node m356 = NodeManager::mkBoundVar("m356", nm->integerType());
Node tn357 = NodeManager::mkBoundVar("tn357", nm->integerType());
Node an358 = NodeManager::mkBoundVar("an358", nm->integerType());
Node x359 = NodeManager::mkBoundVar("x359", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y360 = NodeManager::mkBoundVar("y360", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x361 = NodeManager::mkBoundVar("x361", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y362 = NodeManager::mkBoundVar("y362", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x363 = NodeManager::mkBoundVar("x363", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x364 = NodeManager::mkBoundVar("x364", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x365 = NodeManager::mkBoundVar("x365", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x366 = NodeManager::mkBoundVar("x366", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n367 = NodeManager::mkBoundVar("n367", nm->integerType());
Node w368 = NodeManager::mkBoundVar("w368", nm->integerType());
Node xs369 = NodeManager::mkBoundVar("xs369", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(xs369);
Node n1370 = NodeManager::mkBoundVar("n1370", nm->integerType());
Node w1371 = NodeManager::mkBoundVar("w1371", nm->integerType());
Node n2372 = NodeManager::mkBoundVar("n2372", nm->integerType());
Node w2373 = NodeManager::mkBoundVar("w2373", nm->integerType());
Node ww374 = NodeManager::mkBoundVar("ww374", nm->integerType());
Node zs375 = NodeManager::mkBoundVar("zs375", nm->mkAbstractType(Kind::BITVECTOR_TYPE));expr::markListVar(zs375);
Node x376 = NodeManager::mkBoundVar("x376", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y377 = NodeManager::mkBoundVar("y377", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x378 = NodeManager::mkBoundVar("x378", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y379 = NodeManager::mkBoundVar("y379", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x380 = NodeManager::mkBoundVar("x380", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x381 = NodeManager::mkBoundVar("x381", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x382 = NodeManager::mkBoundVar("x382", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y383 = NodeManager::mkBoundVar("y383", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node z384 = NodeManager::mkBoundVar("z384", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node x385 = NodeManager::mkBoundVar("x385", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node y386 = NodeManager::mkBoundVar("y386", nm->mkAbstractType(Kind::BITVECTOR_TYPE));

  // Definitions
Node e388 = nm->mkConst(true);
Node e389 = nm->mkConstInt(Rational(1));
Node e390 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),nm->mkConstInt(Rational(1)) });
Node e391 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(1)),nm->mkConstInt(Rational(1)) });
Node e392 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n367,w368 });
Node e393 = nm->mkConstInt(Rational(0));
Node e394 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),an358 });
Node e395 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m356,a354 });
Node e396 = nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkConstInt(Rational(0)),an351 });
Node e397 = nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),m349,a347 });
Node e398 = nm->mkNode(Kind::BITVECTOR_ADD, { ys341,zs342 });
Node e399 = nm->mkNode(Kind::BITVECTOR_SIZE, { x299 });
Node e400 = nm->mkNode(Kind::BITVECTOR_SIZE, { x293 });
Node e401 = nm->mkNode(Kind::BITVECTOR_CONCAT, { x264,xs266,y265 });
Node e402 = nm->mkNode(Kind::BITVECTOR_SIZE, { x257 });
Node e403 = nm->mkNode(Kind::BITVECTOR_SIZE, { x250 });

  // Rules

        {
            // from rewrites-bv-rewrites.cpp
            db.addRule(ProofRewriteRule::BV_CONCAT_EXTRACT_MERGE, { xs229, s230, ys231, i232, j233, j1234, k235 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs229,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k235,j1234,s230 }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j233,i232,s230 }),ys231 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs229,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),k235,i232,s230 }),ys231 }), nm->mkNode(Kind::EQUAL, { j1234,nm->mkNode(Kind::ADD, { j233,e389 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_EXTRACT, { x236, i237, j238, k239, l240, ll241, kk242 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),l240,k239,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j238,i237,x236 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),ll241,kk242,x236 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { ll241,nm->mkNode(Kind::ADD, { i237,l240 }) }),nm->mkNode(Kind::EQUAL, { kk242,nm->mkNode(Kind::ADD, { i237,k239 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_WHOLE, { x243, n244 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),n244,e393,x243 }), x243, nm->mkNode(Kind::GEQ, { n244,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x243 }),e389 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_1, { x245, xs246, y247, i248, j249 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j249,i248,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs246,y247,x245 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j249,i248,x245 }), nm->mkNode(Kind::LEQ, { j249,nm->mkNode(Kind::BITVECTOR_SIZE, { x245 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_2, { x250, xs251, y252, i253, j254, u1255, u2256 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j254,i253,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs251,y252,x250 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u1255,e393,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs251,y252 }) }),nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2256,i253,x250 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { i253,e403 }),nm->mkNode(Kind::GEQ, { j254,e403 }),nm->mkNode(Kind::EQUAL, { u1255,nm->mkNode(Kind::SUB, { j254,e403 }) }),nm->mkNode(Kind::EQUAL, { u2256,nm->mkNode(Kind::SUB, { e403,e389 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_3, { x257, y258, xs259, i260, j261, u2262, l2263 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j261,i260,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs259,y258,x257 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),u2262,l2263,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs259,y258 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { i260,e402 }),nm->mkNode(Kind::EQUAL, { u2262,nm->mkNode(Kind::SUB, { j261,e402 }) }),nm->mkNode(Kind::EQUAL, { l2263,nm->mkNode(Kind::SUB, { i260,e402 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_CONCAT_4, { x264, y265, xs266, i267, j268 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j268,i267,e401 }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j268,i267,nm->mkNode(Kind::BITVECTOR_CONCAT, { xs266,y265 }) }), nm->mkNode(Kind::LT, { j268,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { e401 }),nm->mkNode(Kind::BITVECTOR_SIZE, { x264 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM1, { x269, y270, i271, j272, wm1273, jp1274, im1275 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j272,i271,x269 }),y270 }), nm->mkNode(Kind::EQUAL, { x269,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1273,jp1274,x269 }),y270,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),im1275,e393,x269 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1273,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x269 }),e389 }) }),nm->mkNode(Kind::EQUAL, { jp1274,nm->mkNode(Kind::ADD, { j272,e389 }) }),nm->mkNode(Kind::EQUAL, { im1275,nm->mkNode(Kind::SUB, { i271,e389 }) }),nm->mkNode(Kind::GT, { wm1273,j272 }),nm->mkNode(Kind::GT, { i271,e393 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM2, { x276, y277, j278, wm1279, jp1280 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j278,e393,x276 }),y277 }), nm->mkNode(Kind::EQUAL, { x276,nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm1279,jp1280,x276 }),y277 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm1279,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x276 }),e389 }) }),nm->mkNode(Kind::EQUAL, { jp1280,nm->mkNode(Kind::ADD, { j278,e389 }) }),nm->mkNode(Kind::GT, { wm1279,j278 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EQ_EXTRACT_ELIM3, { x281, y282, i283, j284, im1285 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j284,i283,x281 }),y282 }), nm->mkNode(Kind::EQUAL, { x281,nm->mkNode(Kind::BITVECTOR_CONCAT, { y282,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),im1285,e393,x281 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { j284,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::BITVECTOR_SIZE, { x281 }),e389 }) }),nm->mkNode(Kind::EQUAL, { im1285,nm->mkNode(Kind::SUB, { i283,e389 }) }),nm->mkNode(Kind::GT, { i283,e393 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_NOT, { x286, i287, j288 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j288,i287,nm->mkNode(Kind::BITVECTOR_NOT, { x286 }) }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),j288,i287,x286 }) }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_1, { x289, low290, high291, k292 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high291,low290,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k292,x289 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high291,low290,x289 }), nm->mkNode(Kind::LT, { high291,nm->mkNode(Kind::BITVECTOR_SIZE, { x289 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_2, { x293, low294, high295, k296, nm1297, sn298 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high295,low294,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k296,x293 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),sn298,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1297,low294,x293 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { low294,e400 }),nm->mkNode(Kind::GEQ, { high295,e400 }),nm->mkNode(Kind::EQUAL, { nm1297,nm->mkNode(Kind::SUB, { e400,e389 }) }),nm->mkNode(Kind::EQUAL, { sn298,nm->mkNode(Kind::ADD, { e389,nm->mkNode(Kind::SUB, { high295,e400 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EXTRACT_SIGN_EXTEND_3, { x299, low300, high301, k302, rn303, nm1304 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),high301,low300,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),k302,x299 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_REPEAT)),rn303,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),nm1304,nm1304,x299 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { low300,e399 }),nm->mkNode(Kind::EQUAL, { rn303,nm->mkNode(Kind::ADD, { e389,nm->mkNode(Kind::SUB, { high301,low300 }) }) }),nm->mkNode(Kind::EQUAL, { nm1304,nm->mkNode(Kind::SUB, { e399,e389 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NOT_XOR, { x1305, x2306, xs307 }, nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { x1305,x2306,xs307 }) }), nm->mkNode(Kind::BITVECTOR_XOR, { nm->mkNode(Kind::BITVECTOR_NOT, { x1305 }),x2306,xs307 }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_1, { xs308, ys309, zs310, x311, w312 }, nm->mkNode(Kind::BITVECTOR_AND, { xs308,nm->mkNode(Kind::BITVECTOR_NOT, { x311 }),ys309,x311,zs310 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,w312 }), nm->mkNode(Kind::EQUAL, { w312,nm->mkNode(Kind::BITVECTOR_SIZE, { x311 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_AND_SIMPLIFY_2, { xs313, ys314, zs315, x316, w317 }, nm->mkNode(Kind::BITVECTOR_AND, { xs313,x316,ys314,nm->mkNode(Kind::BITVECTOR_NOT, { x316 }),zs315 }), nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,w317 }), nm->mkNode(Kind::EQUAL, { w317,nm->mkNode(Kind::BITVECTOR_SIZE, { x316 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_1, { xs318, ys319, zs320, x321, w322 }, nm->mkNode(Kind::BITVECTOR_OR, { xs318,nm->mkNode(Kind::BITVECTOR_NOT, { x321 }),ys319,x321,zs320 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,w322 }) }), nm->mkNode(Kind::EQUAL, { w322,nm->mkNode(Kind::BITVECTOR_SIZE, { x321 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_OR_SIMPLIFY_2, { xs323, ys324, zs325, x326, w327 }, nm->mkNode(Kind::BITVECTOR_OR, { xs323,x326,ys324,nm->mkNode(Kind::BITVECTOR_NOT, { x326 }),zs325 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,w327 }) }), nm->mkNode(Kind::EQUAL, { w327,nm->mkNode(Kind::BITVECTOR_SIZE, { x326 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_1, { xs328, ys329, zs330, x331 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs328,x331,ys329,x331,zs330 }), nm->mkNode(Kind::BITVECTOR_XOR, { xs328,ys329,zs330 }), e388, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t387 }),t387 }), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_2, { xs332, ys333, zs334, x335 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs332,x335,ys333,nm->mkNode(Kind::BITVECTOR_NOT, { x335 }),zs334 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs332,ys333,zs334 }) }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_XOR_SIMPLIFY_3, { xs336, ys337, zs338, x339 }, nm->mkNode(Kind::BITVECTOR_XOR, { xs336,nm->mkNode(Kind::BITVECTOR_NOT, { x339 }),ys337,x339,zs338 }), nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::BITVECTOR_XOR, { xs336,ys337,zs338 }) }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_ADD_ONE, { x340, ys341, zs342, c1343, w344 }, nm->mkNode(Kind::BITVECTOR_ULT, { x340,nm->mkNode(Kind::BITVECTOR_ADD, { ys341,c1343,zs342 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { e398,nm->mkNode(Kind::BITVECTOR_NOT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,w344 }) }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::BITVECTOR_ULT, { e398,x340 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { c1343,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e389,w344 }) }),nm->mkNode(Kind::EQUAL, { w344,nm->mkNode(Kind::BITVECTOR_SIZE, { x340 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_1, { x345, y346, a347, n348, m349, tn350, an351 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n348,y346 }),e397 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),n348,x345 }),e397 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SUB, { y346,x345 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,tn350 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a347,e396 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SLT, { y346,x345 }),nm->mkNode(Kind::BITVECTOR_SGT, { a347,e396 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { tn350,nm->mkNode(Kind::BITVECTOR_SIZE, { x345 }) }),nm->mkNode(Kind::EQUAL, { an351,nm->mkNode(Kind::BITVECTOR_SIZE, { a347 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_MULT_SLT_MULT_2, { x352, y353, a354, n355, m356, tn357, an358 }, nm->mkNode(Kind::BITVECTOR_SLT, { nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n355,y353 }),e395 }),nm->mkNode(Kind::BITVECTOR_MULT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),n355,x352 }),e395 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SUB, { y353,x352 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e393,tn357 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { a354,e394 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_ULT, { y353,x352 }),nm->mkNode(Kind::BITVECTOR_SGT, { a354,e394 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { tn357,nm->mkNode(Kind::BITVECTOR_SIZE, { x352 }) }),nm->mkNode(Kind::EQUAL, { an358,nm->mkNode(Kind::BITVECTOR_SIZE, { a354 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_XOR, { x359, y360 }, nm->mkNode(Kind::BITVECTOR_XOR, { x359,y360 }), nm->mkNode(Kind::BITVECTOR_XOR, { y360,x359 }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_COMP, { x361, y362 }, nm->mkNode(Kind::BITVECTOR_COMP, { x361,y362 }), nm->mkNode(Kind::BITVECTOR_COMP, { y362,x361 }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ZERO_EXTEND_ELIMINATE_0, { x363 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_ZERO_EXTEND)),e393,x363 }), x363, e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SIGN_EXTEND_ELIMINATE_0, { x364 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_SIGN_EXTEND)),e393,x364 }), x364, e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_NOT_NEQ, { x365 }, nm->mkNode(Kind::EQUAL, { x365,nm->mkNode(Kind::BITVECTOR_NOT, { x365 }) }), nm->mkConst(false), nm->mkNode(Kind::GT, { nm->mkNode(Kind::BITVECTOR_SIZE, { x365 }),e393 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ULT_ONES, { x366, n367, w368 }, nm->mkNode(Kind::BITVECTOR_ULT, { x366,e392 }), nm->mkNode(Kind::DISTINCT, { x366,e392 }), nm->mkNode(Kind::EQUAL, { n367,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::POW2, { w368 }),e389 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_CONCAT_MERGE_CONST, { xs369, n1370, w1371, n2372, w2373, ww374, zs375 }, nm->mkNode(Kind::BITVECTOR_CONCAT, { xs369,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n1370,w1371 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { n2372,w2373 }),zs375 }), nm->mkNode(Kind::BITVECTOR_CONCAT, { xs369,nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::MULT, { n1370,nm->mkNode(Kind::POW2, { w2373 }) }),n2372 }),ww374 }),zs375 }), nm->mkNode(Kind::EQUAL, { ww374,nm->mkNode(Kind::ADD, { w1371,w2373 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_COMMUTATIVE_ADD, { x376, y377 }, nm->mkNode(Kind::BITVECTOR_ADD, { x376,y377 }), nm->mkNode(Kind::BITVECTOR_ADD, { y377,x376 }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_SUB_ELIMINATE, { x378, y379 }, nm->mkNode(Kind::BITVECTOR_SUB, { x378,y379 }), nm->mkNode(Kind::BITVECTOR_ADD, { x378,nm->mkNode(Kind::BITVECTOR_NEG, { y379 }) }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_WIDTH_ONE, { x380 }, nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x380,e391 }),e391,e390 }), x380, e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_ITE_WIDTH_ONE_NOT, { x381 }, nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { x381,e390 }),e391,e390 }), nm->mkNode(Kind::BITVECTOR_NOT, { x381 }), e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EQ_XOR_SOLVE, { x382, y383, z384 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_XOR, { x382,y383 }),z384 }),nm->mkNode(Kind::EQUAL, { x382,nm->mkNode(Kind::BITVECTOR_XOR, { z384,y383 }) }) }), e388, e388, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::BV_EQ_NOT_SOLVE, { x385, y386 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_NOT, { x385 }),y386 }),nm->mkNode(Kind::EQUAL, { x385,nm->mkNode(Kind::BITVECTOR_NOT, { y386 }) }) }), e388, e388, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
