/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_sets_rewrites_card(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x1443 = NodeManager::mkBoundVar("x1443", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1444 = NodeManager::mkBoundVar("s1444", nm->mkAbstractType(Kind::SET_TYPE));
Node t1445 = NodeManager::mkBoundVar("t1445", nm->mkAbstractType(Kind::SET_TYPE));
Node s1446 = NodeManager::mkBoundVar("s1446", nm->mkAbstractType(Kind::SET_TYPE));
Node t1447 = NodeManager::mkBoundVar("t1447", nm->mkAbstractType(Kind::SET_TYPE));
Node x1448 = NodeManager::mkBoundVar("x1448", nm->mkAbstractType(Kind::SET_TYPE));

  // Definitions
Node e1449 = nm->mkConst(true);

  // Rules

        {
            // from rewrites-sets-rewrites-card.cpp
            db.addRule(ProofRewriteRule::SETS_CARD_SINGLETON, { x1443 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_SINGLETON, { x1443 }) }), nm->mkConstInt(Rational(1)), e1449, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::SETS_CARD_UNION, { s1444, t1445 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_UNION, { s1444,t1445 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::ADD, { nm->mkNode(Kind::SET_CARD, { s1444 }),nm->mkNode(Kind::SET_CARD, { t1445 }) }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s1444,t1445 }) }) }), e1449, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::SETS_CARD_MINUS, { s1446, t1447 }, nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_MINUS, { s1446,t1447 }) }), nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SET_CARD, { s1446 }),nm->mkNode(Kind::SET_CARD, { nm->mkNode(Kind::SET_INTER, { s1446,t1447 }) }) }), e1449, Node::null(), Level::EXPERT);
db.addRule(ProofRewriteRule::SETS_CARD_EMP, { x1448 }, nm->mkNode(Kind::SET_CARD, { x1448 }), nm->mkConstInt(Rational(0)), nm->mkNode(Kind::EQUAL, { x1448,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1448 }) }) }), Node::null(), Level::EXPERT);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
