/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_sets_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x861 = NodeManager::mkBoundVar("x861", nm->mkAbstractType(Kind::SET_TYPE));
Node y862 = NodeManager::mkBoundVar("y862", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x863 = NodeManager::mkBoundVar("x863", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y864 = NodeManager::mkBoundVar("y864", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x865 = NodeManager::mkBoundVar("x865", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y866 = NodeManager::mkBoundVar("y866", nm->mkAbstractType(Kind::SET_TYPE));
Node x867 = NodeManager::mkBoundVar("x867", nm->mkAbstractType(Kind::SET_TYPE));
Node y868 = NodeManager::mkBoundVar("y868", nm->mkAbstractType(Kind::SET_TYPE));
Node x869 = NodeManager::mkBoundVar("x869", nm->mkAbstractType(Kind::SET_TYPE));
Node y870 = NodeManager::mkBoundVar("y870", nm->mkAbstractType(Kind::SET_TYPE));
Node x871 = NodeManager::mkBoundVar("x871", nm->mkAbstractType(Kind::SET_TYPE));
Node y872 = NodeManager::mkBoundVar("y872", nm->mkAbstractType(Kind::SET_TYPE));
Node x873 = NodeManager::mkBoundVar("x873", nm->mkAbstractType(Kind::SET_TYPE));
Node y874 = NodeManager::mkBoundVar("y874", nm->mkAbstractType(Kind::SET_TYPE));
Node x875 = NodeManager::mkBoundVar("x875", nm->mkAbstractType(Kind::SET_TYPE));
Node y876 = NodeManager::mkBoundVar("y876", nm->mkAbstractType(Kind::SET_TYPE));
Node x877 = NodeManager::mkBoundVar("x877", nm->mkAbstractType(Kind::SET_TYPE));
Node y878 = NodeManager::mkBoundVar("y878", nm->mkAbstractType(Kind::SET_TYPE));
Node x879 = NodeManager::mkBoundVar("x879", nm->mkAbstractType(Kind::SET_TYPE));
Node y880 = NodeManager::mkBoundVar("y880", nm->mkAbstractType(Kind::SET_TYPE));
Node x881 = NodeManager::mkBoundVar("x881", nm->mkAbstractType(Kind::SET_TYPE));
Node y882 = NodeManager::mkBoundVar("y882", nm->mkAbstractType(Kind::SET_TYPE));
Node x883 = NodeManager::mkBoundVar("x883", nm->mkAbstractType(Kind::SET_TYPE));
Node y884 = NodeManager::mkBoundVar("y884", nm->mkAbstractType(Kind::SET_TYPE));
Node x885 = NodeManager::mkBoundVar("x885", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y886 = NodeManager::mkBoundVar("y886", nm->mkAbstractType(Kind::SET_TYPE));
Node z887 = NodeManager::mkBoundVar("z887", nm->mkAbstractType(Kind::SET_TYPE));
Node x888 = NodeManager::mkBoundVar("x888", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y889 = NodeManager::mkBoundVar("y889", nm->mkAbstractType(Kind::SET_TYPE));
Node z890 = NodeManager::mkBoundVar("z890", nm->mkAbstractType(Kind::SET_TYPE));
Node x891 = NodeManager::mkBoundVar("x891", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node y892 = NodeManager::mkBoundVar("y892", nm->mkAbstractType(Kind::SET_TYPE));
Node z893 = NodeManager::mkBoundVar("z893", nm->mkAbstractType(Kind::SET_TYPE));
Node x894 = NodeManager::mkBoundVar("x894", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x895 = NodeManager::mkBoundVar("x895", nm->mkAbstractType(Kind::SET_TYPE));
Node x896 = NodeManager::mkBoundVar("x896", nm->mkAbstractType(Kind::SET_TYPE));
Node x897 = NodeManager::mkBoundVar("x897", nm->mkAbstractType(Kind::SET_TYPE));

  // Definitions
Node e898 = nm->mkConst(true);
Node e899 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-sets-rewrites.cpp
            db.addRule(ProofRewriteRule::SETS_EQ_SINGLETON_EMP, { x861, y862 }, nm->mkNode(Kind::EQUAL, { x861,nm->mkNode(Kind::SET_SINGLETON, { y862 }) }), e899, nm->mkNode(Kind::EQUAL, { x861,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x861 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MEMBER_SINGLETON, { x863, y864 }, nm->mkNode(Kind::SET_MEMBER, { x863,nm->mkNode(Kind::SET_SINGLETON, { y864 }) }), nm->mkNode(Kind::EQUAL, { x863,y864 }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MEMBER_EMP, { x865, y866 }, nm->mkNode(Kind::SET_MEMBER, { x865,y866 }), e899, nm->mkNode(Kind::EQUAL, { y866,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y866 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_SUBSET_ELIM, { x867, y868 }, nm->mkNode(Kind::SET_SUBSET, { x867,y868 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SET_UNION, { x867,y868 }),y868 }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_UNION_COMM, { x869, y870 }, nm->mkNode(Kind::SET_UNION, { x869,y870 }), nm->mkNode(Kind::SET_UNION, { y870,x869 }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_INTER_COMM, { x871, y872 }, nm->mkNode(Kind::SET_INTER, { x871,y872 }), nm->mkNode(Kind::SET_INTER, { y872,x871 }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_INTER_EMP1, { x873, y874 }, nm->mkNode(Kind::SET_INTER, { x873,y874 }), x873, nm->mkNode(Kind::EQUAL, { x873,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x873 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_INTER_EMP2, { x875, y876 }, nm->mkNode(Kind::SET_INTER, { x875,y876 }), y876, nm->mkNode(Kind::EQUAL, { y876,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y876 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MINUS_EMP1, { x877, y878 }, nm->mkNode(Kind::SET_MINUS, { x877,y878 }), x877, nm->mkNode(Kind::EQUAL, { x877,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x877 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MINUS_EMP2, { x879, y880 }, nm->mkNode(Kind::SET_MINUS, { x879,y880 }), x879, nm->mkNode(Kind::EQUAL, { y880,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y880 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_UNION_EMP1, { x881, y882 }, nm->mkNode(Kind::SET_UNION, { x881,y882 }), y882, nm->mkNode(Kind::EQUAL, { x881,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x881 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_UNION_EMP2, { x883, y884 }, nm->mkNode(Kind::SET_UNION, { x883,y884 }), x883, nm->mkNode(Kind::EQUAL, { y884,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { y884 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_INTER_MEMBER, { x885, y886, z887 }, nm->mkNode(Kind::SET_MEMBER, { x885,nm->mkNode(Kind::SET_INTER, { y886,z887 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x885,y886 }),nm->mkNode(Kind::SET_MEMBER, { x885,z887 }) }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MINUS_MEMBER, { x888, y889, z890 }, nm->mkNode(Kind::SET_MEMBER, { x888,nm->mkNode(Kind::SET_MINUS, { y889,z890 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::SET_MEMBER, { x888,y889 }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::SET_MEMBER, { x888,z890 }) }) }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_UNION_MEMBER, { x891, y892, z893 }, nm->mkNode(Kind::SET_MEMBER, { x891,nm->mkNode(Kind::SET_UNION, { y892,z893 }) }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::SET_MEMBER, { x891,y892 }),nm->mkNode(Kind::SET_MEMBER, { x891,z893 }) }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_CHOOSE_SINGLETON, { x894 }, nm->mkNode(Kind::SET_CHOOSE, { nm->mkNode(Kind::SET_SINGLETON, { x894 }) }), x894, e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_MINUS_SELF, { x895 }, nm->mkNode(Kind::SET_MINUS, { x895,x895 }), nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x895 }) }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_IS_EMPTY_ELIM, { x896 }, nm->mkNode(Kind::SET_IS_EMPTY, { x896 }), nm->mkNode(Kind::EQUAL, { x896,nm->mkNode(Kind::SET_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x896 }) }) }), e898, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SETS_IS_SINGLETON_ELIM, { x897 }, nm->mkNode(Kind::SET_IS_SINGLETON, { x897 }), nm->mkNode(Kind::EQUAL, { x897,nm->mkNode(Kind::SET_SINGLETON, { nm->mkNode(Kind::SET_CHOOSE, { x897 }) }) }), e898, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
