/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites_regexp_membership(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node t1361 = NodeManager::mkBoundVar("t1361", nm->stringType());
Node t1362 = NodeManager::mkBoundVar("t1362", nm->stringType());
Node t1363 = NodeManager::mkBoundVar("t1363", nm->stringType());
Node t1364 = NodeManager::mkBoundVar("t1364", nm->stringType());
Node s1365 = NodeManager::mkBoundVar("s1365", nm->stringType());
Node t1366 = NodeManager::mkBoundVar("t1366", nm->stringType());
Node r1367 = NodeManager::mkBoundVar("r1367", nm->regExpType());
Node s1368 = NodeManager::mkBoundVar("s1368", nm->stringType());
Node r11369 = NodeManager::mkBoundVar("r11369", nm->regExpType());
Node r21370 = NodeManager::mkBoundVar("r21370", nm->regExpType());
Node rs1371 = NodeManager::mkBoundVar("rs1371", nm->regExpType());expr::markListVar(rs1371);
Node t1383 = NodeManager::mkBoundVar("t1383", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1372 = NodeManager::mkBoundVar("s1372", nm->stringType());
Node r11373 = NodeManager::mkBoundVar("r11373", nm->regExpType());
Node r21374 = NodeManager::mkBoundVar("r21374", nm->regExpType());
Node rs1375 = NodeManager::mkBoundVar("rs1375", nm->regExpType());expr::markListVar(rs1375);
Node t1384 = NodeManager::mkBoundVar("t1384", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1376 = NodeManager::mkBoundVar("s1376", nm->stringType());
Node c11377 = NodeManager::mkBoundVar("c11377", nm->stringType());
Node c21378 = NodeManager::mkBoundVar("c21378", nm->stringType());
Node t1379 = NodeManager::mkBoundVar("t1379", nm->stringType());
Node s1380 = NodeManager::mkBoundVar("s1380", nm->stringType());
Node n1381 = NodeManager::mkBoundVar("n1381", nm->integerType());
Node n1382 = NodeManager::mkBoundVar("n1382", nm->integerType());

  // Definitions
Node e1385 = nm->mkConst(true);
Node e1386 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_RANGE, { nm->mkConst(String("0")),nm->mkConst(String("9")) }) });
Node e1387 = nm->mkNode(Kind::REGEXP_RANGE, { nm->mkConst(String("0")),nm->mkConst(String("9")) });
Node e1388 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1389 = nm->mkNode(Kind::STRING_TO_CODE, { s1376 });
Node e1390 = nm->mkConstInt(Rational(1));
Node e1391 = nm->mkNode(Kind::REGEXP_ALLCHAR, {  });

  // Rules

        {
            // from rewrites-strings-rewrites-regexp-membership.cpp
            db.addRule(ProofRewriteRule::RE_IN_EMPTY, { t1361 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1361,nm->mkNode(Kind::REGEXP_NONE, {  }) }), nm->mkConst(false), e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_IN_SIGMA, { t1362 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1362,e1391 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1362 }),e1390 }), e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_IN_SIGMA_STAR, { t1363 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1363,e1388 }), e1385, e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_IN_CSTRING, { t1364, s1365 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1364,nm->mkNode(Kind::STRING_TO_REGEXP, { s1365 }) }), nm->mkNode(Kind::EQUAL, { t1364,s1365 }), e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_IN_COMP, { t1366, r1367 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1366,nm->mkNode(Kind::REGEXP_COMPLEMENT, { r1367 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { t1366,r1367 }) }), e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_UNION_ELIM, { s1368, r11369, r21370, rs1371 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1368,nm->mkNode(Kind::REGEXP_UNION, { r11369,r21370,rs1371 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1368,nm->mkNode(Kind::REGEXP_UNION, { r21370,rs1371 }) }), e1385, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1383 }),nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1368,r11369 }),t1383 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_INTER_ELIM, { s1372, r11373, r21374, rs1375 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1372,nm->mkNode(Kind::REGEXP_INTER, { r11373,r21374,rs1375 }) }), nm->mkNode(Kind::STRING_IN_REGEXP, { s1372,nm->mkNode(Kind::REGEXP_INTER, { r21374,rs1375 }) }), e1385, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1384 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1372,r11373 }),t1384 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_RANGE_ELIM, { s1376, c11377, c21378 }, nm->mkNode(Kind::STRING_IN_REGEXP, { s1376,nm->mkNode(Kind::REGEXP_RANGE, { c11377,c21378 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::STRING_TO_CODE, { c11377 }),e1389 }),nm->mkNode(Kind::LEQ, { e1389,nm->mkNode(Kind::STRING_TO_CODE, { c21378 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c11377 }),e1390 }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { c21378 }),e1390 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_CONTAINS, { t1379, s1380 }, nm->mkNode(Kind::STRING_IN_REGEXP, { t1379,nm->mkNode(Kind::REGEXP_CONCAT, { e1388,nm->mkNode(Kind::STRING_TO_REGEXP, { s1380 }),e1388 }) }), nm->mkNode(Kind::STRING_CONTAINS, { t1379,s1380 }), e1385, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_FROM_INT_NEMP_DIG_RANGE, { n1381 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_ITOS, { n1381 }),nm->mkNode(Kind::REGEXP_CONCAT, { e1387,e1386 }) }), e1385, nm->mkNode(Kind::GEQ, { n1381,nm->mkConstInt(Rational(0)) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_IN_RE_FROM_INT_DIG_RANGE, { n1382 }, nm->mkNode(Kind::STRING_IN_REGEXP, { nm->mkNode(Kind::STRING_ITOS, { n1382 }),e1386 }), e1385, e1385, Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
