/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_strings_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node x1900 = NodeManager::mkBoundVar("x1900", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x1900);
Node x901 = NodeManager::mkBoundVar("x901", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x2902 = NodeManager::mkBoundVar("x2902", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(x2902);
Node y903 = NodeManager::mkBoundVar("y903", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x904 = NodeManager::mkBoundVar("x904", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y905 = NodeManager::mkBoundVar("y905", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x906 = NodeManager::mkBoundVar("x906", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y907 = NodeManager::mkBoundVar("y907", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x908 = NodeManager::mkBoundVar("x908", nm->stringType());
Node y909 = NodeManager::mkBoundVar("y909", nm->stringType());
Node x910 = NodeManager::mkBoundVar("x910", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n911 = NodeManager::mkBoundVar("n911", nm->integerType());
Node m912 = NodeManager::mkBoundVar("m912", nm->integerType());
Node x913 = NodeManager::mkBoundVar("x913", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n914 = NodeManager::mkBoundVar("n914", nm->integerType());
Node m915 = NodeManager::mkBoundVar("m915", nm->integerType());
Node x916 = NodeManager::mkBoundVar("x916", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n917 = NodeManager::mkBoundVar("n917", nm->integerType());
Node m918 = NodeManager::mkBoundVar("m918", nm->integerType());
Node x919 = NodeManager::mkBoundVar("x919", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n920 = NodeManager::mkBoundVar("n920", nm->integerType());
Node m921 = NodeManager::mkBoundVar("m921", nm->integerType());
Node x922 = NodeManager::mkBoundVar("x922", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1923 = NodeManager::mkBoundVar("n1923", nm->integerType());
Node m1924 = NodeManager::mkBoundVar("m1924", nm->integerType());
Node n2925 = NodeManager::mkBoundVar("n2925", nm->integerType());
Node m2926 = NodeManager::mkBoundVar("m2926", nm->integerType());
Node s927 = NodeManager::mkBoundVar("s927", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r928 = NodeManager::mkBoundVar("r928", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n929 = NodeManager::mkBoundVar("n929", nm->integerType());
Node m930 = NodeManager::mkBoundVar("m930", nm->integerType());
Node s931 = NodeManager::mkBoundVar("s931", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r932 = NodeManager::mkBoundVar("r932", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node m933 = NodeManager::mkBoundVar("m933", nm->integerType());
Node s934 = NodeManager::mkBoundVar("s934", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp935 = NodeManager::mkBoundVar("emp935", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n936 = NodeManager::mkBoundVar("n936", nm->integerType());
Node m937 = NodeManager::mkBoundVar("m937", nm->integerType());
Node t938 = NodeManager::mkBoundVar("t938", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s939 = NodeManager::mkBoundVar("s939", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r940 = NodeManager::mkBoundVar("r940", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t941 = NodeManager::mkBoundVar("t941", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s942 = NodeManager::mkBoundVar("s942", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r943 = NodeManager::mkBoundVar("r943", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t944 = NodeManager::mkBoundVar("t944", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n945 = NodeManager::mkBoundVar("n945", nm->integerType());
Node r946 = NodeManager::mkBoundVar("r946", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t947 = NodeManager::mkBoundVar("t947", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ts948 = NodeManager::mkBoundVar("ts948", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ts948);
Node s949 = NodeManager::mkBoundVar("s949", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n950 = NodeManager::mkBoundVar("n950", nm->integerType());
Node tpre951 = NodeManager::mkBoundVar("tpre951", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node tpost952 = NodeManager::mkBoundVar("tpost952", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s953 = NodeManager::mkBoundVar("s953", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n954 = NodeManager::mkBoundVar("n954", nm->integerType());
Node m955 = NodeManager::mkBoundVar("m955", nm->integerType());
Node s1956 = NodeManager::mkBoundVar("s1956", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2957 = NodeManager::mkBoundVar("s2957", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s2957);
Node t1958 = NodeManager::mkBoundVar("t1958", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2959 = NodeManager::mkBoundVar("t2959", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2959);
Node s1960 = NodeManager::mkBoundVar("s1960", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2961 = NodeManager::mkBoundVar("s2961", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s2961);
Node t1962 = NodeManager::mkBoundVar("t1962", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2963 = NodeManager::mkBoundVar("t2963", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2963);
Node s1964 = NodeManager::mkBoundVar("s1964", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1965 = NodeManager::mkBoundVar("t1965", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2966 = NodeManager::mkBoundVar("t2966", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2966);
Node s1967 = NodeManager::mkBoundVar("s1967", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1968 = NodeManager::mkBoundVar("t1968", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2969 = NodeManager::mkBoundVar("t2969", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2969);
Node s1970 = NodeManager::mkBoundVar("s1970", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2971 = NodeManager::mkBoundVar("s2971", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s3972 = NodeManager::mkBoundVar("s3972", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s3972);
Node t2973 = NodeManager::mkBoundVar("t2973", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t3974 = NodeManager::mkBoundVar("t3974", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t3974);
Node t1321 = NodeManager::mkBoundVar("t1321", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1975 = NodeManager::mkBoundVar("s1975", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s2976 = NodeManager::mkBoundVar("s2976", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s3977 = NodeManager::mkBoundVar("s3977", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s3977);
Node t2978 = NodeManager::mkBoundVar("t2978", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t3979 = NodeManager::mkBoundVar("t3979", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t3979);
Node t1322 = NodeManager::mkBoundVar("t1322", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s980 = NodeManager::mkBoundVar("s980", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1981 = NodeManager::mkBoundVar("t1981", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2982 = NodeManager::mkBoundVar("t2982", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2982);
Node s983 = NodeManager::mkBoundVar("s983", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1984 = NodeManager::mkBoundVar("t1984", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t2985 = NodeManager::mkBoundVar("t2985", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t2985);
Node s986 = NodeManager::mkBoundVar("s986", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t987 = NodeManager::mkBoundVar("t987", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s988 = NodeManager::mkBoundVar("s988", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t989 = NodeManager::mkBoundVar("t989", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s990 = NodeManager::mkBoundVar("s990", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t991 = NodeManager::mkBoundVar("t991", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s992 = NodeManager::mkBoundVar("s992", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t993 = NodeManager::mkBoundVar("t993", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s994 = NodeManager::mkBoundVar("s994", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t995 = NodeManager::mkBoundVar("t995", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s996 = NodeManager::mkBoundVar("s996", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t997 = NodeManager::mkBoundVar("t997", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s998 = NodeManager::mkBoundVar("s998", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1999 = NodeManager::mkBoundVar("n1999", nm->integerType());
Node m11000 = NodeManager::mkBoundVar("m11000", nm->integerType());
Node n21001 = NodeManager::mkBoundVar("n21001", nm->integerType());
Node m21002 = NodeManager::mkBoundVar("m21002", nm->integerType());
Node s1003 = NodeManager::mkBoundVar("s1003", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11004 = NodeManager::mkBoundVar("n11004", nm->integerType());
Node m11005 = NodeManager::mkBoundVar("m11005", nm->integerType());
Node n21006 = NodeManager::mkBoundVar("n21006", nm->integerType());
Node m21007 = NodeManager::mkBoundVar("m21007", nm->integerType());
Node s1008 = NodeManager::mkBoundVar("s1008", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11009 = NodeManager::mkBoundVar("n11009", nm->integerType());
Node m11010 = NodeManager::mkBoundVar("m11010", nm->integerType());
Node n21011 = NodeManager::mkBoundVar("n21011", nm->integerType());
Node m21012 = NodeManager::mkBoundVar("m21012", nm->integerType());
Node s1013 = NodeManager::mkBoundVar("s1013", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n11014 = NodeManager::mkBoundVar("n11014", nm->integerType());
Node m11015 = NodeManager::mkBoundVar("m11015", nm->integerType());
Node n21016 = NodeManager::mkBoundVar("n21016", nm->integerType());
Node m21017 = NodeManager::mkBoundVar("m21017", nm->integerType());
Node s11018 = NodeManager::mkBoundVar("s11018", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21019 = NodeManager::mkBoundVar("s21019", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21019);
Node n1020 = NodeManager::mkBoundVar("n1020", nm->integerType());
Node m1021 = NodeManager::mkBoundVar("m1021", nm->integerType());
Node s11022 = NodeManager::mkBoundVar("s11022", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21023 = NodeManager::mkBoundVar("s21023", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31024 = NodeManager::mkBoundVar("s31024", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31024);
Node n1025 = NodeManager::mkBoundVar("n1025", nm->integerType());
Node m1026 = NodeManager::mkBoundVar("m1026", nm->integerType());
Node s1027 = NodeManager::mkBoundVar("s1027", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1028 = NodeManager::mkBoundVar("t1028", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1029 = NodeManager::mkBoundVar("r1029", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1030 = NodeManager::mkBoundVar("n1030", nm->integerType());
Node s1031 = NodeManager::mkBoundVar("s1031", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1032 = NodeManager::mkBoundVar("n1032", nm->integerType());
Node s1033 = NodeManager::mkBoundVar("s1033", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1034 = NodeManager::mkBoundVar("n1034", nm->integerType());
Node x1035 = NodeManager::mkBoundVar("x1035", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node xs1036 = NodeManager::mkBoundVar("xs1036", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs1036);
Node z1037 = NodeManager::mkBoundVar("z1037", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1038 = NodeManager::mkBoundVar("y1038", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node zs1039 = NodeManager::mkBoundVar("zs1039", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs1039);
Node xs1040 = NodeManager::mkBoundVar("xs1040", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(xs1040);
Node z1041 = NodeManager::mkBoundVar("z1041", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1042 = NodeManager::mkBoundVar("y1042", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node zs1043 = NodeManager::mkBoundVar("zs1043", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(zs1043);
Node x1044 = NodeManager::mkBoundVar("x1044", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1045 = NodeManager::mkBoundVar("y1045", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1046 = NodeManager::mkBoundVar("z1046", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(z1046);
Node w1047 = NodeManager::mkBoundVar("w1047", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1048 = NodeManager::mkBoundVar("x1048", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1049 = NodeManager::mkBoundVar("y1049", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1050 = NodeManager::mkBoundVar("x1050", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1051 = NodeManager::mkBoundVar("y1051", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1052 = NodeManager::mkBoundVar("x1052", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1053 = NodeManager::mkBoundVar("y1053", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1054 = NodeManager::mkBoundVar("x1054", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1055 = NodeManager::mkBoundVar("n1055", nm->integerType());
Node t1056 = NodeManager::mkBoundVar("t1056", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1057 = NodeManager::mkBoundVar("s1057", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1058 = NodeManager::mkBoundVar("t1058", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1059 = NodeManager::mkBoundVar("s1059", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t11060 = NodeManager::mkBoundVar("t11060", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21061 = NodeManager::mkBoundVar("t21061", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1062 = NodeManager::mkBoundVar("r1062", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(r1062);
Node s1063 = NodeManager::mkBoundVar("s1063", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1064 = NodeManager::mkBoundVar("t1064", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1065 = NodeManager::mkBoundVar("s1065", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1066 = NodeManager::mkBoundVar("r1066", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1067 = NodeManager::mkBoundVar("t1067", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1068 = NodeManager::mkBoundVar("s1068", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1069 = NodeManager::mkBoundVar("r1069", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node tpre1070 = NodeManager::mkBoundVar("tpre1070", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node tpost1071 = NodeManager::mkBoundVar("tpost1071", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1072 = NodeManager::mkBoundVar("t1072", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ts1073 = NodeManager::mkBoundVar("ts1073", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ts1073);
Node s1074 = NodeManager::mkBoundVar("s1074", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1075 = NodeManager::mkBoundVar("r1075", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node tpre1076 = NodeManager::mkBoundVar("tpre1076", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node tpost1077 = NodeManager::mkBoundVar("tpost1077", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1078 = NodeManager::mkBoundVar("t1078", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1079 = NodeManager::mkBoundVar("s1079", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1080 = NodeManager::mkBoundVar("r1080", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1081 = NodeManager::mkBoundVar("t1081", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1082 = NodeManager::mkBoundVar("s1082", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1083 = NodeManager::mkBoundVar("r1083", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ts1084 = NodeManager::mkBoundVar("ts1084", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ts1084);
Node ss1085 = NodeManager::mkBoundVar("ss1085", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ss1085);
Node t1086 = NodeManager::mkBoundVar("t1086", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1087 = NodeManager::mkBoundVar("r1087", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node ts1088 = NodeManager::mkBoundVar("ts1088", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ts1088);
Node ss1089 = NodeManager::mkBoundVar("ss1089", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(ss1089);
Node t1090 = NodeManager::mkBoundVar("t1090", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1091 = NodeManager::mkBoundVar("s1091", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1092 = NodeManager::mkBoundVar("r1092", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1093 = NodeManager::mkBoundVar("t1093", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1094 = NodeManager::mkBoundVar("r1094", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1095 = NodeManager::mkBoundVar("t1095", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1096 = NodeManager::mkBoundVar("r1096", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s11097 = NodeManager::mkBoundVar("s11097", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21098 = NodeManager::mkBoundVar("s21098", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31099 = NodeManager::mkBoundVar("s31099", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31099);
Node t1323 = NodeManager::mkBoundVar("t1323", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11100 = NodeManager::mkBoundVar("s11100", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21101 = NodeManager::mkBoundVar("s21101", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31102 = NodeManager::mkBoundVar("s31102", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31102);
Node t1324 = NodeManager::mkBoundVar("t1324", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11103 = NodeManager::mkBoundVar("s11103", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1104 = NodeManager::mkBoundVar("t1104", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1105 = NodeManager::mkBoundVar("n1105", nm->integerType());
Node t1106 = NodeManager::mkBoundVar("t1106", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1107 = NodeManager::mkBoundVar("s1107", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1108 = NodeManager::mkBoundVar("n1108", nm->integerType());
Node t1109 = NodeManager::mkBoundVar("t1109", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1110 = NodeManager::mkBoundVar("s1110", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1111 = NodeManager::mkBoundVar("n1111", nm->integerType());
Node t1112 = NodeManager::mkBoundVar("t1112", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1113 = NodeManager::mkBoundVar("s1113", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1114 = NodeManager::mkBoundVar("n1114", nm->integerType());
Node t11115 = NodeManager::mkBoundVar("t11115", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t21116 = NodeManager::mkBoundVar("t21116", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(t21116);
Node s1117 = NodeManager::mkBoundVar("s1117", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1118 = NodeManager::mkBoundVar("n1118", nm->integerType());
Node t1119 = NodeManager::mkBoundVar("t1119", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1120 = NodeManager::mkBoundVar("emp1120", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1121 = NodeManager::mkBoundVar("n1121", nm->integerType());
Node t1122 = NodeManager::mkBoundVar("t1122", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1123 = NodeManager::mkBoundVar("s1123", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1124 = NodeManager::mkBoundVar("r1124", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1125 = NodeManager::mkBoundVar("n1125", nm->integerType());
Node t1126 = NodeManager::mkBoundVar("t1126", nm->stringType());
Node n1127 = NodeManager::mkBoundVar("n1127", nm->integerType());
Node t1128 = NodeManager::mkBoundVar("t1128", nm->stringType());
Node r1129 = NodeManager::mkBoundVar("r1129", nm->regExpType());
Node n1130 = NodeManager::mkBoundVar("n1130", nm->integerType());
Node s11131 = NodeManager::mkBoundVar("s11131", nm->stringType());
Node s21132 = NodeManager::mkBoundVar("s21132", nm->stringType());
Node s31133 = NodeManager::mkBoundVar("s31133", nm->stringType());expr::markListVar(s31133);
Node t1325 = NodeManager::mkBoundVar("t1325", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s11134 = NodeManager::mkBoundVar("s11134", nm->stringType());
Node s21135 = NodeManager::mkBoundVar("s21135", nm->stringType());
Node s31136 = NodeManager::mkBoundVar("s31136", nm->stringType());expr::markListVar(s31136);
Node t1326 = NodeManager::mkBoundVar("t1326", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1137 = NodeManager::mkBoundVar("s1137", nm->stringType());
Node s1138 = NodeManager::mkBoundVar("s1138", nm->stringType());
Node s1139 = NodeManager::mkBoundVar("s1139", nm->stringType());
Node s1140 = NodeManager::mkBoundVar("s1140", nm->stringType());
Node n1141 = NodeManager::mkBoundVar("n1141", nm->integerType());
Node n1142 = NodeManager::mkBoundVar("n1142", nm->integerType());
Node s11143 = NodeManager::mkBoundVar("s11143", nm->stringType());expr::markListVar(s11143);
Node s21144 = NodeManager::mkBoundVar("s21144", nm->stringType());
Node s31145 = NodeManager::mkBoundVar("s31145", nm->stringType());expr::markListVar(s31145);
Node s1146 = NodeManager::mkBoundVar("s1146", nm->stringType());
Node s1147 = NodeManager::mkBoundVar("s1147", nm->stringType());
Node s1148 = NodeManager::mkBoundVar("s1148", nm->stringType());expr::markListVar(s1148);
Node t11149 = NodeManager::mkBoundVar("t11149", nm->stringType());
Node s11150 = NodeManager::mkBoundVar("s11150", nm->stringType());
Node t21151 = NodeManager::mkBoundVar("t21151", nm->stringType());expr::markListVar(t21151);
Node s21152 = NodeManager::mkBoundVar("s21152", nm->stringType());expr::markListVar(s21152);
Node s1153 = NodeManager::mkBoundVar("s1153", nm->stringType());expr::markListVar(s1153);
Node t11154 = NodeManager::mkBoundVar("t11154", nm->stringType());
Node s11155 = NodeManager::mkBoundVar("s11155", nm->stringType());
Node t21156 = NodeManager::mkBoundVar("t21156", nm->stringType());expr::markListVar(t21156);
Node s21157 = NodeManager::mkBoundVar("s21157", nm->stringType());expr::markListVar(s21157);
Node t11158 = NodeManager::mkBoundVar("t11158", nm->stringType());
Node t21159 = NodeManager::mkBoundVar("t21159", nm->stringType());expr::markListVar(t21159);
Node s1160 = NodeManager::mkBoundVar("s1160", nm->stringType());
Node t1161 = NodeManager::mkBoundVar("t1161", nm->stringType());
Node s11162 = NodeManager::mkBoundVar("s11162", nm->stringType());
Node s21163 = NodeManager::mkBoundVar("s21163", nm->stringType());expr::markListVar(s21163);
Node s1164 = NodeManager::mkBoundVar("s1164", nm->stringType());
Node t1165 = NodeManager::mkBoundVar("t1165", nm->stringType());
Node n1166 = NodeManager::mkBoundVar("n1166", nm->integerType());
Node s1167 = NodeManager::mkBoundVar("s1167", nm->stringType());
Node t1168 = NodeManager::mkBoundVar("t1168", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1169 = NodeManager::mkBoundVar("s1169", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1170 = NodeManager::mkBoundVar("n1170", nm->integerType());
Node m1171 = NodeManager::mkBoundVar("m1171", nm->integerType());
Node s1172 = NodeManager::mkBoundVar("s1172", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1173 = NodeManager::mkBoundVar("n1173", nm->integerType());
Node m1174 = NodeManager::mkBoundVar("m1174", nm->integerType());
Node s1175 = NodeManager::mkBoundVar("s1175", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1176 = NodeManager::mkBoundVar("t1176", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1177 = NodeManager::mkBoundVar("r1177", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node u1178 = NodeManager::mkBoundVar("u1178", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1179 = NodeManager::mkBoundVar("s1179", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1180 = NodeManager::mkBoundVar("t1180", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node r1181 = NodeManager::mkBoundVar("r1181", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node u1182 = NodeManager::mkBoundVar("u1182", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1183 = NodeManager::mkBoundVar("s1183", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1184 = NodeManager::mkBoundVar("t1184", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s1185 = NodeManager::mkBoundVar("s1185", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1186 = NodeManager::mkBoundVar("t1186", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1187 = NodeManager::mkBoundVar("emp1187", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1188 = NodeManager::mkBoundVar("x1188", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1189 = NodeManager::mkBoundVar("n1189", nm->integerType());
Node x1190 = NodeManager::mkBoundVar("x1190", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1191 = NodeManager::mkBoundVar("y1191", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1192 = NodeManager::mkBoundVar("z1192", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1193 = NodeManager::mkBoundVar("w1193", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1194 = NodeManager::mkBoundVar("x1194", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1195 = NodeManager::mkBoundVar("y1195", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1196 = NodeManager::mkBoundVar("w1196", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1197 = NodeManager::mkBoundVar("x1197", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1198 = NodeManager::mkBoundVar("y1198", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1199 = NodeManager::mkBoundVar("x1199", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1200 = NodeManager::mkBoundVar("y1200", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1201 = NodeManager::mkBoundVar("z1201", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1202 = NodeManager::mkBoundVar("x1202", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1203 = NodeManager::mkBoundVar("y1203", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1204 = NodeManager::mkBoundVar("x1204", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1205 = NodeManager::mkBoundVar("y1205", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1206 = NodeManager::mkBoundVar("z1206", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1207 = NodeManager::mkBoundVar("w1207", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1208 = NodeManager::mkBoundVar("x1208", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1209 = NodeManager::mkBoundVar("y1209", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1210 = NodeManager::mkBoundVar("x1210", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1211 = NodeManager::mkBoundVar("y1211", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1212 = NodeManager::mkBoundVar("z1212", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1213 = NodeManager::mkBoundVar("w1213", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1214 = NodeManager::mkBoundVar("x1214", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1215 = NodeManager::mkBoundVar("y1215", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1216 = NodeManager::mkBoundVar("z1216", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1217 = NodeManager::mkBoundVar("x1217", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1218 = NodeManager::mkBoundVar("y1218", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1219 = NodeManager::mkBoundVar("z1219", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1220 = NodeManager::mkBoundVar("x1220", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1221 = NodeManager::mkBoundVar("y1221", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1222 = NodeManager::mkBoundVar("z1222", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1223 = NodeManager::mkBoundVar("x1223", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1224 = NodeManager::mkBoundVar("y1224", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1225 = NodeManager::mkBoundVar("z1225", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1226 = NodeManager::mkBoundVar("w1226", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node u1227 = NodeManager::mkBoundVar("u1227", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1228 = NodeManager::mkBoundVar("x1228", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1229 = NodeManager::mkBoundVar("y1229", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1230 = NodeManager::mkBoundVar("x1230", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1231 = NodeManager::mkBoundVar("y1231", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1232 = NodeManager::mkBoundVar("z1232", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1233 = NodeManager::mkBoundVar("w1233", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1234 = NodeManager::mkBoundVar("x1234", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1235 = NodeManager::mkBoundVar("y1235", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1236 = NodeManager::mkBoundVar("z1236", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1237 = NodeManager::mkBoundVar("w1237", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1238 = NodeManager::mkBoundVar("y1238", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1239 = NodeManager::mkBoundVar("z1239", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node w1240 = NodeManager::mkBoundVar("w1240", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1241 = NodeManager::mkBoundVar("x1241", nm->regExpType());
Node x1242 = NodeManager::mkBoundVar("x1242", nm->regExpType());
Node y1243 = NodeManager::mkBoundVar("y1243", nm->regExpType());
Node x1244 = NodeManager::mkBoundVar("x1244", nm->regExpType());
Node xs1245 = NodeManager::mkBoundVar("xs1245", nm->regExpType());expr::markListVar(xs1245);
Node r1246 = NodeManager::mkBoundVar("r1246", nm->regExpType());
Node ys1247 = NodeManager::mkBoundVar("ys1247", nm->regExpType());expr::markListVar(ys1247);
Node xs1248 = NodeManager::mkBoundVar("xs1248", nm->regExpType());expr::markListVar(xs1248);
Node r1249 = NodeManager::mkBoundVar("r1249", nm->regExpType());
Node ys1250 = NodeManager::mkBoundVar("ys1250", nm->regExpType());expr::markListVar(ys1250);
Node xs1251 = NodeManager::mkBoundVar("xs1251", nm->regExpType());expr::markListVar(xs1251);
Node r1252 = NodeManager::mkBoundVar("r1252", nm->regExpType());
Node ys1253 = NodeManager::mkBoundVar("ys1253", nm->regExpType());expr::markListVar(ys1253);
Node xs1254 = NodeManager::mkBoundVar("xs1254", nm->regExpType());expr::markListVar(xs1254);
Node r1255 = NodeManager::mkBoundVar("r1255", nm->regExpType());
Node ys1256 = NodeManager::mkBoundVar("ys1256", nm->regExpType());expr::markListVar(ys1256);
Node xs1257 = NodeManager::mkBoundVar("xs1257", nm->regExpType());expr::markListVar(xs1257);
Node s1258 = NodeManager::mkBoundVar("s1258", nm->stringType());
Node t1259 = NodeManager::mkBoundVar("t1259", nm->stringType());
Node ys1260 = NodeManager::mkBoundVar("ys1260", nm->regExpType());expr::markListVar(ys1260);
Node t1327 = NodeManager::mkBoundVar("t1327", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node xs1261 = NodeManager::mkBoundVar("xs1261", nm->regExpType());expr::markListVar(xs1261);
Node ys1262 = NodeManager::mkBoundVar("ys1262", nm->regExpType());expr::markListVar(ys1262);
Node r1263 = NodeManager::mkBoundVar("r1263", nm->regExpType());
Node s1264 = NodeManager::mkBoundVar("s1264", nm->stringType());
Node xs1265 = NodeManager::mkBoundVar("xs1265", nm->regExpType());expr::markListVar(xs1265);
Node ys1266 = NodeManager::mkBoundVar("ys1266", nm->regExpType());expr::markListVar(ys1266);
Node t1328 = NodeManager::mkBoundVar("t1328", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1267 = NodeManager::mkBoundVar("x1267", nm->regExpType());
Node x1268 = NodeManager::mkBoundVar("x1268", nm->regExpType());expr::markListVar(x1268);
Node y1269 = NodeManager::mkBoundVar("y1269", nm->regExpType());expr::markListVar(y1269);
Node n1270 = NodeManager::mkBoundVar("n1270", nm->integerType());
Node m1271 = NodeManager::mkBoundVar("m1271", nm->integerType());
Node r1272 = NodeManager::mkBoundVar("r1272", nm->regExpType());
Node xs1273 = NodeManager::mkBoundVar("xs1273", nm->regExpType());expr::markListVar(xs1273);
Node ys1274 = NodeManager::mkBoundVar("ys1274", nm->regExpType());expr::markListVar(ys1274);
Node s1275 = NodeManager::mkBoundVar("s1275", nm->stringType());
Node xs1276 = NodeManager::mkBoundVar("xs1276", nm->regExpType());expr::markListVar(xs1276);
Node ys1277 = NodeManager::mkBoundVar("ys1277", nm->regExpType());expr::markListVar(ys1277);
Node s1278 = NodeManager::mkBoundVar("s1278", nm->stringType());
Node s11279 = NodeManager::mkBoundVar("s11279", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21280 = NodeManager::mkBoundVar("s21280", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s21280);
Node n1281 = NodeManager::mkBoundVar("n1281", nm->integerType());
Node m1282 = NodeManager::mkBoundVar("m1282", nm->integerType());
Node s11283 = NodeManager::mkBoundVar("s11283", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s21284 = NodeManager::mkBoundVar("s21284", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node s31285 = NodeManager::mkBoundVar("s31285", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(s31285);
Node n1286 = NodeManager::mkBoundVar("n1286", nm->integerType());
Node s1287 = NodeManager::mkBoundVar("s1287", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node n1288 = NodeManager::mkBoundVar("n1288", nm->integerType());
Node m1289 = NodeManager::mkBoundVar("m1289", nm->integerType());
Node x1290 = NodeManager::mkBoundVar("x1290", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1291 = NodeManager::mkBoundVar("x1291", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1292 = NodeManager::mkBoundVar("x1292", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1293 = NodeManager::mkBoundVar("y1293", nm->mkAbstractType(Kind::SEQUENCE_TYPE));expr::markListVar(y1293);
Node z1294 = NodeManager::mkBoundVar("z1294", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node t1329 = NodeManager::mkBoundVar("t1329", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1295 = NodeManager::mkBoundVar("x1295", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1296 = NodeManager::mkBoundVar("y1296", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1297 = NodeManager::mkBoundVar("emp1297", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1298 = NodeManager::mkBoundVar("x1298", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1299 = NodeManager::mkBoundVar("y1299", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1300 = NodeManager::mkBoundVar("z1300", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1301 = NodeManager::mkBoundVar("x1301", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1302 = NodeManager::mkBoundVar("y1302", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1303 = NodeManager::mkBoundVar("z1303", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1304 = NodeManager::mkBoundVar("x1304", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1305 = NodeManager::mkBoundVar("y1305", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1306 = NodeManager::mkBoundVar("emp1306", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1307 = NodeManager::mkBoundVar("x1307", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1308 = NodeManager::mkBoundVar("y1308", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1309 = NodeManager::mkBoundVar("z1309", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1310 = NodeManager::mkBoundVar("emp1310", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1311 = NodeManager::mkBoundVar("x1311", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1312 = NodeManager::mkBoundVar("y1312", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node z1313 = NodeManager::mkBoundVar("z1313", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node emp1314 = NodeManager::mkBoundVar("emp1314", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1315 = NodeManager::mkBoundVar("x1315", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node y1316 = NodeManager::mkBoundVar("y1316", nm->mkAbstractType(Kind::SEQUENCE_TYPE));
Node x1317 = NodeManager::mkBoundVar("x1317", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1318 = NodeManager::mkBoundVar("x1318", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1319 = NodeManager::mkBoundVar("x1319", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node x1320 = NodeManager::mkBoundVar("x1320", nm->mkAbstractType(Kind::SEQUENCE_TYPE));

  // Definitions
Node e1330 = nm->mkNode(Kind::SEQ_UNIT, { x1319 });
Node e1331 = nm->mkConstInt(Rational(0));
Node e1332 = nm->mkConst(true);
Node e1333 = nm->mkConstInt(Rational(1));
Node e1334 = nm->mkNode(Kind::STRING_LENGTH, { s1287 });
Node e1335 = nm->mkNode(Kind::STRING_LENGTH, { s11283 });
Node e1336 = nm->mkNode(Kind::STRING_TO_REGEXP, { s1275 });
Node e1337 = nm->mkNode(Kind::REGEXP_NONE, {  });
Node e1338 = nm->mkNode(Kind::REGEXP_STAR, { x1267 });
Node e1339 = nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkConst(String("")) });
Node e1340 = nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_ALLCHAR, {  }) });
Node e1341 = nm->mkNode(Kind::REGEXP_STAR, { r1249 });
Node e1342 = nm->mkNode(Kind::REGEXP_STAR, { r1246 });
Node e1343 = nm->mkNode(Kind::STRING_REPLACE, { emp1187,s1185,t1186 });
Node e1344 = nm->mkConst(false);
Node e1345 = nm->mkConst(String(""));
Node e1346 = nm->mkConstInt(-(Rational(1)));
Node e1347 = nm->mkNode(Kind::STRING_ITOS, { n1142 });
Node e1348 = nm->mkNode(Kind::STRING_ITOS, { n1141 });
Node e1349 = nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { t1104 }) });
Node e1350 = nm->mkNode(Kind::STRING_INDEXOF, { t1072,s1074,nm->mkConstInt(Rational(0)) });
Node e1351 = nm->mkNode(Kind::STRING_INDEXOF, { t1067,s1068,nm->mkConstInt(Rational(0)) });
Node e1352 = nm->mkNode(Kind::STRING_LENGTH, { t1028 });
Node e1353 = nm->mkNode(Kind::STRING_LENGTH, { s11022 });
Node e1354 = nm->mkNode(Kind::STRING_SUBSTR, { s1013,n11014,m11015 });
Node e1355 = nm->mkNode(Kind::STRING_SUBSTR, { s1008,n11009,m11010 });
Node e1356 = nm->mkNode(Kind::SUB, { m11000,n21001 });
Node e1357 = nm->mkNode(Kind::STRING_LENGTH, { s988 });
Node e1358 = nm->mkNode(Kind::STRING_LENGTH, { t947 });
Node e1359 = nm->mkNode(Kind::ADD, { n950,nm->mkNode(Kind::STRING_LENGTH, { s949 }) });
Node e1360 = nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s931 }) });

  // Rules

        {
            // from rewrites-strings-rewrites.cpp
            db.addRule(ProofRewriteRule::STR_EQ_CTN_FALSE, { x1900, x901, x2902, y903 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { x1900,x901,x2902 }),y903 }), e1344, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y903,x901 }),e1344 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE1, { x904, y905 }, nm->mkNode(Kind::EQUAL, { x904,y905 }), e1344, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { y905,x904 }),e1344 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_CTN_FULL_FALSE2, { x906, y907 }, nm->mkNode(Kind::EQUAL, { x906,y907 }), e1344, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONTAINS, { x906,y907 }),e1344 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_LEN_FALSE, { x908, y909 }, nm->mkNode(Kind::EQUAL, { x908,y909 }), e1344, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { x908 }),nm->mkNode(Kind::STRING_LENGTH, { y909 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_STR, { x910, n911, m912 }, nm->mkNode(Kind::STRING_SUBSTR, { x910,n911,m912 }), x910, nm->mkNode(Kind::EQUAL, { x910,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x910 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_RANGE, { x913, n914, m915 }, nm->mkNode(Kind::STRING_SUBSTR, { x913,n914,m915 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x913 }) }), nm->mkNode(Kind::GEQ, { e1331,m915 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START, { x916, n917, m918 }, nm->mkNode(Kind::STRING_SUBSTR, { x916,n917,m918 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x916 }) }), nm->mkNode(Kind::GEQ, { n917,nm->mkNode(Kind::STRING_LENGTH, { x916 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EMPTY_START_NEG, { x919, n920, m921 }, nm->mkNode(Kind::STRING_SUBSTR, { x919,n920,m921 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x919 }) }), nm->mkNode(Kind::LT, { n920,e1331 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_SUBSTR_START_GEQ_LEN, { x922, n1923, m1924, n2925, m2926 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { x922,n1923,m1924 }),n2925,m2926 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x922 }) }), nm->mkNode(Kind::GEQ, { n2925,m1924 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EQ_EMPTY, { s927, r928, n929, m930 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { s927,n929,m930 }),r928 }), nm->mkNode(Kind::EQUAL, { s927,r928 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { n929,e1331 }),nm->mkNode(Kind::GT, { m930,n929 }),nm->mkNode(Kind::EQUAL, { r928,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { r928 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_Z_EQ_EMPTY_LEQ, { s931, r932, m933 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { s931,e1331,m933 }),r932 }), nm->mkNode(Kind::LEQ, { m933,e1331 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s931,e1360 }) }),nm->mkNode(Kind::EQUAL, { r932,e1360 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_EQ_EMPTY_LEQ_LEN, { s934, emp935, n936, m937 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { s934,n936,m937 }),emp935 }), nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::STRING_LENGTH, { s934 }),n936 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n936,e1331 }),nm->mkNode(Kind::GT, { m937,e1331 }),nm->mkNode(Kind::EQUAL, { emp935,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { emp935 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_REPLACE_INV, { t938, s939, r940 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REPLACE, { t938,s939,r940 }) }), nm->mkNode(Kind::STRING_LENGTH, { t938 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s939 }),nm->mkNode(Kind::STRING_LENGTH, { r940 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_REPLACE_ALL_INV, { t941, s942, r943 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REPLACE_ALL, { t941,s942,r943 }) }), nm->mkNode(Kind::STRING_LENGTH, { t941 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s942 }),nm->mkNode(Kind::STRING_LENGTH, { r943 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_UPDATE_INV, { t944, n945, r946 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_UPDATE, { t944,n945,r946 }) }), nm->mkNode(Kind::STRING_LENGTH, { t944 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_UPDATE_IN_FIRST_CONCAT, { t947, ts948, s949, n950, tpre951, tpost952 }, nm->mkNode(Kind::STRING_UPDATE, { nm->mkNode(Kind::STRING_CONCAT, { t947,ts948 }),n950,s949 }), nm->mkNode(Kind::STRING_CONCAT, { tpre951,s949,tpost952,ts948 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n950,e1331 }),nm->mkNode(Kind::LT, { e1359,e1358 }),nm->mkNode(Kind::EQUAL, { tpre951,nm->mkNode(Kind::STRING_SUBSTR, { t947,e1331,n950 }) }),nm->mkNode(Kind::EQUAL, { tpost952,nm->mkNode(Kind::STRING_SUBSTR, { t947,e1359,e1358 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_SUBSTR_IN_RANGE, { s953, n954, m955 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_SUBSTR, { s953,n954,m955 }) }), m955, nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n954,e1331 }),nm->mkNode(Kind::GEQ, { m955,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s953 }),nm->mkNode(Kind::ADD, { n954,m955 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH, { s1956, s2957, t1958, t2959 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s1956,s2957 }),nm->mkNode(Kind::STRING_CONCAT, { t1958,t2959 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1956,t1958 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1956 }),nm->mkNode(Kind::STRING_LENGTH, { t1958 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH_REV, { s1960, s2961, t1962, t2963 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2961,s1960 }),nm->mkNode(Kind::STRING_CONCAT, { t2963,t1962 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1960,t1962 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1960 }),nm->mkNode(Kind::STRING_LENGTH, { t1962 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2, { s1964, t1965, t2966 }, nm->mkNode(Kind::EQUAL, { s1964,nm->mkNode(Kind::STRING_CONCAT, { t1965,t2966 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1964,t1965 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1964 }),nm->mkNode(Kind::STRING_LENGTH, { t1965 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_CLASH2_REV, { s1967, t1968, t2969 }, nm->mkNode(Kind::EQUAL, { s1967,nm->mkNode(Kind::STRING_CONCAT, { t2969,t1968 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1967,t1968 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1967 }),nm->mkNode(Kind::STRING_LENGTH, { t1968 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY, { s1970, s2971, s3972, t2973, t3974 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s1970,s2971,s3972 }),nm->mkNode(Kind::STRING_CONCAT, { s1970,t2973,t3974 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2971,s3972 }),nm->mkNode(Kind::STRING_CONCAT, { t2973,t3974 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1321 }),t1321 }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_REV, { s1975, s2976, s3977, t2978, t3979 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2976,s3977,s1975 }),nm->mkNode(Kind::STRING_CONCAT, { t2978,t3979,s1975 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_CONCAT, { s2976,s3977 }),nm->mkNode(Kind::STRING_CONCAT, { t2978,t3979 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1322 }),t1322 }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE, { s980, t1981, t2982 }, nm->mkNode(Kind::EQUAL, { s980,nm->mkNode(Kind::STRING_CONCAT, { s980,t1981,t2982 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s980 }) }),nm->mkNode(Kind::STRING_CONCAT, { t1981,t2982 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONCAT_UNIFY_BASE_REV, { s983, t1984, t2985 }, nm->mkNode(Kind::EQUAL, { s983,nm->mkNode(Kind::STRING_CONCAT, { t1984,t2985,s983 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s983 }) }),nm->mkNode(Kind::STRING_CONCAT, { t1984,t2985 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_PREFIXOF_ELIM, { s986, t987 }, nm->mkNode(Kind::STRING_PREFIX, { s986,t987 }), nm->mkNode(Kind::EQUAL, { s986,nm->mkNode(Kind::STRING_SUBSTR, { t987,e1331,nm->mkNode(Kind::STRING_LENGTH, { s986 }) }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ELIM, { s988, t989 }, nm->mkNode(Kind::STRING_SUFFIX, { s988,t989 }), nm->mkNode(Kind::EQUAL, { s988,nm->mkNode(Kind::STRING_SUBSTR, { t989,nm->mkNode(Kind::SUB, { nm->mkNode(Kind::STRING_LENGTH, { t989 }),e1357 }),e1357 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_PREFIXOF_EQ, { s990, t991 }, nm->mkNode(Kind::STRING_PREFIX, { s990,t991 }), nm->mkNode(Kind::EQUAL, { s990,t991 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s990 }),nm->mkNode(Kind::STRING_LENGTH, { t991 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUFFIXOF_EQ, { s992, t993 }, nm->mkNode(Kind::STRING_SUFFIX, { s992,t993 }), nm->mkNode(Kind::EQUAL, { s992,t993 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s992 }),nm->mkNode(Kind::STRING_LENGTH, { t993 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_PREFIXOF_ONE, { s994, t995 }, nm->mkNode(Kind::STRING_PREFIX, { s994,t995 }), nm->mkNode(Kind::STRING_CONTAINS, { t995,s994 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t995 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUFFIXOF_ONE, { s996, t997 }, nm->mkNode(Kind::STRING_SUFFIX, { s996,t997 }), nm->mkNode(Kind::STRING_CONTAINS, { t997,s996 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t997 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE1, { s998, n1999, m11000, n21001, m21002 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s998,n1999,m11000 }),n21001,m21002 }), nm->mkNode(Kind::STRING_SUBSTR, { s998,nm->mkNode(Kind::ADD, { n1999,n21001 }),e1356 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1999,e1331 }),nm->mkNode(Kind::GEQ, { n21001,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { m21002,e1356 }),e1331 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE2, { s1003, n11004, m11005, n21006, m21007 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_SUBSTR, { s1003,n11004,m11005 }),n21006,m21007 }), nm->mkNode(Kind::STRING_SUBSTR, { s1003,nm->mkNode(Kind::ADD, { n11004,n21006 }),m21007 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11004,e1331 }),nm->mkNode(Kind::GEQ, { n21006,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::SUB, { nm->mkNode(Kind::SUB, { m11005,n21006 }),m21007 }),e1331 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE3, { s1008, n11009, m11010, n21011, m21012 }, nm->mkNode(Kind::STRING_SUBSTR, { e1355,n21011,m21012 }), nm->mkNode(Kind::STRING_SUBSTR, { s1008,nm->mkNode(Kind::ADD, { n11009,n21011 }),m21012 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11009,e1331 }),nm->mkNode(Kind::GEQ, { n21011,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { e1355 }),nm->mkNode(Kind::ADD, { n21011,m21012 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_COMBINE4, { s1013, n11014, m11015, n21016, m21017 }, nm->mkNode(Kind::STRING_SUBSTR, { e1354,n21016,m21017 }), nm->mkNode(Kind::STRING_SUBSTR, { s1013,nm->mkNode(Kind::ADD, { n11014,n21016 }),nm->mkNode(Kind::SUB, { m11015,n21016 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n11014,e1331 }),nm->mkNode(Kind::GEQ, { n21016,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::ADD, { n21016,m21017 }),nm->mkNode(Kind::STRING_LENGTH, { e1354 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT1, { s11018, s21019, n1020, m1021 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11018,s21019 }),n1020,m1021 }), nm->mkNode(Kind::STRING_SUBSTR, { s11018,n1020,m1021 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { n1020,e1331 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s11018 }),nm->mkNode(Kind::ADD, { n1020,m1021 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_CONCAT2, { s11022, s21023, s31024, n1025, m1026 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11022,s21023,s31024 }),n1025,m1026 }), nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21023,s31024 }),nm->mkNode(Kind::SUB, { n1025,e1353 }),m1026 }), nm->mkNode(Kind::GEQ, { n1025,e1353 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_REPLACE, { s1027, t1028, r1029, n1030 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_REPLACE, { s1027,t1028,r1029 }),e1331,n1030 }), nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_SUBSTR, { s1027,e1331,n1030 }),t1028,r1029 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { e1352,nm->mkNode(Kind::STRING_LENGTH, { r1029 }) }),nm->mkNode(Kind::EQUAL, { e1352,e1333 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL, { s1031, n1032 }, nm->mkNode(Kind::STRING_SUBSTR, { s1031,e1331,n1032 }), s1031, nm->mkNode(Kind::GEQ, { n1032,nm->mkNode(Kind::STRING_LENGTH, { s1031 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_FULL_EQ, { s1033, n1034 }, nm->mkNode(Kind::STRING_SUBSTR, { s1033,e1331,n1034 }), s1033, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1033 }),n1034 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_REFL, { x1035 }, nm->mkNode(Kind::STRING_CONTAINS, { x1035,x1035 }), e1332, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_CONCAT_FIND, { xs1036, z1037, y1038, zs1039 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { xs1036,z1037,zs1039 }),y1038 }), e1332, nm->mkNode(Kind::STRING_CONTAINS, { z1037,y1038 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_CONCAT_FIND_CONTRA, { xs1040, z1041, y1042, zs1043 }, nm->mkNode(Kind::STRING_CONTAINS, { y1042,nm->mkNode(Kind::STRING_CONCAT, { xs1040,z1041,zs1043 }) }), e1344, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { y1042,z1041 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_SPLIT_CHAR, { x1044, y1045, z1046, w1047 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { x1044,y1045,z1046 }),w1047 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_CONTAINS, { x1044,w1047 }),nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_CONCAT, { y1045,z1046 }),w1047 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { w1047 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_LEQ_LEN_EQ, { x1048, y1049 }, nm->mkNode(Kind::STRING_CONTAINS, { x1048,y1049 }), nm->mkNode(Kind::EQUAL, { x1048,y1049 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { y1049 }),nm->mkNode(Kind::STRING_LENGTH, { x1048 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_EMP, { x1050, y1051 }, nm->mkNode(Kind::STRING_CONTAINS, { x1050,y1051 }), e1332, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { y1051 }),e1331 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_CHAR, { x1052, y1053 }, nm->mkNode(Kind::STRING_CONTAINS, { x1052,y1053 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1052 }) }),y1053 }),nm->mkNode(Kind::EQUAL, { x1052,y1053 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { x1052 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_AT_ELIM, { x1054, n1055 }, nm->mkNode(Kind::STRING_CHARAT, { x1054,n1055 }), nm->mkNode(Kind::STRING_SUBSTR, { x1054,n1055,e1333 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_SELF, { t1056, s1057 }, nm->mkNode(Kind::STRING_REPLACE, { t1056,t1056,s1057 }), s1057, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_ID, { t1058, s1059 }, nm->mkNode(Kind::STRING_REPLACE, { t1058,s1059,s1059 }), t1058, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_PREFIX, { t11060, t21061, r1062, s1063 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { t11060,t21061,r1062 }),t11060,s1063 }), nm->mkNode(Kind::STRING_CONCAT, { s1063,t21061,r1062 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_NO_CONTAINS, { t1064, s1065, r1066 }, nm->mkNode(Kind::STRING_REPLACE, { t1064,s1065,r1066 }), t1064, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1064,s1065 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_FIND_BASE, { t1067, s1068, r1069, tpre1070, tpost1071 }, nm->mkNode(Kind::STRING_REPLACE, { t1067,s1068,r1069 }), nm->mkNode(Kind::STRING_CONCAT, { tpre1070,r1069,tpost1071 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { e1351,e1331 }),nm->mkNode(Kind::EQUAL, { tpre1070,nm->mkNode(Kind::STRING_SUBSTR, { t1067,e1331,e1351 }) }),nm->mkNode(Kind::EQUAL, { tpost1071,nm->mkNode(Kind::STRING_SUBSTR, { t1067,nm->mkNode(Kind::ADD, { e1351,nm->mkNode(Kind::STRING_LENGTH, { s1068 }) }),nm->mkNode(Kind::STRING_LENGTH, { t1067 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_FIND_FIRST_CONCAT, { t1072, ts1073, s1074, r1075, tpre1076, tpost1077 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { t1072,ts1073 }),s1074,r1075 }), nm->mkNode(Kind::STRING_CONCAT, { tpre1076,r1075,tpost1077,ts1073 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GEQ, { e1350,e1331 }),nm->mkNode(Kind::EQUAL, { tpre1076,nm->mkNode(Kind::STRING_SUBSTR, { t1072,e1331,e1350 }) }),nm->mkNode(Kind::EQUAL, { tpost1077,nm->mkNode(Kind::STRING_SUBSTR, { t1072,nm->mkNode(Kind::ADD, { e1350,nm->mkNode(Kind::STRING_LENGTH, { s1074 }) }),nm->mkNode(Kind::STRING_LENGTH, { t1072 }) }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_EMPTY, { t1078, s1079, r1080 }, nm->mkNode(Kind::STRING_REPLACE, { t1078,r1080,s1079 }), nm->mkNode(Kind::STRING_CONCAT, { s1079,t1078 }), nm->mkNode(Kind::EQUAL, { r1080,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { r1080 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_ONE_PRE, { t1081, s1082, r1083, ts1084, ss1085 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { ts1084,t1081,ss1085,t1081 }),s1082,r1083 }), nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { ts1084,t1081,ss1085 }),s1082,r1083 }),t1081 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s1082 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_FIND_PRE, { t1086, r1087, ts1088, ss1089 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { ts1088,t1086,ss1089 }),t1086,r1087 }), nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_CONCAT, { ts1088,t1086 }),t1086,r1087 }),ss1089 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_ALL_NO_CONTAINS, { t1090, s1091, r1092 }, nm->mkNode(Kind::STRING_REPLACE_ALL, { t1090,s1091,r1092 }), t1090, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1090,s1091 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_RE_NONE, { t1093, r1094 }, nm->mkNode(Kind::STRING_REPLACE_RE, { t1093,e1337,r1094 }), t1093, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_RE_ALL_NONE, { t1095, r1096 }, nm->mkNode(Kind::STRING_REPLACE_RE_ALL, { t1095,e1337,r1096 }), t1095, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_CONCAT_REC, { s11097, s21098, s31099 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s11097,s21098,s31099 }) }), nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s21098,s31099 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1323 }),nm->mkNode(Kind::ADD, { nm->mkNode(Kind::STRING_LENGTH, { s11097 }),t1323 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_EQ_ZERO_CONCAT_REC, { s11100, s21101, s31102 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s11100,s21101,s31102 }) }),e1331 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_CONCAT, { s21101,s31102 }) }),e1331 }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1324 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { s11100,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s11100 }) }) }),t1324 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEN_EQ_ZERO_BASE, { s11103 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { s11103 }),e1331 }), nm->mkNode(Kind::EQUAL, { s11103,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s11103 }) }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_SELF, { t1104, n1105 }, nm->mkNode(Kind::STRING_INDEXOF, { t1104,t1104,n1105 }), nm->mkNode(Kind::STRING_INDEXOF, { e1349,e1349,n1105 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_NO_CONTAINS, { t1106, s1107, n1108 }, nm->mkNode(Kind::STRING_INDEXOF, { t1106,s1107,n1108 }), e1346, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t1106,n1108,nm->mkNode(Kind::STRING_LENGTH, { t1106 }) }),s1107 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_OOB, { t1109, s1110, n1111 }, nm->mkNode(Kind::STRING_INDEXOF, { t1109,s1110,n1111 }), e1346, nm->mkNode(Kind::GT, { n1111,nm->mkNode(Kind::STRING_LENGTH, { t1109 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_OOB2, { t1112, s1113, n1114 }, nm->mkNode(Kind::STRING_INDEXOF, { t1112,s1113,n1114 }), e1346, nm->mkNode(Kind::GT, { e1331,n1114 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_CONTAINS_PRE, { t11115, t21116, s1117, n1118 }, nm->mkNode(Kind::STRING_INDEXOF, { nm->mkNode(Kind::STRING_CONCAT, { t11115,t21116 }),s1117,n1118 }), nm->mkNode(Kind::STRING_INDEXOF, { t11115,s1117,n1118 }), nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t11115,n1118,nm->mkNode(Kind::STRING_LENGTH, { t11115 }) }),s1117 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_FIND_EMP, { t1119, emp1120, n1121 }, nm->mkNode(Kind::STRING_INDEXOF, { t1119,emp1120,n1121 }), n1121, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { emp1120,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { t1119 }) }) }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { t1119 }),n1121 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_EQ_IRR, { t1122, s1123, r1124, n1125 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_INDEXOF, { t1122,s1123,n1125 }),nm->mkNode(Kind::STRING_INDEXOF, { r1124,s1123,n1125 }) }), e1332, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_SUBSTR, { t1122,n1125,nm->mkNode(Kind::STRING_LENGTH, { t1122 }) }),nm->mkNode(Kind::STRING_SUBSTR, { r1124,n1125,nm->mkNode(Kind::STRING_LENGTH, { r1124 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_RE_NONE, { t1126, n1127 }, nm->mkNode(Kind::STRING_INDEXOF_RE, { t1126,e1337,n1127 }), e1346, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_INDEXOF_RE_EMP_RE, { t1128, r1129, n1130 }, nm->mkNode(Kind::STRING_INDEXOF_RE, { t1128,r1129,n1130 }), n1130, nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_IN_REGEXP, { e1345,r1129 }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { t1128 }),n1130 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_LOWER_CONCAT, { s11131, s21132, s31133 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s11131,s21132,s31133 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_CONCAT, { s21132,s31133 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1325 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_LOWER, { s11131 }),t1325 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_UPPER_CONCAT, { s11134, s21135, s31136 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s11134,s21135,s31136 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_CONCAT, { s21135,s31136 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1326 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_TO_UPPER, { s11134 }),t1326 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_LOWER_UPPER, { s1137 }, nm->mkNode(Kind::STRING_TO_LOWER, { nm->mkNode(Kind::STRING_TO_UPPER, { s1137 }) }), nm->mkNode(Kind::STRING_TO_LOWER, { s1137 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_UPPER_LOWER, { s1138 }, nm->mkNode(Kind::STRING_TO_UPPER, { nm->mkNode(Kind::STRING_TO_LOWER, { s1138 }) }), nm->mkNode(Kind::STRING_TO_UPPER, { s1138 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_LOWER_LEN, { s1139 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_TO_LOWER, { s1139 }) }), nm->mkNode(Kind::STRING_LENGTH, { s1139 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_UPPER_LEN, { s1140 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_TO_UPPER, { s1140 }) }), nm->mkNode(Kind::STRING_LENGTH, { s1140 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_LOWER_FROM_INT, { n1141 }, nm->mkNode(Kind::STRING_TO_LOWER, { e1348 }), e1348, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_UPPER_FROM_INT, { n1142 }, nm->mkNode(Kind::STRING_TO_UPPER, { e1347 }), e1347, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_TO_INT_CONCAT_NEG_ONE, { s11143, s21144, s31145 }, nm->mkNode(Kind::STRING_STOI, { nm->mkNode(Kind::STRING_CONCAT, { s11143,s21144,s31145 }) }), e1346, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_STOI, { s21144 }),e1346 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_EMPTY, { s1146 }, nm->mkNode(Kind::STRING_LEQ, { e1345,s1146 }), e1332, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_EMPTY_EQ, { s1147 }, nm->mkNode(Kind::STRING_LEQ, { s1147,e1345 }), nm->mkNode(Kind::EQUAL, { s1147,e1345 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_FALSE, { s1148, t11149, s11150, t21151, s21152 }, nm->mkNode(Kind::STRING_LEQ, { nm->mkNode(Kind::STRING_CONCAT, { s1148,t11149,t21151 }),nm->mkNode(Kind::STRING_CONCAT, { s1148,s11150,s21152 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t11149 }),nm->mkNode(Kind::STRING_LENGTH, { s11150 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LEQ, { t11149,s11150 }),e1344 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_TRUE, { s1153, t11154, s11155, t21156, s21157 }, nm->mkNode(Kind::STRING_LEQ, { nm->mkNode(Kind::STRING_CONCAT, { s1153,t11154,t21156 }),nm->mkNode(Kind::STRING_CONCAT, { s1153,s11155,s21157 }) }), e1332, nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t11154 }),nm->mkNode(Kind::STRING_LENGTH, { s11155 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t11154,s11155 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LEQ, { t11154,s11155 }),e1332 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_BASE_1, { t11158, t21159, s1160 }, nm->mkNode(Kind::STRING_LEQ, { nm->mkNode(Kind::STRING_CONCAT, { t11158,t21159 }),s1160 }), nm->mkNode(Kind::STRING_LEQ, { t11158,s1160 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t11158 }),nm->mkNode(Kind::STRING_LENGTH, { s1160 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t11158,s1160 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LEQ_CONCAT_BASE_2, { t1161, s11162, s21163 }, nm->mkNode(Kind::STRING_LEQ, { t1161,nm->mkNode(Kind::STRING_CONCAT, { s11162,s21163 }) }), nm->mkNode(Kind::STRING_LEQ, { t1161,s11162 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { t1161 }),nm->mkNode(Kind::STRING_LENGTH, { s11162 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t1161,s11162 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_LT_ELIM, { s1164, t1165 }, nm->mkNode(Kind::STRING_LT, { s1164,t1165 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1164,t1165 }) }),nm->mkNode(Kind::STRING_LEQ, { s1164,t1165 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_FROM_INT_NO_CTN_NONDIGIT, { n1166, s1167 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_ITOS, { n1166 }),s1167 }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { s1167,e1345 }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_STOI, { s1167 }),e1346 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_CTN_CONTRA, { t1168, s1169, n1170, m1171 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_SUBSTR, { t1168,n1170,m1171 }),s1169 }), e1344, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { t1168,s1169 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_CTN, { s1172, n1173, m1174 }, nm->mkNode(Kind::STRING_CONTAINS, { s1172,nm->mkNode(Kind::STRING_SUBSTR, { s1172,n1173,m1174 }) }), e1332, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_DUAL_CTN, { s1175, t1176, r1177, u1178 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_REPLACE, { s1175,t1176,r1177 }),u1178 }), e1332, nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_CONTAINS, { s1175,u1178 }),nm->mkNode(Kind::STRING_CONTAINS, { r1177,u1178 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_DUAL_CTN_FALSE, { s1179, t1180, r1181, u1182 }, nm->mkNode(Kind::STRING_CONTAINS, { s1179,nm->mkNode(Kind::STRING_REPLACE, { t1180,r1181,u1182 }) }), e1344, nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { s1179,t1180 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { s1179,u1182 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_SELF_CTN_SIMP, { s1183, t1184 }, nm->mkNode(Kind::STRING_CONTAINS, { s1183,nm->mkNode(Kind::STRING_REPLACE, { t1184,s1183,t1184 }) }), nm->mkNode(Kind::STRING_CONTAINS, { s1183,t1184 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPLACE_EMP_CTN_SRC, { s1185, t1186, emp1187 }, nm->mkNode(Kind::STRING_CONTAINS, { s1185,e1343 }), nm->mkNode(Kind::EQUAL, { emp1187,e1343 }), nm->mkNode(Kind::EQUAL, { emp1187,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { s1185 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_CHAR_START_EQ_LEN, { x1188, n1189 }, nm->mkNode(Kind::STRING_SUBSTR, { x1188,n1189,n1189 }), nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1188 }) }), nm->mkNode(Kind::GEQ, { e1333,nm->mkNode(Kind::STRING_LENGTH, { x1188 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_REPL_CHAR, { x1190, y1191, z1192, w1193 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_REPLACE, { x1190,y1191,z1192 }),w1193 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_CONTAINS, { x1190,w1193 }),nm->mkNode(Kind::AND, { nm->mkNode(Kind::STRING_CONTAINS, { x1190,y1191 }),nm->mkNode(Kind::STRING_CONTAINS, { z1192,w1193 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { w1193 }),e1333 }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { w1193,y1191 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_REPL_SELF_TGT_CHAR, { x1194, y1195, w1196 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_REPLACE, { x1194,y1195,x1194 }),w1196 }), nm->mkNode(Kind::STRING_CONTAINS, { x1194,w1196 }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { w1196 }),e1333 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_REPL_SELF, { x1197, y1198 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_REPLACE, { x1197,y1198,x1197 }),y1198 }), nm->mkNode(Kind::STRING_CONTAINS, { x1197,y1198 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_CONTAINS_REPL_TGT, { x1199, y1200, z1201 }, nm->mkNode(Kind::STRING_CONTAINS, { nm->mkNode(Kind::STRING_REPLACE, { x1199,y1200,z1201 }),z1201 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::STRING_CONTAINS, { x1199,y1200 }),nm->mkNode(Kind::STRING_CONTAINS, { x1199,z1201 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_LEN_ID, { x1202, y1203 }, nm->mkNode(Kind::STRING_REPLACE, { x1202,y1203,x1202 }), x1202, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { y1203 }),nm->mkNode(Kind::STRING_LENGTH, { x1202 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_SRC_TGT_NO_CTN, { x1204, y1205, z1206, w1207 }, nm->mkNode(Kind::STRING_REPLACE, { x1204,w1207,nm->mkNode(Kind::STRING_REPLACE, { z1206,x1204,y1205 }) }), nm->mkNode(Kind::STRING_REPLACE, { x1204,w1207,z1206 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { z1206,w1207 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_TGT_SELF, { x1208, y1209 }, nm->mkNode(Kind::STRING_REPLACE, { x1208,y1209,nm->mkNode(Kind::STRING_REPLACE, { y1209,x1208,y1209 }) }), x1208, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_TGT_NO_CTN, { x1210, y1211, z1212, w1213 }, nm->mkNode(Kind::STRING_REPLACE, { x1210,y1211,nm->mkNode(Kind::STRING_REPLACE, { y1211,z1212,w1213 }) }), x1210, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { x1210,z1212 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_SRC_SELF, { x1214, y1215, z1216 }, nm->mkNode(Kind::STRING_REPLACE, { x1214,nm->mkNode(Kind::STRING_REPLACE, { y1215,x1214,y1215 }),z1216 }), nm->mkNode(Kind::STRING_REPLACE, { x1214,y1215,z1216 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_SRC_INV_NO_CTN1, { x1217, y1218, z1219 }, nm->mkNode(Kind::STRING_REPLACE, { x1217,nm->mkNode(Kind::STRING_REPLACE, { y1218,x1217,z1219 }),y1218 }), nm->mkNode(Kind::STRING_REPLACE, { x1217,y1218,y1218 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { y1218,z1219 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_SRC_INV_NO_CTN2, { x1220, y1221, z1222 }, nm->mkNode(Kind::STRING_REPLACE, { x1220,nm->mkNode(Kind::STRING_REPLACE, { y1221,x1220,z1222 }),x1220 }), nm->mkNode(Kind::STRING_REPLACE, { x1220,y1221,x1220 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { y1221,z1222 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_SRC_INV_NO_CTN3, { x1223, y1224, z1225, w1226, u1227 }, nm->mkNode(Kind::STRING_REPLACE, { x1223,nm->mkNode(Kind::STRING_REPLACE, { y1224,z1225,w1226 }),u1227 }), nm->mkNode(Kind::STRING_REPLACE, { x1223,y1224,u1227 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { x1223,z1225 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { x1223,w1226 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_DUAL_SELF, { x1228, y1229 }, nm->mkNode(Kind::STRING_REPLACE, { x1228,nm->mkNode(Kind::STRING_REPLACE, { x1228,y1229,x1228 }),x1228 }), x1228, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_DUAL_ITE1, { x1230, y1231, z1232, w1233 }, nm->mkNode(Kind::STRING_REPLACE, { x1230,nm->mkNode(Kind::STRING_REPLACE, { x1230,y1231,z1232 }),w1233 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::STRING_CONTAINS, { x1230,y1231 }),x1230,w1233 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { x1230,z1232 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_DUAL_ITE2, { x1234, y1235, z1236, w1237 }, nm->mkNode(Kind::STRING_REPLACE, { x1234,nm->mkNode(Kind::STRING_REPLACE, { x1234,y1235,z1236 }),w1237 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::STRING_CONTAINS, { x1234,y1235 }),x1234,w1237 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { y1235,z1236 }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { z1236,y1235 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_REPL_REPL_LOOKAHEAD_ID_SIMP, { y1238, z1239, w1240 }, nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_REPLACE, { y1238,w1240,y1238 }),y1238,z1239 }), nm->mkNode(Kind::STRING_REPLACE, { nm->mkNode(Kind::STRING_REPLACE, { y1238,w1240,z1239 }),y1238,z1239 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { w1240,z1239 }) }),nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { w1240 }),nm->mkNode(Kind::STRING_LENGTH, { z1239 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_ALL_ELIM, {  }, nm->mkNode(Kind::REGEXP_ALL, {  }), e1340, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_OPT_ELIM, { x1241 }, nm->mkNode(Kind::REGEXP_OPT, { x1241 }), nm->mkNode(Kind::REGEXP_UNION, { e1339,x1241 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_DIFF_ELIM, { x1242, y1243 }, nm->mkNode(Kind::REGEXP_DIFF, { x1242,y1243 }), nm->mkNode(Kind::REGEXP_INTER, { x1242,nm->mkNode(Kind::REGEXP_COMPLEMENT, { y1243 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_PLUS_ELIM, { x1244 }, nm->mkNode(Kind::REGEXP_PLUS, { x1244 }), nm->mkNode(Kind::REGEXP_CONCAT, { x1244,nm->mkNode(Kind::REGEXP_STAR, { x1244 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_SWAP, { xs1245, r1246, ys1247 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1245,e1342,r1246,ys1247 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1245,r1246,e1342,ys1247 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_REPEAT, { xs1248, r1249, ys1250 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1248,e1341,e1341,ys1250 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1248,e1341,ys1250 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_SUBSUME1, { xs1251, r1252, ys1253 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1251,nm->mkNode(Kind::REGEXP_STAR, { r1252 }),e1340,ys1253 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1251,e1340,ys1253 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_CONCAT_STAR_SUBSUME2, { xs1254, r1255, ys1256 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1254,e1340,nm->mkNode(Kind::REGEXP_STAR, { r1255 }),ys1256 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1254,e1340,ys1256 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_CONCAT_MERGE, { xs1257, s1258, t1259, ys1260 }, nm->mkNode(Kind::REGEXP_CONCAT, { xs1257,nm->mkNode(Kind::STRING_TO_REGEXP, { s1258 }),nm->mkNode(Kind::STRING_TO_REGEXP, { t1259 }),ys1260 }), nm->mkNode(Kind::REGEXP_CONCAT, { xs1257,nm->mkNode(Kind::STRING_TO_REGEXP, { nm->mkNode(Kind::STRING_CONCAT, { s1258,t1259 }) }),ys1260 }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1327 }),t1327 }), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_UNION_ALL, { xs1261, ys1262 }, nm->mkNode(Kind::REGEXP_UNION, { xs1261,e1340,ys1262 }), e1340, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_UNION_CONST_ELIM, { r1263, s1264 }, nm->mkNode(Kind::REGEXP_UNION, { nm->mkNode(Kind::STRING_TO_REGEXP, { s1264 }),r1263 }), r1263, nm->mkNode(Kind::STRING_IN_REGEXP, { s1264,r1263 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_INTER_ALL, { xs1265, ys1266 }, nm->mkNode(Kind::REGEXP_INTER, { xs1265,e1340,ys1266 }), nm->mkNode(Kind::REGEXP_INTER, { xs1265,ys1266 }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1328 }),t1328 }), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_STAR_NONE, {  }, nm->mkNode(Kind::REGEXP_STAR, { e1337 }), e1339, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_STAR_EMP, {  }, nm->mkNode(Kind::REGEXP_STAR, { e1339 }), e1339, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_STAR_STAR, { x1267 }, nm->mkNode(Kind::REGEXP_STAR, { e1338 }), e1338, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_STAR_UNION_DROP_EMP, { x1268, y1269 }, nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_UNION, { x1268,e1339,y1269 }) }), nm->mkNode(Kind::REGEXP_STAR, { nm->mkNode(Kind::REGEXP_UNION, { x1268,y1269 }) }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_LOOP_NEG, { n1270, m1271, r1272 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::REGEXP_LOOP)),n1270,m1271,r1272 }), e1337, nm->mkNode(Kind::GT, { n1270,m1271 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_INTER_CSTRING, { xs1273, ys1274, s1275 }, nm->mkNode(Kind::REGEXP_INTER, { xs1273,e1336,ys1274 }), e1336, nm->mkNode(Kind::STRING_IN_REGEXP, { s1275,nm->mkNode(Kind::REGEXP_INTER, { xs1273,ys1274 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::RE_INTER_CSTRING_NEG, { xs1276, ys1277, s1278 }, nm->mkNode(Kind::REGEXP_INTER, { xs1276,nm->mkNode(Kind::STRING_TO_REGEXP, { s1278 }),ys1277 }), e1337, nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_IN_REGEXP, { s1278,nm->mkNode(Kind::REGEXP_INTER, { xs1276,ys1277 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE, { s11279, s21280, n1281, m1282 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11279,s21280 }),n1281,m1282 }), nm->mkNode(Kind::STRING_SUBSTR, { s11279,n1281,m1282 }), nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::STRING_LENGTH, { s11279 }),nm->mkNode(Kind::ADD, { n1281,m1282 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_INCLUDE_PRE, { s11283, s21284, s31285, n1286 }, nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s11283,s21284,s31285 }),e1331,n1286 }), nm->mkNode(Kind::STRING_CONCAT, { s11283,nm->mkNode(Kind::STRING_SUBSTR, { nm->mkNode(Kind::STRING_CONCAT, { s21284,s31285 }),e1331,nm->mkNode(Kind::SUB, { n1286,e1335 }) }) }), nm->mkNode(Kind::GEQ, { n1286,e1335 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_SUBSTR_LEN_NORM, { s1287, n1288, m1289 }, nm->mkNode(Kind::STRING_SUBSTR, { s1287,n1288,m1289 }), nm->mkNode(Kind::STRING_SUBSTR, { s1287,n1288,e1334 }), nm->mkNode(Kind::GEQ, { m1289,e1334 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_LEN_REV, { x1290 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::STRING_REV, { x1290 }) }), nm->mkNode(Kind::STRING_LENGTH, { x1290 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_REV_REV, { x1291 }, nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_REV, { x1291 }) }), x1291, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_REV_CONCAT, { x1292, y1293, z1294 }, nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1292,y1293,z1294 }) }), nm->mkNode(Kind::STRING_REV, { nm->mkNode(Kind::STRING_CONCAT, { x1292,y1293 }) }), e1332, nm->mkNode(Kind::LAMBDA, { nm->mkNode(Kind::BOUND_VAR_LIST, { t1329 }),nm->mkNode(Kind::STRING_CONCAT, { nm->mkNode(Kind::STRING_REV, { z1294 }),t1329 }) }), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_SELF_EMP, { x1295, y1296, emp1297 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1295,y1296,x1295 }),emp1297 }), nm->mkNode(Kind::EQUAL, { x1295,emp1297 }), nm->mkNode(Kind::EQUAL, { emp1297,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1295 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_NO_CHANGE, { x1298, y1299, z1300 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1298,y1299,z1300 }),x1298 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::STRING_CONTAINS, { x1298,y1299 }) }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { y1299,z1300 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_TGT_EQ_LEN, { x1301, y1302, z1303 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1301,y1302,z1303 }),z1303 }), nm->mkNode(Kind::OR, { nm->mkNode(Kind::EQUAL, { x1301,y1302 }),nm->mkNode(Kind::EQUAL, { x1301,z1303 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { y1302 }),nm->mkNode(Kind::STRING_LENGTH, { z1303 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_LEN_ONE_EMP_PREFIX, { x1304, y1305, emp1306 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1304,y1305,emp1306 }),emp1306 }), nm->mkNode(Kind::STRING_PREFIX, { x1304,y1305 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { emp1306,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1304 }) }) }),nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_LENGTH, { y1305 }),e1333 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_EMP_TGT_NEMP, { x1307, y1308, z1309, emp1310 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1307,y1308,z1309 }),emp1310 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x1307,emp1310 }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { y1308,emp1310 }) }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { emp1310,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1307 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { z1309,emp1310 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_NEMP_SRC_EMP, { x1311, y1312, z1313, emp1314 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { emp1314,x1311,y1312 }),z1313 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { x1311,emp1314 }),nm->mkNode(Kind::EQUAL, { y1312,z1313 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { emp1314,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1311 }) }) }),nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { z1313,emp1314 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::STR_EQ_REPL_SELF_SRC, { x1315, y1316 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::STRING_REPLACE, { x1315,y1316,x1315 }),y1316 }), nm->mkNode(Kind::EQUAL, { x1315,y1316 }), e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_LEN_UNIT, { x1317 }, nm->mkNode(Kind::STRING_LENGTH, { nm->mkNode(Kind::SEQ_UNIT, { x1317 }) }), e1333, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_NTH_UNIT, { x1318 }, nm->mkNode(Kind::SEQ_NTH, { nm->mkNode(Kind::SEQ_UNIT, { x1318 }),e1331 }), x1318, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_REV_UNIT, { x1319 }, nm->mkNode(Kind::STRING_REV, { e1330 }), e1330, e1332, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::SEQ_LEN_EMPTY, { x1320 }, nm->mkNode(Kind::STRING_LENGTH, { x1320 }), e1331, nm->mkNode(Kind::EQUAL, { x1320,nm->mkNode(Kind::SEQ_EMPTY_OF_TYPE, { nm->mkNode(Kind::TYPE_OF, { x1320 }) }) }), Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
