/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_uf_rewrites(NodeManager* nm, RewriteDb& db)
{
  // Variables
  Node t1392 = NodeManager::mkBoundVar("t1392", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1393 = NodeManager::mkBoundVar("t1393", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1394 = NodeManager::mkBoundVar("s1394", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1395 = NodeManager::mkBoundVar("t1395", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1396 = NodeManager::mkBoundVar("s1396", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r1397 = NodeManager::mkBoundVar("r1397", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node C1398 = NodeManager::mkBoundVar("C1398", nm->booleanType());
Node t1399 = NodeManager::mkBoundVar("t1399", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1400 = NodeManager::mkBoundVar("s1400", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node r1401 = NodeManager::mkBoundVar("r1401", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node t1402 = NodeManager::mkBoundVar("t1402", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node s1403 = NodeManager::mkBoundVar("s1403", nm->mkAbstractType(Kind::ABSTRACT_TYPE));
Node w1404 = NodeManager::mkBoundVar("w1404", nm->integerType());
Node t1405 = NodeManager::mkBoundVar("t1405", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node w1406 = NodeManager::mkBoundVar("w1406", nm->integerType());
Node t1407 = NodeManager::mkBoundVar("t1407", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n1408 = NodeManager::mkBoundVar("n1408", nm->integerType());
Node w1409 = NodeManager::mkBoundVar("w1409", nm->integerType());
Node t1410 = NodeManager::mkBoundVar("t1410", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node wm11411 = NodeManager::mkBoundVar("wm11411", nm->integerType());
Node w1412 = NodeManager::mkBoundVar("w1412", nm->integerType());
Node t1413 = NodeManager::mkBoundVar("t1413", nm->integerType());
Node x1414 = NodeManager::mkBoundVar("x1414", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node n1415 = NodeManager::mkBoundVar("n1415", nm->integerType());
Node w1416 = NodeManager::mkBoundVar("w1416", nm->integerType());
Node t1417 = NodeManager::mkBoundVar("t1417", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node s1418 = NodeManager::mkBoundVar("s1418", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1419 = NodeManager::mkBoundVar("t1419", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node s1420 = NodeManager::mkBoundVar("s1420", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node t1421 = NodeManager::mkBoundVar("t1421", nm->mkAbstractType(Kind::BITVECTOR_TYPE));
Node wm11422 = NodeManager::mkBoundVar("wm11422", nm->integerType());
Node n1423 = NodeManager::mkBoundVar("n1423", nm->integerType());

  // Definitions
Node e1424 = nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1421 });
Node e1425 = nm->mkConstInt(Rational(1));
Node e1426 = nm->mkNode(Kind::BITVECTOR_SIZE, { t1421 });
Node e1427 = nm->mkConst(true);
Node e1428 = nm->mkConstInt(Rational(0));
Node e1429 = nm->mkNode(Kind::BITVECTOR_SIZE, { t1407 });
Node e1430 = nm->mkNode(Kind::EQUAL, { t1395,r1397 });
Node e1431 = nm->mkNode(Kind::EQUAL, { t1395,s1396 });
Node e1432 = nm->mkConst(false);

  // Rules

        {
            // from rewrites-uf-rewrites.cpp
            db.addRule(ProofRewriteRule::EQ_REFL, { t1392 }, nm->mkNode(Kind::EQUAL, { t1392,t1392 }), e1427, e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::EQ_SYMM, { t1393, s1394 }, nm->mkNode(Kind::EQUAL, { t1393,s1394 }), nm->mkNode(Kind::EQUAL, { s1394,t1393 }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::EQ_COND_DEQ, { t1395, s1396, r1397 }, nm->mkNode(Kind::EQUAL, { e1431,e1430 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::NOT, { e1431 }),nm->mkNode(Kind::NOT, { e1430 }) }), nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::EQUAL, { s1396,r1397 }),e1432 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::EQ_ITE_LIFT, { C1398, t1399, s1400, r1401 }, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::ITE, { C1398,t1399,s1400 }),r1401 }), nm->mkNode(Kind::ITE, { C1398,nm->mkNode(Kind::EQUAL, { t1399,r1401 }),nm->mkNode(Kind::EQUAL, { s1400,r1401 }) }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::DISTINCT_BINARY_ELIM, { t1402, s1403 }, nm->mkNode(Kind::DISTINCT, { t1402,s1403 }), nm->mkNode(Kind::NOT, { nm->mkNode(Kind::EQUAL, { t1402,s1403 }) }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV, { w1404, t1405 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1404,nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1405 }) }), t1405, nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::BITVECTOR_SIZE, { t1405 }),w1404 }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV_EXTEND, { w1406, t1407, n1408 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1406,nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1407 }) }), nm->mkNode(Kind::BITVECTOR_CONCAT, { nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e1428,n1408 }),t1407 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::GT, { w1406,e1429 }),nm->mkNode(Kind::EQUAL, { n1408,nm->mkNode(Kind::SUB, { w1406,e1429 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_BV2NAT_INT2BV_EXTRACT, { w1409, t1410, wm11411 }, nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1409,nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1410 }) }), nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm11411,e1428,t1410 }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::LT, { w1409,nm->mkNode(Kind::BITVECTOR_SIZE, { t1410 }) }),nm->mkNode(Kind::EQUAL, { wm11411,nm->mkNode(Kind::SUB, { w1409,e1425 }) }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_INT2BV_BV2NAT, { w1412, t1413 }, nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1412,t1413 }) }), nm->mkNode(Kind::INTS_MODULUS_TOTAL, { t1413,nm->mkNode(Kind::POW2, { w1412 }) }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_BV2NAT_GEQ_ELIM, { x1414, n1415, w1416 }, nm->mkNode(Kind::GEQ, { nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { x1414 }),n1415 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::GEQ, { n1415,w1416 }),e1432,nm->mkNode(Kind::ITE, { nm->mkNode(Kind::LT, { n1415,e1428 }),e1427,nm->mkNode(Kind::BITVECTOR_UGE, { x1414,nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::INT_TO_BITVECTOR)),w1416,n1415 }) }) }) }), nm->mkNode(Kind::EQUAL, { w1416,nm->mkNode(Kind::BITVECTOR_SIZE, { x1414 }) }), Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_INT2BV_BVULT_EQUIV, { t1417, s1418 }, nm->mkNode(Kind::BITVECTOR_ULT, { t1417,s1418 }), nm->mkNode(Kind::LT, { nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1417 }),nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { s1418 }) }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_INT2BV_BVULE_EQUIV, { t1419, s1420 }, nm->mkNode(Kind::BITVECTOR_ULE, { t1419,s1420 }), nm->mkNode(Kind::LEQ, { nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { t1419 }),nm->mkNode(Kind::BITVECTOR_UBV_TO_INT, { s1420 }) }), e1427, Node::null(), Level::NORMAL);
db.addRule(ProofRewriteRule::UF_SBV_TO_INT_ELIM, { t1421, wm11422, n1423 }, nm->mkNode(Kind::BITVECTOR_SBV_TO_INT, { t1421 }), nm->mkNode(Kind::ITE, { nm->mkNode(Kind::EQUAL, { nm->mkNode(Kind::APPLY_INDEXED_SYMBOLIC, { nm->mkConst(GenericOp(Kind::BITVECTOR_EXTRACT)),wm11422,wm11422,t1421 }),nm->mkNode(Kind::CONST_BITVECTOR_SYMBOLIC, { e1428,e1425 }) }),e1424,nm->mkNode(Kind::SUB, { e1424,n1423 }) }), nm->mkNode(Kind::AND, { nm->mkNode(Kind::EQUAL, { wm11422,nm->mkNode(Kind::SUB, { e1426,e1425 }) }),nm->mkNode(Kind::EQUAL, { n1423,nm->mkNode(Kind::POW2, { e1426 }) }) }), Node::null(), Level::NORMAL);
        }
    
  }

}  // namespace rewriter
}  // namespace cvc5::internal
