/******************************************************************************
 * Top contributors (to current version):
 *   Andrew Reynolds, Leni Aniva, Daniel Larraz
 *
 * This file is part of the cvc5 project.
 *
 * Copyright (c) 2009-2025 by the authors listed in the file AUTHORS
 * in the top-level source directory and their institutional affiliations.
 * All rights reserved.  See the file COPYING in the top-level source
 * directory for licensing information.
 * ****************************************************************************
 *
 * Generated rewrites
 */

#include "expr/node.h"
#include "expr/node_manager.h"
#include "proof/proof_checker.h"
#include "rewriter/rewrite_db.h"
#include "rewriter/rewrites.h"
#include "theory/builtin/generic_op.h"
#include "util/string.h"

using namespace cvc5::internal::kind;

namespace cvc5::internal {
namespace rewriter {

void addRewrites_arith_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_arrays_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_booleans_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_builtin_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_bv_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_bv_rewrites_elimination(NodeManager* nm, RewriteDb&);
void addRewrites_bv_rewrites_simplification(NodeManager* nm, RewriteDb&);
void addRewrites_sets_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_strings_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_strings_rewrites_regexp_membership(NodeManager* nm, RewriteDb&);
void addRewrites_uf_rewrites(NodeManager* nm, RewriteDb&);
void addRewrites_arith_rewrites_transcendentals(NodeManager* nm, RewriteDb&);
void addRewrites_sets_rewrites_card(NodeManager* nm, RewriteDb&);
    
    void
    addRules(NodeManager* nm, RewriteDb& db){
        // Calls to individual rewrites
          addRewrites_arith_rewrites(nm, db);
addRewrites_arrays_rewrites(nm, db);
addRewrites_booleans_rewrites(nm, db);
addRewrites_builtin_rewrites(nm, db);
addRewrites_bv_rewrites(nm, db);
addRewrites_bv_rewrites_elimination(nm, db);
addRewrites_bv_rewrites_simplification(nm, db);
addRewrites_sets_rewrites(nm, db);
addRewrites_strings_rewrites(nm, db);
addRewrites_strings_rewrites_regexp_membership(nm, db);
addRewrites_uf_rewrites(nm, db);
addRewrites_arith_rewrites_transcendentals(nm, db);
addRewrites_sets_rewrites_card(nm, db);
            }

Node mkRewriteRuleNode(NodeManager* nm, ProofRewriteRule rule)
{
  return nm->mkConstInt(Rational(static_cast<uint32_t>(rule)));
}

bool getRewriteRule(TNode n, ProofRewriteRule& rule)
{
  uint32_t index;
  if (!ProofRuleChecker::getUInt32(n, index))
  {
    return false;
  }
  rule = static_cast<ProofRewriteRule>(index);
  return true;
}

}  // namespace rewriter
}  // namespace cvc5::internal
